"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from onshape_client.oas.model.bt_app_associative_data_array_info import BTAppAssociativeDataArrayInfo
from onshape_client.oas.model.bt_app_element_basic_info import BTAppElementBasicInfo
from onshape_client.oas.model.bt_app_element_params_array_bt_copy_view_associative_data_params import BTAppElementParamsArrayBTCopyViewAssociativeDataParams


class AppAssociativeDataApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.copy_associative_data_endpoint = _Endpoint(
            settings={
                'response_type': (BTAppAssociativeDataArrayInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/appelements/d/{did}/w/{wid}/e/{eid}/copyassociativedata',
                'operation_id': 'copy_associative_data',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wid',
                    'eid',
                    'bt_app_element_params_array_bt_copy_view_associative_data_params',
                ],
                'required': [
                    'did',
                    'wid',
                    'eid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wid':
                        (str,),
                    'eid':
                        (str,),
                    'bt_app_element_params_array_bt_copy_view_associative_data_params':
                        (BTAppElementParamsArrayBTCopyViewAssociativeDataParams,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wid': 'wid',
                    'eid': 'eid',
                },
                'location_map': {
                    'did': 'path',
                    'wid': 'path',
                    'eid': 'path',
                    'bt_app_element_params_array_bt_copy_view_associative_data_params': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.delete_associative_data_endpoint = _Endpoint(
            settings={
                'response_type': (BTAppElementBasicInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/appelements/d/{did}/{wvm}/{wvmid}/e/{eid}/associativedata',
                'operation_id': 'delete_associative_data',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'eid',
                    'wvm',
                    'wvmid',
                    'transaction_id',
                    'parent_change_id',
                    'associative_data_id',
                    'element_id',
                    'view_id',
                    'microversion_id',
                    'document_microversion',
                    'deterministic_id',
                    'feature_id',
                    'entity_id',
                    'occurrence_id',
                ],
                'required': [
                    'did',
                    'eid',
                    'wvm',
                    'wvmid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'eid':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'transaction_id':
                        (str,),
                    'parent_change_id':
                        (str,),
                    'associative_data_id':
                        ([str],),
                    'element_id':
                        (str,),
                    'view_id':
                        (str,),
                    'microversion_id':
                        (str,),
                    'document_microversion':
                        (str,),
                    'deterministic_id':
                        (str,),
                    'feature_id':
                        (str,),
                    'entity_id':
                        (str,),
                    'occurrence_id':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'eid': 'eid',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'transaction_id': 'transactionId',
                    'parent_change_id': 'parentChangeId',
                    'associative_data_id': 'associativeDataId',
                    'element_id': 'elementId',
                    'view_id': 'viewId',
                    'microversion_id': 'microversionId',
                    'document_microversion': 'documentMicroversion',
                    'deterministic_id': 'deterministicId',
                    'feature_id': 'featureId',
                    'entity_id': 'entityId',
                    'occurrence_id': 'occurrenceId',
                },
                'location_map': {
                    'did': 'path',
                    'eid': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'transaction_id': 'query',
                    'parent_change_id': 'query',
                    'associative_data_id': 'query',
                    'element_id': 'query',
                    'view_id': 'query',
                    'microversion_id': 'query',
                    'document_microversion': 'query',
                    'deterministic_id': 'query',
                    'feature_id': 'query',
                    'entity_id': 'query',
                    'occurrence_id': 'query',
                },
                'collection_format_map': {
                    'associative_data_id': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_associative_data_endpoint = _Endpoint(
            settings={
                'response_type': (BTAppAssociativeDataArrayInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/appelements/d/{did}/{wvm}/{wvmid}/e/{eid}/associativedata',
                'operation_id': 'get_associative_data',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'transaction_id',
                    'change_id',
                    'associative_data_id',
                    'element_id',
                    'view_id',
                    'microversion_id',
                    'document_microversion',
                    'deterministic_id',
                    'feature_id',
                    'entity_id',
                    'occurrence_id',
                    'return_id_tags',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'transaction_id':
                        (str,),
                    'change_id':
                        (str,),
                    'associative_data_id':
                        ([str],),
                    'element_id':
                        (str,),
                    'view_id':
                        (str,),
                    'microversion_id':
                        (str,),
                    'document_microversion':
                        (str,),
                    'deterministic_id':
                        (str,),
                    'feature_id':
                        (str,),
                    'entity_id':
                        (str,),
                    'occurrence_id':
                        (str,),
                    'return_id_tags':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'transaction_id': 'transactionId',
                    'change_id': 'changeId',
                    'associative_data_id': 'associativeDataId',
                    'element_id': 'elementId',
                    'view_id': 'viewId',
                    'microversion_id': 'microversionId',
                    'document_microversion': 'documentMicroversion',
                    'deterministic_id': 'deterministicId',
                    'feature_id': 'featureId',
                    'entity_id': 'entityId',
                    'occurrence_id': 'occurrenceId',
                    'return_id_tags': 'returnIdTags',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'transaction_id': 'query',
                    'change_id': 'query',
                    'associative_data_id': 'query',
                    'element_id': 'query',
                    'view_id': 'query',
                    'microversion_id': 'query',
                    'document_microversion': 'query',
                    'deterministic_id': 'query',
                    'feature_id': 'query',
                    'entity_id': 'query',
                    'occurrence_id': 'query',
                    'return_id_tags': 'query',
                },
                'collection_format_map': {
                    'associative_data_id': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.post_associative_data_endpoint = _Endpoint(
            settings={
                'response_type': (BTAppAssociativeDataArrayInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/appelements/d/{did}/{wvm}/{wvmid}/e/{eid}/associativedata',
                'operation_id': 'post_associative_data',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'eid',
                    'wvm',
                    'wvmid',
                    'body',
                ],
                'required': [
                    'did',
                    'eid',
                    'wvm',
                    'wvmid',
                    'body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'eid':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'body':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'eid': 'eid',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                },
                'location_map': {
                    'did': 'path',
                    'eid': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )

    def copy_associative_data(
        self,
        did,
        wid,
        eid,
        **kwargs
    ):
        """Copy associative data between sub-views inside this application tab. Useful if the application has multiple sub-components; for example, Drawing views.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.copy_associative_data(did, wid, eid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wid (str):
            eid (str):

        Keyword Args:
            bt_app_element_params_array_bt_copy_view_associative_data_params (BTAppElementParamsArrayBTCopyViewAssociativeDataParams): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTAppAssociativeDataArrayInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wid'] = \
            wid
        kwargs['eid'] = \
            eid
        return self.copy_associative_data_endpoint.call_with_http_info(**kwargs)

    def delete_associative_data(
        self,
        did,
        eid,
        wvm,
        wvmid,
        **kwargs
    ):
        """Delete associative data for this application tab  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_associative_data(did, eid, wvm, wvmid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            eid (str):
            wvm (str):
            wvmid (str):

        Keyword Args:
            transaction_id (str): [optional] if omitted the server will use the default value of ""
            parent_change_id (str): [optional] if omitted the server will use the default value of ""
            associative_data_id ([str]): [optional]
            element_id (str): [optional] if omitted the server will use the default value of ""
            view_id (str): [optional] if omitted the server will use the default value of ""
            microversion_id (str): [optional] if omitted the server will use the default value of ""
            document_microversion (str): [optional] if omitted the server will use the default value of ""
            deterministic_id (str): [optional] if omitted the server will use the default value of ""
            feature_id (str): [optional] if omitted the server will use the default value of ""
            entity_id (str): [optional] if omitted the server will use the default value of ""
            occurrence_id (str): [optional] if omitted the server will use the default value of ""
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTAppElementBasicInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['eid'] = \
            eid
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        return self.delete_associative_data_endpoint.call_with_http_info(**kwargs)

    def get_associative_data(
        self,
        did,
        wvm,
        wvmid,
        eid,
        **kwargs
    ):
        """Retrieve associative data for this application tab  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_associative_data(did, wvm, wvmid, eid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):

        Keyword Args:
            transaction_id (str): [optional] if omitted the server will use the default value of ""
            change_id (str): [optional] if omitted the server will use the default value of ""
            associative_data_id ([str]): [optional]
            element_id (str): [optional] if omitted the server will use the default value of ""
            view_id (str): [optional] if omitted the server will use the default value of ""
            microversion_id (str): [optional] if omitted the server will use the default value of ""
            document_microversion (str): [optional] if omitted the server will use the default value of ""
            deterministic_id (str): [optional] if omitted the server will use the default value of ""
            feature_id (str): [optional] if omitted the server will use the default value of ""
            entity_id (str): [optional] if omitted the server will use the default value of ""
            occurrence_id (str): [optional] if omitted the server will use the default value of ""
            return_id_tags (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTAppAssociativeDataArrayInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        return self.get_associative_data_endpoint.call_with_http_info(**kwargs)

    def post_associative_data(
        self,
        did,
        eid,
        wvm,
        wvmid,
        body,
        **kwargs
    ):
        """Create or update associative data for this application tab  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.post_associative_data(did, eid, wvm, wvmid, body, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            eid (str):
            wvm (str):
            wvmid (str):
            body (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTAppAssociativeDataArrayInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['eid'] = \
            eid
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['body'] = \
            body
        return self.post_associative_data_endpoint.call_with_http_info(**kwargs)

