"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from onshape_client.oas.model.bt_document_element_processing_info import BTDocumentElementProcessingInfo
from onshape_client.oas.model.bt_translate_format_params import BTTranslateFormatParams
from onshape_client.oas.model.bt_translation_request_info import BTTranslationRequestInfo
from onshape_client.oas.model.bt_update_mesh_units_params import BTUpdateMeshUnitsParams


class BlobElementApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_blob_translation_endpoint = _Endpoint(
            settings={
                'response_type': (BTTranslationRequestInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/blobelements/d/{did}/{wv}/{wvid}/e/{eid}/translations',
                'operation_id': 'create_blob_translation',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'bt_translate_format_params',
                ],
                'required': [
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'bt_translate_format_params',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wv':
                        (str,),
                    'wvid':
                        (str,),
                    'eid':
                        (str,),
                    'bt_translate_format_params':
                        (BTTranslateFormatParams,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wv': 'wv',
                    'wvid': 'wvid',
                    'eid': 'eid',
                },
                'location_map': {
                    'did': 'path',
                    'wv': 'path',
                    'wvid': 'path',
                    'eid': 'path',
                    'bt_translate_format_params': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.download_file_workspace_endpoint = _Endpoint(
            settings={
                'response_type': (file_type,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/blobelements/d/{did}/w/{wid}/e/{eid}',
                'operation_id': 'download_file_workspace',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wid',
                    'eid',
                    'content_disposition',
                    'if_none_match',
                    'link_document_id',
                ],
                'required': [
                    'did',
                    'wid',
                    'eid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wid':
                        (str,),
                    'eid':
                        (str,),
                    'content_disposition':
                        (str,),
                    'if_none_match':
                        (str,),
                    'link_document_id':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wid': 'wid',
                    'eid': 'eid',
                    'content_disposition': 'contentDisposition',
                    'if_none_match': 'If-None-Match',
                    'link_document_id': 'linkDocumentId',
                },
                'location_map': {
                    'did': 'path',
                    'wid': 'path',
                    'eid': 'path',
                    'content_disposition': 'query',
                    'if_none_match': 'header',
                    'link_document_id': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v1+octet-stream;charset=UTF-8;qs=0.1'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_units_endpoint = _Endpoint(
            settings={
                'response_type': (BTDocumentElementProcessingInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/blobelements/d/{did}/w/{wid}/e/{eid}/units',
                'operation_id': 'update_units',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'eid',
                    'wid',
                    'bt_update_mesh_units_params',
                ],
                'required': [
                    'did',
                    'eid',
                    'wid',
                    'bt_update_mesh_units_params',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'eid':
                        (str,),
                    'wid':
                        (str,),
                    'bt_update_mesh_units_params':
                        (BTUpdateMeshUnitsParams,),
                },
                'attribute_map': {
                    'did': 'did',
                    'eid': 'eid',
                    'wid': 'wid',
                },
                'location_map': {
                    'did': 'path',
                    'eid': 'path',
                    'wid': 'path',
                    'bt_update_mesh_units_params': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.upload_file_create_element_endpoint = _Endpoint(
            settings={
                'response_type': (BTDocumentElementProcessingInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/blobelements/d/{did}/w/{wid}',
                'operation_id': 'upload_file_create_element',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wid',
                    'file',
                    'allow_faulty_parts',
                    'create_composite',
                    'create_drawing_if_possible',
                    'encoded_filename',
                    'extract_assembly_hierarchy',
                    'flatten_assemblies',
                    'format_name',
                    'join_adjacent_surfaces',
                    'location_element_id',
                    'location_group_id',
                    'location_position',
                    'notify_user',
                    'owner_id',
                    'parent_id',
                    'project_id',
                    'public',
                    'one_part_per_doc',
                    'split_assemblies_into_multiple_documents',
                    'store_in_document',
                    'translate',
                    'unit',
                    'upload_id',
                    'version_string',
                    'y_axis_is_up',
                    'import_within_document',
                ],
                'required': [
                    'did',
                    'wid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wid':
                        (str,),
                    'file':
                        ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                    'allow_faulty_parts':
                        (bool,),
                    'create_composite':
                        (bool,),
                    'create_drawing_if_possible':
                        (bool,),
                    'encoded_filename':
                        (str,),
                    'extract_assembly_hierarchy':
                        (bool,),
                    'flatten_assemblies':
                        (bool,),
                    'format_name':
                        (str,),
                    'join_adjacent_surfaces':
                        (bool,),
                    'location_element_id':
                        (str,),
                    'location_group_id':
                        (str,),
                    'location_position':
                        (int,),
                    'notify_user':
                        (bool,),
                    'owner_id':
                        (str,),
                    'parent_id':
                        (str,),
                    'project_id':
                        (str,),
                    'public':
                        (bool,),
                    'one_part_per_doc':
                        (bool,),
                    'split_assemblies_into_multiple_documents':
                        (bool,),
                    'store_in_document':
                        (bool,),
                    'translate':
                        (bool,),
                    'unit':
                        (str,),
                    'upload_id':
                        (str,),
                    'version_string':
                        (str,),
                    'y_axis_is_up':
                        (bool,),
                    'import_within_document':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wid': 'wid',
                    'file': 'file',
                    'allow_faulty_parts': 'allowFaultyParts',
                    'create_composite': 'createComposite',
                    'create_drawing_if_possible': 'createDrawingIfPossible',
                    'encoded_filename': 'encodedFilename',
                    'extract_assembly_hierarchy': 'extractAssemblyHierarchy',
                    'flatten_assemblies': 'flattenAssemblies',
                    'format_name': 'formatName',
                    'join_adjacent_surfaces': 'joinAdjacentSurfaces',
                    'location_element_id': 'locationElementId',
                    'location_group_id': 'locationGroupId',
                    'location_position': 'locationPosition',
                    'notify_user': 'notifyUser',
                    'owner_id': 'ownerId',
                    'parent_id': 'parentId',
                    'project_id': 'projectId',
                    'public': 'public',
                    'one_part_per_doc': 'onePartPerDoc',
                    'split_assemblies_into_multiple_documents': 'splitAssembliesIntoMultipleDocuments',
                    'store_in_document': 'storeInDocument',
                    'translate': 'translate',
                    'unit': 'unit',
                    'upload_id': 'uploadId',
                    'version_string': 'versionString',
                    'y_axis_is_up': 'yAxisIsUp',
                    'import_within_document': 'importWithinDocument',
                },
                'location_map': {
                    'did': 'path',
                    'wid': 'path',
                    'file': 'form',
                    'allow_faulty_parts': 'form',
                    'create_composite': 'form',
                    'create_drawing_if_possible': 'form',
                    'encoded_filename': 'form',
                    'extract_assembly_hierarchy': 'form',
                    'flatten_assemblies': 'form',
                    'format_name': 'form',
                    'join_adjacent_surfaces': 'form',
                    'location_element_id': 'form',
                    'location_group_id': 'form',
                    'location_position': 'form',
                    'notify_user': 'form',
                    'owner_id': 'form',
                    'parent_id': 'form',
                    'project_id': 'form',
                    'public': 'form',
                    'one_part_per_doc': 'form',
                    'split_assemblies_into_multiple_documents': 'form',
                    'store_in_document': 'form',
                    'translate': 'form',
                    'unit': 'form',
                    'upload_id': 'form',
                    'version_string': 'form',
                    'y_axis_is_up': 'form',
                    'import_within_document': 'form',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )
        self.upload_file_update_element_endpoint = _Endpoint(
            settings={
                'response_type': (BTDocumentElementProcessingInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/blobelements/d/{did}/w/{wid}/e/{eid}',
                'operation_id': 'upload_file_update_element',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'eid',
                    'wid',
                    'parent_change_id',
                    'file',
                    'allow_faulty_parts',
                    'create_composite',
                    'create_drawing_if_possible',
                    'encoded_filename',
                    'extract_assembly_hierarchy',
                    'flatten_assemblies',
                    'format_name',
                    'join_adjacent_surfaces',
                    'location_element_id',
                    'location_group_id',
                    'location_position',
                    'notify_user',
                    'owner_id',
                    'parent_id',
                    'project_id',
                    'public',
                    'one_part_per_doc',
                    'split_assemblies_into_multiple_documents',
                    'store_in_document',
                    'translate',
                    'unit',
                    'upload_id',
                    'version_string',
                    'y_axis_is_up',
                    'import_within_document',
                ],
                'required': [
                    'did',
                    'eid',
                    'wid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'eid':
                        (str,),
                    'wid':
                        (str,),
                    'parent_change_id':
                        (str,),
                    'file':
                        ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                    'allow_faulty_parts':
                        (bool,),
                    'create_composite':
                        (bool,),
                    'create_drawing_if_possible':
                        (bool,),
                    'encoded_filename':
                        (str,),
                    'extract_assembly_hierarchy':
                        (bool,),
                    'flatten_assemblies':
                        (bool,),
                    'format_name':
                        (str,),
                    'join_adjacent_surfaces':
                        (bool,),
                    'location_element_id':
                        (str,),
                    'location_group_id':
                        (str,),
                    'location_position':
                        (int,),
                    'notify_user':
                        (bool,),
                    'owner_id':
                        (str,),
                    'parent_id':
                        (str,),
                    'project_id':
                        (str,),
                    'public':
                        (bool,),
                    'one_part_per_doc':
                        (bool,),
                    'split_assemblies_into_multiple_documents':
                        (bool,),
                    'store_in_document':
                        (bool,),
                    'translate':
                        (bool,),
                    'unit':
                        (str,),
                    'upload_id':
                        (str,),
                    'version_string':
                        (str,),
                    'y_axis_is_up':
                        (bool,),
                    'import_within_document':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'eid': 'eid',
                    'wid': 'wid',
                    'parent_change_id': 'parentChangeId',
                    'file': 'file',
                    'allow_faulty_parts': 'allowFaultyParts',
                    'create_composite': 'createComposite',
                    'create_drawing_if_possible': 'createDrawingIfPossible',
                    'encoded_filename': 'encodedFilename',
                    'extract_assembly_hierarchy': 'extractAssemblyHierarchy',
                    'flatten_assemblies': 'flattenAssemblies',
                    'format_name': 'formatName',
                    'join_adjacent_surfaces': 'joinAdjacentSurfaces',
                    'location_element_id': 'locationElementId',
                    'location_group_id': 'locationGroupId',
                    'location_position': 'locationPosition',
                    'notify_user': 'notifyUser',
                    'owner_id': 'ownerId',
                    'parent_id': 'parentId',
                    'project_id': 'projectId',
                    'public': 'public',
                    'one_part_per_doc': 'onePartPerDoc',
                    'split_assemblies_into_multiple_documents': 'splitAssembliesIntoMultipleDocuments',
                    'store_in_document': 'storeInDocument',
                    'translate': 'translate',
                    'unit': 'unit',
                    'upload_id': 'uploadId',
                    'version_string': 'versionString',
                    'y_axis_is_up': 'yAxisIsUp',
                    'import_within_document': 'importWithinDocument',
                },
                'location_map': {
                    'did': 'path',
                    'eid': 'path',
                    'wid': 'path',
                    'parent_change_id': 'query',
                    'file': 'form',
                    'allow_faulty_parts': 'form',
                    'create_composite': 'form',
                    'create_drawing_if_possible': 'form',
                    'encoded_filename': 'form',
                    'extract_assembly_hierarchy': 'form',
                    'flatten_assemblies': 'form',
                    'format_name': 'form',
                    'join_adjacent_surfaces': 'form',
                    'location_element_id': 'form',
                    'location_group_id': 'form',
                    'location_position': 'form',
                    'notify_user': 'form',
                    'owner_id': 'form',
                    'parent_id': 'form',
                    'project_id': 'form',
                    'public': 'form',
                    'one_part_per_doc': 'form',
                    'split_assemblies_into_multiple_documents': 'form',
                    'store_in_document': 'form',
                    'translate': 'form',
                    'unit': 'form',
                    'upload_id': 'form',
                    'version_string': 'form',
                    'y_axis_is_up': 'form',
                    'import_within_document': 'form',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )

    def create_blob_translation(
        self,
        did,
        wv,
        wvid,
        eid,
        bt_translate_format_params,
        **kwargs
    ):
        """Create Translation.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_blob_translation(did, wv, wvid, eid, bt_translate_format_params, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wv (str):
            wvid (str):
            eid (str):
            bt_translate_format_params (BTTranslateFormatParams):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTTranslationRequestInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wv'] = \
            wv
        kwargs['wvid'] = \
            wvid
        kwargs['eid'] = \
            eid
        kwargs['bt_translate_format_params'] = \
            bt_translate_format_params
        return self.create_blob_translation_endpoint.call_with_http_info(**kwargs)

    def download_file_workspace(
        self,
        did,
        wid,
        eid,
        **kwargs
    ):
        """download_file_workspace  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.download_file_workspace(did, wid, eid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wid (str):
            eid (str):

        Keyword Args:
            content_disposition (str): [optional]
            if_none_match (str): [optional]
            link_document_id (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            file_type
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wid'] = \
            wid
        kwargs['eid'] = \
            eid
        return self.download_file_workspace_endpoint.call_with_http_info(**kwargs)

    def update_units(
        self,
        did,
        eid,
        wid,
        bt_update_mesh_units_params,
        **kwargs
    ):
        """Update Mesh Units.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_units(did, eid, wid, bt_update_mesh_units_params, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            eid (str):
            wid (str):
            bt_update_mesh_units_params (BTUpdateMeshUnitsParams):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTDocumentElementProcessingInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['eid'] = \
            eid
        kwargs['wid'] = \
            wid
        kwargs['bt_update_mesh_units_params'] = \
            bt_update_mesh_units_params
        return self.update_units_endpoint.call_with_http_info(**kwargs)

    def upload_file_create_element(
        self,
        did,
        wid,
        **kwargs
    ):
        """Upload file to new element.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.upload_file_create_element(did, wid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wid (str):

        Keyword Args:
            file ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): The file to upload.. [optional]
            allow_faulty_parts (bool): [optional]
            create_composite (bool): [optional]
            create_drawing_if_possible (bool): [optional]
            encoded_filename (str): [optional]
            extract_assembly_hierarchy (bool): [optional]
            flatten_assemblies (bool): [optional]
            format_name (str): [optional]
            join_adjacent_surfaces (bool): [optional]
            location_element_id (str): [optional]
            location_group_id (str): [optional]
            location_position (int): [optional] if omitted the server will use the default value of -1
            notify_user (bool): [optional] if omitted the server will use the default value of True
            owner_id (str): [optional]
            parent_id (str): [optional]
            project_id (str): [optional]
            public (bool): [optional]
            one_part_per_doc (bool): [optional] if omitted the server will use the default value of False
            split_assemblies_into_multiple_documents (bool): [optional] if omitted the server will use the default value of False
            store_in_document (bool): [optional] if omitted the server will use the default value of True
            translate (bool): [optional] if omitted the server will use the default value of True
            unit (str): [optional] if omitted the server will use the default value of ""
            upload_id (str): [optional]
            version_string (str): [optional]
            y_axis_is_up (bool): [optional]
            import_within_document (bool): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTDocumentElementProcessingInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wid'] = \
            wid
        return self.upload_file_create_element_endpoint.call_with_http_info(**kwargs)

    def upload_file_update_element(
        self,
        did,
        eid,
        wid,
        **kwargs
    ):
        """Update Blob Element.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.upload_file_update_element(did, eid, wid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            eid (str):
            wid (str):

        Keyword Args:
            parent_change_id (str): [optional]
            file ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): The file to upload.. [optional]
            allow_faulty_parts (bool): [optional]
            create_composite (bool): [optional]
            create_drawing_if_possible (bool): [optional]
            encoded_filename (str): [optional]
            extract_assembly_hierarchy (bool): [optional]
            flatten_assemblies (bool): [optional]
            format_name (str): [optional]
            join_adjacent_surfaces (bool): [optional]
            location_element_id (str): [optional]
            location_group_id (str): [optional]
            location_position (int): [optional] if omitted the server will use the default value of -1
            notify_user (bool): [optional] if omitted the server will use the default value of True
            owner_id (str): [optional]
            parent_id (str): [optional]
            project_id (str): [optional]
            public (bool): [optional]
            one_part_per_doc (bool): [optional] if omitted the server will use the default value of False
            split_assemblies_into_multiple_documents (bool): [optional] if omitted the server will use the default value of False
            store_in_document (bool): [optional] if omitted the server will use the default value of True
            translate (bool): [optional] if omitted the server will use the default value of True
            unit (str): [optional] if omitted the server will use the default value of ""
            upload_id (str): [optional]
            version_string (str): [optional]
            y_axis_is_up (bool): [optional]
            import_within_document (bool): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTDocumentElementProcessingInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['eid'] = \
            eid
        kwargs['wid'] = \
            wid
        return self.upload_file_update_element_endpoint.call_with_http_info(**kwargs)

