"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from onshape_client.oas.model.bt_metadata_object_info import BTMetadataObjectInfo
from onshape_client.oas.model.bt_metadata_object_list_info_bt_metadata_element_info import BTMetadataObjectListInfoBTMetadataElementInfo
from onshape_client.oas.model.bt_metadata_object_list_info_bt_metadata_part_info import BTMetadataObjectListInfoBTMetadataPartInfo


class MetadataApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_veop_standard_content_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/standardcontent/d/{did}/v/{vid}/e/{eid}/{otype}/{oid}/p/{pid}',
                'operation_id': 'get_veop_standard_content_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'vid',
                    'eid',
                    'otype',
                    'oid',
                    'pid',
                    'configuration',
                    'link_document_id',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'vid',
                    'eid',
                    'otype',
                    'oid',
                    'pid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'vid':
                        (str,),
                    'eid':
                        (str,),
                    'otype':
                        (str,),
                    'oid':
                        (str,),
                    'pid':
                        (str,),
                    'configuration':
                        (str,),
                    'link_document_id':
                        (str,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'vid': 'vid',
                    'eid': 'eid',
                    'otype': 'otype',
                    'oid': 'oid',
                    'pid': 'pid',
                    'configuration': 'configuration',
                    'link_document_id': 'linkDocumentId',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'vid': 'path',
                    'eid': 'path',
                    'otype': 'path',
                    'oid': 'path',
                    'pid': 'path',
                    'configuration': 'query',
                    'link_document_id': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_wmve_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e/{eid}',
                'operation_id': 'get_wmve_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'configuration',
                    'link_document_id',
                    'infer_metadata_owner',
                    'depth',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'configuration':
                        (str,),
                    'link_document_id':
                        (str,),
                    'infer_metadata_owner':
                        (bool,),
                    'depth':
                        (str,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'configuration': 'configuration',
                    'link_document_id': 'linkDocumentId',
                    'infer_metadata_owner': 'inferMetadataOwner',
                    'depth': 'depth',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'configuration': 'query',
                    'link_document_id': 'query',
                    'infer_metadata_owner': 'query',
                    'depth': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_wmvep_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e/{eid}/{iden}/{pid}',
                'operation_id': 'get_wmvep_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'iden',
                    'partid',
                    'pid',
                    'link_document_id',
                    'configuration',
                    'rollback_bar_index',
                    'element_microversion_id',
                    'infer_metadata_owner',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'iden',
                    'partid',
                    'pid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'iden':
                        (str,),
                    'partid':
                        (str,),
                    'pid':
                        (str,),
                    'link_document_id':
                        (str,),
                    'configuration':
                        (str,),
                    'rollback_bar_index':
                        (int,),
                    'element_microversion_id':
                        (str,),
                    'infer_metadata_owner':
                        (bool,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'iden': 'iden',
                    'partid': 'partid',
                    'pid': 'pid',
                    'link_document_id': 'linkDocumentId',
                    'configuration': 'configuration',
                    'rollback_bar_index': 'rollbackBarIndex',
                    'element_microversion_id': 'elementMicroversionId',
                    'infer_metadata_owner': 'inferMetadataOwner',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'iden': 'path',
                    'partid': 'path',
                    'pid': 'path',
                    'link_document_id': 'query',
                    'configuration': 'query',
                    'rollback_bar_index': 'query',
                    'element_microversion_id': 'query',
                    'infer_metadata_owner': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_wmveps_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectListInfoBTMetadataPartInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e/{eid}/p',
                'operation_id': 'get_wmveps_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'configuration',
                    'link_document_id',
                    'infer_metadata_owner',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'configuration':
                        (str,),
                    'link_document_id':
                        (str,),
                    'infer_metadata_owner':
                        (bool,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'configuration': 'configuration',
                    'link_document_id': 'linkDocumentId',
                    'infer_metadata_owner': 'inferMetadataOwner',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'configuration': 'query',
                    'link_document_id': 'query',
                    'infer_metadata_owner': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_wmves_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectListInfoBTMetadataElementInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e',
                'operation_id': 'get_wmves_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'link_document_id',
                    'infer_metadata_owner',
                    'depth',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'link_document_id':
                        (str,),
                    'infer_metadata_owner':
                        (bool,),
                    'depth':
                        (str,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'link_document_id': 'linkDocumentId',
                    'infer_metadata_owner': 'inferMetadataOwner',
                    'depth': 'depth',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'link_document_id': 'query',
                    'infer_metadata_owner': 'query',
                    'depth': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_wv_metadata_endpoint = _Endpoint(
            settings={
                'response_type': (BTMetadataObjectInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wv}/{wvid}',
                'operation_id': 'get_wv_metadata',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wv',
                    'wvid',
                    'link_document_id',
                    'infer_metadata_owner',
                    'depth',
                    'include_computed_properties',
                    'thumbnail',
                ],
                'required': [
                    'did',
                    'wv',
                    'wvid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wv':
                        (str,),
                    'wvid':
                        (str,),
                    'link_document_id':
                        (str,),
                    'infer_metadata_owner':
                        (bool,),
                    'depth':
                        (str,),
                    'include_computed_properties':
                        (bool,),
                    'thumbnail':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wv': 'wv',
                    'wvid': 'wvid',
                    'link_document_id': 'linkDocumentId',
                    'infer_metadata_owner': 'inferMetadataOwner',
                    'depth': 'depth',
                    'include_computed_properties': 'includeComputedProperties',
                    'thumbnail': 'thumbnail',
                },
                'location_map': {
                    'did': 'path',
                    'wv': 'path',
                    'wvid': 'path',
                    'link_document_id': 'query',
                    'infer_metadata_owner': 'query',
                    'depth': 'query',
                    'include_computed_properties': 'query',
                    'thumbnail': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_veop_standard_content_part_metadata_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/standardcontent/d/{did}/v/{vid}/e/{eid}/{otype}/{oid}/p/{pid}',
                'operation_id': 'update_veop_standard_content_part_metadata',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'vid',
                    'eid',
                    'otype',
                    'oid',
                    'pid',
                    'body',
                    'link_document_id',
                ],
                'required': [
                    'did',
                    'vid',
                    'eid',
                    'otype',
                    'oid',
                    'pid',
                    'body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'vid':
                        (str,),
                    'eid':
                        (str,),
                    'otype':
                        (str,),
                    'oid':
                        (str,),
                    'pid':
                        (str,),
                    'body':
                        (str,),
                    'link_document_id':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'vid': 'vid',
                    'eid': 'eid',
                    'otype': 'otype',
                    'oid': 'oid',
                    'pid': 'pid',
                    'link_document_id': 'linkDocumentId',
                },
                'location_map': {
                    'did': 'path',
                    'vid': 'path',
                    'eid': 'path',
                    'otype': 'path',
                    'oid': 'path',
                    'pid': 'path',
                    'body': 'body',
                    'link_document_id': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.update_wv_metadata_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wv}/{wvid}',
                'operation_id': 'update_wv_metadata',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wv',
                    'wvid',
                    'body',
                ],
                'required': [
                    'did',
                    'wv',
                    'wvid',
                    'body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wv':
                        (str,),
                    'wvid':
                        (str,),
                    'body':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wv': 'wv',
                    'wvid': 'wvid',
                },
                'location_map': {
                    'did': 'path',
                    'wv': 'path',
                    'wvid': 'path',
                    'body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.update_wve_metadata_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e/{eid}',
                'operation_id': 'update_wve_metadata',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'body',
                    'configuration',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'body':
                        (str,),
                    'configuration':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'configuration': 'configuration',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'body': 'body',
                    'configuration': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )
        self.update_wvep_metadata_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/metadata/d/{did}/{wvm}/{wvmid}/e/{eid}/{iden}/{pid}',
                'operation_id': 'update_wvep_metadata',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'iden',
                    'partid',
                    'pid',
                    'body',
                    'link_document_id',
                    'configuration',
                    'rollback_bar_index',
                    'element_microversion_id',
                ],
                'required': [
                    'did',
                    'wvm',
                    'wvmid',
                    'eid',
                    'iden',
                    'partid',
                    'pid',
                    'body',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wvm':
                        (str,),
                    'wvmid':
                        (str,),
                    'eid':
                        (str,),
                    'iden':
                        (str,),
                    'partid':
                        (str,),
                    'pid':
                        (str,),
                    'body':
                        (str,),
                    'link_document_id':
                        (str,),
                    'configuration':
                        (str,),
                    'rollback_bar_index':
                        (int,),
                    'element_microversion_id':
                        (str,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wvm': 'wvm',
                    'wvmid': 'wvmid',
                    'eid': 'eid',
                    'iden': 'iden',
                    'partid': 'partid',
                    'pid': 'pid',
                    'link_document_id': 'linkDocumentId',
                    'configuration': 'configuration',
                    'rollback_bar_index': 'rollbackBarIndex',
                    'element_microversion_id': 'elementMicroversionId',
                },
                'location_map': {
                    'did': 'path',
                    'wvm': 'path',
                    'wvmid': 'path',
                    'eid': 'path',
                    'iden': 'path',
                    'partid': 'path',
                    'pid': 'path',
                    'body': 'body',
                    'link_document_id': 'query',
                    'configuration': 'query',
                    'rollback_bar_index': 'query',
                    'element_microversion_id': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ]
            },
            api_client=api_client
        )

    def get_veop_standard_content_metadata(
        self,
        did,
        vid,
        eid,
        otype,
        oid,
        pid,
        **kwargs
    ):
        """get_veop_standard_content_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_veop_standard_content_metadata(did, vid, eid, otype, oid, pid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            vid (str):
            eid (str):
            otype (str):
            oid (str):
            pid (str):

        Keyword Args:
            configuration (str): [optional]
            link_document_id (str): [optional]
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['vid'] = \
            vid
        kwargs['eid'] = \
            eid
        kwargs['otype'] = \
            otype
        kwargs['oid'] = \
            oid
        kwargs['pid'] = \
            pid
        return self.get_veop_standard_content_metadata_endpoint.call_with_http_info(**kwargs)

    def get_wmve_metadata(
        self,
        did,
        wvm,
        wvmid,
        eid,
        **kwargs
    ):
        """get_wmve_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_wmve_metadata(did, wvm, wvmid, eid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):

        Keyword Args:
            configuration (str): [optional]
            link_document_id (str): [optional]
            infer_metadata_owner (bool): [optional] if omitted the server will use the default value of False
            depth (str): [optional] if omitted the server will use the default value of "1"
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        return self.get_wmve_metadata_endpoint.call_with_http_info(**kwargs)

    def get_wmvep_metadata(
        self,
        did,
        wvm,
        wvmid,
        eid,
        iden,
        partid,
        pid,
        **kwargs
    ):
        """get_wmvep_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_wmvep_metadata(did, wvm, wvmid, eid, iden, partid, pid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):
            iden (str):
            partid (str):
            pid (str):

        Keyword Args:
            link_document_id (str): [optional] if omitted the server will use the default value of ""
            configuration (str): [optional] if omitted the server will use the default value of ""
            rollback_bar_index (int): [optional] if omitted the server will use the default value of -1
            element_microversion_id (str): [optional]
            infer_metadata_owner (bool): [optional] if omitted the server will use the default value of False
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        kwargs['iden'] = \
            iden
        kwargs['partid'] = \
            partid
        kwargs['pid'] = \
            pid
        return self.get_wmvep_metadata_endpoint.call_with_http_info(**kwargs)

    def get_wmveps_metadata(
        self,
        did,
        wvm,
        wvmid,
        eid,
        **kwargs
    ):
        """get_wmveps_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_wmveps_metadata(did, wvm, wvmid, eid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):

        Keyword Args:
            configuration (str): [optional]
            link_document_id (str): [optional]
            infer_metadata_owner (bool): [optional] if omitted the server will use the default value of False
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectListInfoBTMetadataPartInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        return self.get_wmveps_metadata_endpoint.call_with_http_info(**kwargs)

    def get_wmves_metadata(
        self,
        did,
        wvm,
        wvmid,
        **kwargs
    ):
        """get_wmves_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_wmves_metadata(did, wvm, wvmid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):

        Keyword Args:
            link_document_id (str): [optional]
            infer_metadata_owner (bool): [optional] if omitted the server will use the default value of False
            depth (str): [optional] if omitted the server will use the default value of "1"
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectListInfoBTMetadataElementInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        return self.get_wmves_metadata_endpoint.call_with_http_info(**kwargs)

    def get_wv_metadata(
        self,
        did,
        wv,
        wvid,
        **kwargs
    ):
        """get_wv_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_wv_metadata(did, wv, wvid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wv (str):
            wvid (str):

        Keyword Args:
            link_document_id (str): [optional]
            infer_metadata_owner (bool): [optional] if omitted the server will use the default value of False
            depth (str): [optional] if omitted the server will use the default value of "1"
            include_computed_properties (bool): [optional] if omitted the server will use the default value of True
            thumbnail (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTMetadataObjectInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wv'] = \
            wv
        kwargs['wvid'] = \
            wvid
        return self.get_wv_metadata_endpoint.call_with_http_info(**kwargs)

    def update_veop_standard_content_part_metadata(
        self,
        did,
        vid,
        eid,
        otype,
        oid,
        pid,
        body,
        **kwargs
    ):
        """update_veop_standard_content_part_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_veop_standard_content_part_metadata(did, vid, eid, otype, oid, pid, body, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            vid (str):
            eid (str):
            otype (str):
            oid (str):
            pid (str):
            body (str):

        Keyword Args:
            link_document_id (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['vid'] = \
            vid
        kwargs['eid'] = \
            eid
        kwargs['otype'] = \
            otype
        kwargs['oid'] = \
            oid
        kwargs['pid'] = \
            pid
        kwargs['body'] = \
            body
        return self.update_veop_standard_content_part_metadata_endpoint.call_with_http_info(**kwargs)

    def update_wv_metadata(
        self,
        did,
        wv,
        wvid,
        body,
        **kwargs
    ):
        """update_wv_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_wv_metadata(did, wv, wvid, body, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wv (str):
            wvid (str):
            body (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wv'] = \
            wv
        kwargs['wvid'] = \
            wvid
        kwargs['body'] = \
            body
        return self.update_wv_metadata_endpoint.call_with_http_info(**kwargs)

    def update_wve_metadata(
        self,
        did,
        wvm,
        wvmid,
        eid,
        body,
        **kwargs
    ):
        """update_wve_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_wve_metadata(did, wvm, wvmid, eid, body, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):
            body (str):

        Keyword Args:
            configuration (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        kwargs['body'] = \
            body
        return self.update_wve_metadata_endpoint.call_with_http_info(**kwargs)

    def update_wvep_metadata(
        self,
        did,
        wvm,
        wvmid,
        eid,
        iden,
        partid,
        pid,
        body,
        **kwargs
    ):
        """update_wvep_metadata  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_wvep_metadata(did, wvm, wvmid, eid, iden, partid, pid, body, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wvm (str):
            wvmid (str):
            eid (str):
            iden (str):
            partid (str):
            pid (str):
            body (str):

        Keyword Args:
            link_document_id (str): [optional] if omitted the server will use the default value of ""
            configuration (str): [optional] if omitted the server will use the default value of ""
            rollback_bar_index (int): [optional] if omitted the server will use the default value of -1
            element_microversion_id (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wvm'] = \
            wvm
        kwargs['wvmid'] = \
            wvmid
        kwargs['eid'] = \
            eid
        kwargs['iden'] = \
            iden
        kwargs['partid'] = \
            partid
        kwargs['pid'] = \
            pid
        kwargs['body'] = \
            body
        return self.update_wvep_metadata_endpoint.call_with_http_info(**kwargs)

