"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)


class OpenApiApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_open_api_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'BasicAuth'
                ],
                'endpoint_path': '/openapi',
                'operation_id': 'get_open_api',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'force_reload',
                    'version',
                    'version_alias',
                    'included_tags',
                    'excluded_tags',
                    'include_deprecated',
                    'documentation_statuses',
                    'rest_user_role',
                    'operation_ids',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                    'version_alias',
                    'documentation_statuses',
                    'rest_user_role',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('version_alias',): {

                        "MINOR": "LAST_MINOR",
                        "BUILD": "LAST_BUILD"
                    },
                    ('documentation_statuses',): {

                        "DEVELOPMENT": "DEVELOPMENT",
                        "PRODUCTION": "PRODUCTION",
                        "STAGING": "STAGING",
                        "EVP": "EVP",
                        "UNSET": "UNSET",
                        "INTERNAL": "INTERNAL"
                    },
                    ('rest_user_role',): {

                        "PUBLIC": "PUBLIC",
                        "INTERNAL": "INTERNAL"
                    },
                },
                'openapi_types': {
                    'force_reload':
                        (bool,),
                    'version':
                        (str,),
                    'version_alias':
                        (str,),
                    'included_tags':
                        ([str],),
                    'excluded_tags':
                        ([str],),
                    'include_deprecated':
                        (bool,),
                    'documentation_statuses':
                        ([str],),
                    'rest_user_role':
                        (str,),
                    'operation_ids':
                        ([str],),
                },
                'attribute_map': {
                    'force_reload': 'forceReload',
                    'version': 'version',
                    'version_alias': 'versionAlias',
                    'included_tags': 'includedTags',
                    'excluded_tags': 'excludedTags',
                    'include_deprecated': 'includeDeprecated',
                    'documentation_statuses': 'documentationStatuses',
                    'rest_user_role': 'restUserRole',
                    'operation_ids': 'operationIds',
                },
                'location_map': {
                    'force_reload': 'query',
                    'version': 'query',
                    'version_alias': 'query',
                    'included_tags': 'query',
                    'excluded_tags': 'query',
                    'include_deprecated': 'query',
                    'documentation_statuses': 'query',
                    'rest_user_role': 'query',
                    'operation_ids': 'query',
                },
                'collection_format_map': {
                    'included_tags': 'multi',
                    'excluded_tags': 'multi',
                    'documentation_statuses': 'multi',
                    'operation_ids': 'multi',
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_tags_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'BasicAuth'
                ],
                'endpoint_path': '/openapi/tags',
                'operation_id': 'get_tags',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client
        )

    def get_open_api(
        self,
        **kwargs
    ):
        """OpenAPI spec documentation for the Onshape REST API.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_open_api(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            force_reload (bool): Force reload the OpenApi definition. Only works when asking for the latest version.. [optional]
            version (str): Specify a version of Onshape from which the OpenAPI is generated. If '*' is specified in any of the version fields, that indicates any version if acceptable.. [optional]
            version_alias (str): Version aliases based on the currently released version.. [optional]
            included_tags ([str]): Return only operations with tags included in includedTags.. [optional]
            excluded_tags ([str]): If an operation contains an excluded tag, it is not returned from this endpoint.. [optional]
            include_deprecated (bool): Include deprecated endpoints.. [optional]
            documentation_statuses ([str]): Only return endpoints that have the specified documentation status. Default is to return all the endpoints the user should have access to.. [optional]
            rest_user_role (str): The REST user role for which this spec is requested.. [optional]
            operation_ids ([str]): Only return operations with specified id.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.get_open_api_endpoint.call_with_http_info(**kwargs)

    def get_tags(
        self,
        **kwargs
    ):
        """get_tags  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_tags(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.get_tags_endpoint.call_with_http_info(**kwargs)

