"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from onshape_client.oas.model.bt_list_response_bt_revision_info import BTListResponseBTRevisionInfo
from onshape_client.oas.model.bt_revision_info import BTRevisionInfo
from onshape_client.oas.model.bt_revision_list_response import BTRevisionListResponse


class RevisionApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.delete_revision_history_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/companies/{cid}/partnumber/{pnum}/elementType/{et}',
                'operation_id': 'delete_revision_history',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'cid',
                    'pnum',
                    'et',
                    'ignore_linked_documents',
                ],
                'required': [
                    'cid',
                    'pnum',
                    'et',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cid':
                        (str,),
                    'pnum':
                        (str,),
                    'et':
                        (str,),
                    'ignore_linked_documents':
                        (bool,),
                },
                'attribute_map': {
                    'cid': 'cid',
                    'pnum': 'pnum',
                    'et': 'et',
                    'ignore_linked_documents': 'ignoreLinkedDocuments',
                },
                'location_map': {
                    'cid': 'path',
                    'pnum': 'path',
                    'et': 'path',
                    'ignore_linked_documents': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.enumerate_revisions_endpoint = _Endpoint(
            settings={
                'response_type': (BTListResponseBTRevisionInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/companies/{cid}',
                'operation_id': 'enumerate_revisions',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'cid',
                    'element_type',
                    'limit',
                    'offset',
                    'latest_only',
                    'after',
                ],
                'required': [
                    'cid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'limit',
                    'offset',
                ]
            },
            root_map={
                'validations': {
                    ('limit',): {

                        'inclusive_maximum': 100,
                        'inclusive_minimum': 1,
                    },
                    ('offset',): {

                        'inclusive_maximum': 100,
                        'inclusive_minimum': 0,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cid':
                        (str,),
                    'element_type':
                        (int,),
                    'limit':
                        (int,),
                    'offset':
                        (int,),
                    'latest_only':
                        (bool,),
                    'after':
                        (datetime,),
                },
                'attribute_map': {
                    'cid': 'cid',
                    'element_type': 'elementType',
                    'limit': 'limit',
                    'offset': 'offset',
                    'latest_only': 'latestOnly',
                    'after': 'after',
                },
                'location_map': {
                    'cid': 'path',
                    'element_type': 'query',
                    'limit': 'query',
                    'offset': 'query',
                    'latest_only': 'query',
                    'after': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_latest_in_document_or_company_endpoint = _Endpoint(
            settings={
                'response_type': (BTRevisionInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/{cd}/{cdid}/p/{pnum}/latest',
                'operation_id': 'get_latest_in_document_or_company',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'cd',
                    'cdid',
                    'pnum',
                    'et',
                ],
                'required': [
                    'cd',
                    'cdid',
                    'pnum',
                    'et',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cd':
                        (str,),
                    'cdid':
                        (str,),
                    'pnum':
                        (str,),
                    'et':
                        (str,),
                },
                'attribute_map': {
                    'cd': 'cd',
                    'cdid': 'cdid',
                    'pnum': 'pnum',
                    'et': 'et',
                },
                'location_map': {
                    'cd': 'path',
                    'cdid': 'path',
                    'pnum': 'path',
                    'et': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_revision_history_in_company_by_element_id_endpoint = _Endpoint(
            settings={
                'response_type': (BTRevisionListResponse,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/companies/{cid}/d/{did}/{wv}/{wvid}/e/{eid}',
                'operation_id': 'get_revision_history_in_company_by_element_id',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'cid',
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'element_type',
                    'configuration',
                    'link_document_id',
                    'fill_approvers',
                    'fill_export_permission',
                ],
                'required': [
                    'cid',
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'element_type',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cid':
                        (str,),
                    'did':
                        (str,),
                    'wv':
                        (str,),
                    'wvid':
                        (str,),
                    'eid':
                        (str,),
                    'element_type':
                        (str,),
                    'configuration':
                        (str,),
                    'link_document_id':
                        (str,),
                    'fill_approvers':
                        (bool,),
                    'fill_export_permission':
                        (bool,),
                },
                'attribute_map': {
                    'cid': 'cid',
                    'did': 'did',
                    'wv': 'wv',
                    'wvid': 'wvid',
                    'eid': 'eid',
                    'element_type': 'elementType',
                    'configuration': 'configuration',
                    'link_document_id': 'linkDocumentId',
                    'fill_approvers': 'fillApprovers',
                    'fill_export_permission': 'fillExportPermission',
                },
                'location_map': {
                    'cid': 'path',
                    'did': 'path',
                    'wv': 'path',
                    'wvid': 'path',
                    'eid': 'path',
                    'element_type': 'query',
                    'configuration': 'query',
                    'link_document_id': 'query',
                    'fill_approvers': 'query',
                    'fill_export_permission': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_revision_history_in_company_by_part_id_endpoint = _Endpoint(
            settings={
                'response_type': (BTRevisionListResponse,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/companies/{cid}/d/{did}/{wv}/{wvid}/e/{eid}/p/{pid}',
                'operation_id': 'get_revision_history_in_company_by_part_id',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'cid',
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'pid',
                    'configuration',
                    'link_document_id',
                    'fill_approvers',
                    'fill_export_permission',
                ],
                'required': [
                    'cid',
                    'did',
                    'wv',
                    'wvid',
                    'eid',
                    'pid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cid':
                        (str,),
                    'did':
                        (str,),
                    'wv':
                        (str,),
                    'wvid':
                        (str,),
                    'eid':
                        (str,),
                    'pid':
                        (str,),
                    'configuration':
                        (str,),
                    'link_document_id':
                        (str,),
                    'fill_approvers':
                        (bool,),
                    'fill_export_permission':
                        (bool,),
                },
                'attribute_map': {
                    'cid': 'cid',
                    'did': 'did',
                    'wv': 'wv',
                    'wvid': 'wvid',
                    'eid': 'eid',
                    'pid': 'pid',
                    'configuration': 'configuration',
                    'link_document_id': 'linkDocumentId',
                    'fill_approvers': 'fillApprovers',
                    'fill_export_permission': 'fillExportPermission',
                },
                'location_map': {
                    'cid': 'path',
                    'did': 'path',
                    'wv': 'path',
                    'wvid': 'path',
                    'eid': 'path',
                    'pid': 'path',
                    'configuration': 'query',
                    'link_document_id': 'query',
                    'fill_approvers': 'query',
                    'fill_export_permission': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_revision_history_in_company_by_part_number_endpoint = _Endpoint(
            settings={
                'response_type': (BTRevisionListResponse,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/revisions/companies/{cid}/partnumber/{pnum}',
                'operation_id': 'get_revision_history_in_company_by_part_number',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'cid',
                    'pnum',
                    'element_type',
                    'fill_approvers',
                    'fill_export_permission',
                ],
                'required': [
                    'cid',
                    'pnum',
                    'element_type',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'cid':
                        (str,),
                    'pnum':
                        (str,),
                    'element_type':
                        (str,),
                    'fill_approvers':
                        (bool,),
                    'fill_export_permission':
                        (bool,),
                },
                'attribute_map': {
                    'cid': 'cid',
                    'pnum': 'pnum',
                    'element_type': 'elementType',
                    'fill_approvers': 'fillApprovers',
                    'fill_export_permission': 'fillExportPermission',
                },
                'location_map': {
                    'cid': 'path',
                    'pnum': 'path',
                    'element_type': 'query',
                    'fill_approvers': 'query',
                    'fill_export_permission': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def delete_revision_history(
        self,
        cid,
        pnum,
        et,
        **kwargs
    ):
        """delete_revision_history  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_revision_history(cid, pnum, et, async_req=True)
        >>> result = thread.get()

        Args:
            cid (str):
            pnum (str):
            et (str):

        Keyword Args:
            ignore_linked_documents (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cid'] = \
            cid
        kwargs['pnum'] = \
            pnum
        kwargs['et'] = \
            et
        return self.delete_revision_history_endpoint.call_with_http_info(**kwargs)

    def enumerate_revisions(
        self,
        cid,
        **kwargs
    ):
        """enumerate_revisions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.enumerate_revisions(cid, async_req=True)
        >>> result = thread.get()

        Args:
            cid (str):

        Keyword Args:
            element_type (int): [optional]
            limit (int): [optional] if omitted the server will use the default value of 20
            offset (int): [optional] if omitted the server will use the default value of 0
            latest_only (bool): [optional] if omitted the server will use the default value of False
            after (datetime): [optional] if omitted the server will use the default value of dateutil_parser('2000-01-01T00:00:00Z')
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTListResponseBTRevisionInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cid'] = \
            cid
        return self.enumerate_revisions_endpoint.call_with_http_info(**kwargs)

    def get_latest_in_document_or_company(
        self,
        cd,
        cdid,
        pnum,
        et,
        **kwargs
    ):
        """get_latest_in_document_or_company  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_latest_in_document_or_company(cd, cdid, pnum, et, async_req=True)
        >>> result = thread.get()

        Args:
            cd (str):
            cdid (str):
            pnum (str):
            et (str): 0: Part Studio, 1: Assembly, 2: Drawing. 4: Blob

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTRevisionInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cd'] = \
            cd
        kwargs['cdid'] = \
            cdid
        kwargs['pnum'] = \
            pnum
        kwargs['et'] = \
            et
        return self.get_latest_in_document_or_company_endpoint.call_with_http_info(**kwargs)

    def get_revision_history_in_company_by_element_id(
        self,
        cid,
        did,
        wv,
        wvid,
        eid,
        element_type,
        **kwargs
    ):
        """get_revision_history_in_company_by_element_id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_revision_history_in_company_by_element_id(cid, did, wv, wvid, eid, element_type, async_req=True)
        >>> result = thread.get()

        Args:
            cid (str):
            did (str):
            wv (str):
            wvid (str):
            eid (str):
            element_type (str):

        Keyword Args:
            configuration (str): [optional]
            link_document_id (str): [optional]
            fill_approvers (bool): [optional] if omitted the server will use the default value of False
            fill_export_permission (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTRevisionListResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cid'] = \
            cid
        kwargs['did'] = \
            did
        kwargs['wv'] = \
            wv
        kwargs['wvid'] = \
            wvid
        kwargs['eid'] = \
            eid
        kwargs['element_type'] = \
            element_type
        return self.get_revision_history_in_company_by_element_id_endpoint.call_with_http_info(**kwargs)

    def get_revision_history_in_company_by_part_id(
        self,
        cid,
        did,
        wv,
        wvid,
        eid,
        pid,
        **kwargs
    ):
        """get_revision_history_in_company_by_part_id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_revision_history_in_company_by_part_id(cid, did, wv, wvid, eid, pid, async_req=True)
        >>> result = thread.get()

        Args:
            cid (str):
            did (str):
            wv (str):
            wvid (str):
            eid (str):
            pid (str):

        Keyword Args:
            configuration (str): [optional]
            link_document_id (str): [optional]
            fill_approvers (bool): [optional] if omitted the server will use the default value of False
            fill_export_permission (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTRevisionListResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cid'] = \
            cid
        kwargs['did'] = \
            did
        kwargs['wv'] = \
            wv
        kwargs['wvid'] = \
            wvid
        kwargs['eid'] = \
            eid
        kwargs['pid'] = \
            pid
        return self.get_revision_history_in_company_by_part_id_endpoint.call_with_http_info(**kwargs)

    def get_revision_history_in_company_by_part_number(
        self,
        cid,
        pnum,
        element_type,
        **kwargs
    ):
        """get_revision_history_in_company_by_part_number  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_revision_history_in_company_by_part_number(cid, pnum, element_type, async_req=True)
        >>> result = thread.get()

        Args:
            cid (str):
            pnum (str):
            element_type (str):

        Keyword Args:
            fill_approvers (bool): [optional] if omitted the server will use the default value of False
            fill_export_permission (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTRevisionListResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['cid'] = \
            cid
        kwargs['pnum'] = \
            pnum
        kwargs['element_type'] = \
            element_type
        return self.get_revision_history_in_company_by_part_number_endpoint.call_with_http_info(**kwargs)

