"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.api_client import ApiClient, Endpoint as _Endpoint
from onshape_client.oas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from onshape_client.oas.model.bt_list_response_bt_translation_request_info import BTListResponseBTTranslationRequestInfo
from onshape_client.oas.model.bt_model_format_full_info import BTModelFormatFullInfo
from onshape_client.oas.model.bt_translation_request_info import BTTranslationRequestInfo


class TranslationApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_translation_endpoint = _Endpoint(
            settings={
                'response_type': (BTTranslationRequestInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/translations/d/{did}/w/{wid}',
                'operation_id': 'create_translation',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'wid',
                    'file',
                    'allow_faulty_parts',
                    'create_composite',
                    'create_drawing_if_possible',
                    'encoded_filename',
                    'extract_assembly_hierarchy',
                    'flatten_assemblies',
                    'format_name',
                    'join_adjacent_surfaces',
                    'location_element_id',
                    'location_group_id',
                    'location_position',
                    'notify_user',
                    'owner_id',
                    'parent_id',
                    'project_id',
                    'public',
                    'one_part_per_doc',
                    'split_assemblies_into_multiple_documents',
                    'store_in_document',
                    'translate',
                    'unit',
                    'upload_id',
                    'version_string',
                    'y_axis_is_up',
                    'import_within_document',
                ],
                'required': [
                    'did',
                    'wid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'wid':
                        (str,),
                    'file':
                        ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                    'allow_faulty_parts':
                        (bool,),
                    'create_composite':
                        (bool,),
                    'create_drawing_if_possible':
                        (bool,),
                    'encoded_filename':
                        (str,),
                    'extract_assembly_hierarchy':
                        (bool,),
                    'flatten_assemblies':
                        (bool,),
                    'format_name':
                        (str,),
                    'join_adjacent_surfaces':
                        (bool,),
                    'location_element_id':
                        (str,),
                    'location_group_id':
                        (str,),
                    'location_position':
                        (int,),
                    'notify_user':
                        (bool,),
                    'owner_id':
                        (str,),
                    'parent_id':
                        (str,),
                    'project_id':
                        (str,),
                    'public':
                        (bool,),
                    'one_part_per_doc':
                        (bool,),
                    'split_assemblies_into_multiple_documents':
                        (bool,),
                    'store_in_document':
                        (bool,),
                    'translate':
                        (bool,),
                    'unit':
                        (str,),
                    'upload_id':
                        (str,),
                    'version_string':
                        (str,),
                    'y_axis_is_up':
                        (bool,),
                    'import_within_document':
                        (bool,),
                },
                'attribute_map': {
                    'did': 'did',
                    'wid': 'wid',
                    'file': 'file',
                    'allow_faulty_parts': 'allowFaultyParts',
                    'create_composite': 'createComposite',
                    'create_drawing_if_possible': 'createDrawingIfPossible',
                    'encoded_filename': 'encodedFilename',
                    'extract_assembly_hierarchy': 'extractAssemblyHierarchy',
                    'flatten_assemblies': 'flattenAssemblies',
                    'format_name': 'formatName',
                    'join_adjacent_surfaces': 'joinAdjacentSurfaces',
                    'location_element_id': 'locationElementId',
                    'location_group_id': 'locationGroupId',
                    'location_position': 'locationPosition',
                    'notify_user': 'notifyUser',
                    'owner_id': 'ownerId',
                    'parent_id': 'parentId',
                    'project_id': 'projectId',
                    'public': 'public',
                    'one_part_per_doc': 'onePartPerDoc',
                    'split_assemblies_into_multiple_documents': 'splitAssembliesIntoMultipleDocuments',
                    'store_in_document': 'storeInDocument',
                    'translate': 'translate',
                    'unit': 'unit',
                    'upload_id': 'uploadId',
                    'version_string': 'versionString',
                    'y_axis_is_up': 'yAxisIsUp',
                    'import_within_document': 'importWithinDocument',
                },
                'location_map': {
                    'did': 'path',
                    'wid': 'path',
                    'file': 'form',
                    'allow_faulty_parts': 'form',
                    'create_composite': 'form',
                    'create_drawing_if_possible': 'form',
                    'encoded_filename': 'form',
                    'extract_assembly_hierarchy': 'form',
                    'flatten_assemblies': 'form',
                    'format_name': 'form',
                    'join_adjacent_surfaces': 'form',
                    'location_element_id': 'form',
                    'location_group_id': 'form',
                    'location_position': 'form',
                    'notify_user': 'form',
                    'owner_id': 'form',
                    'parent_id': 'form',
                    'project_id': 'form',
                    'public': 'form',
                    'one_part_per_doc': 'form',
                    'split_assemblies_into_multiple_documents': 'form',
                    'store_in_document': 'form',
                    'translate': 'form',
                    'unit': 'form',
                    'upload_id': 'form',
                    'version_string': 'form',
                    'y_axis_is_up': 'form',
                    'import_within_document': 'form',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )
        self.delete_translation_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/translations/{tid}',
                'operation_id': 'delete_translation',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'tid',
                ],
                'required': [
                    'tid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tid':
                        (str,),
                },
                'attribute_map': {
                    'tid': 'tid',
                },
                'location_map': {
                    'tid': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_all_translator_formats_endpoint = _Endpoint(
            settings={
                'response_type': ([BTModelFormatFullInfo],),
                'auth': [
                    'BasicAuth'
                ],
                'endpoint_path': '/translations/translationformats',
                'operation_id': 'get_all_translator_formats',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_document_translations_endpoint = _Endpoint(
            settings={
                'response_type': (BTListResponseBTTranslationRequestInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/translations/d/{did}',
                'operation_id': 'get_document_translations',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'did',
                    'offset',
                    'limit',
                ],
                'required': [
                    'did',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'offset',
                    'limit',
                ]
            },
            root_map={
                'validations': {
                    ('offset',): {

                        'inclusive_minimum': 0,
                    },
                    ('limit',): {

                        'inclusive_maximum': 20,
                        'inclusive_minimum': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'did':
                        (str,),
                    'offset':
                        (int,),
                    'limit':
                        (int,),
                },
                'attribute_map': {
                    'did': 'did',
                    'offset': 'offset',
                    'limit': 'limit',
                },
                'location_map': {
                    'did': 'path',
                    'offset': 'query',
                    'limit': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_translation_endpoint = _Endpoint(
            settings={
                'response_type': (BTTranslationRequestInfo,),
                'auth': [
                    'BasicAuth',
                    'OAuth2'
                ],
                'endpoint_path': '/translations/{tid}',
                'operation_id': 'get_translation',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'tid',
                ],
                'required': [
                    'tid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tid':
                        (str,),
                },
                'attribute_map': {
                    'tid': 'tid',
                },
                'location_map': {
                    'tid': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/vnd.onshape.v2+json;charset=UTF-8;qs=0.2'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def create_translation(
        self,
        did,
        wid,
        **kwargs
    ):
        """Upload foreign data (for example, an X_T file) into Onshape, and then translate the data to generate a part, Part Studio, Assembly, or subassembly  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_translation(did, wid, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):
            wid (str):

        Keyword Args:
            file ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): The file to upload.. [optional]
            allow_faulty_parts (bool): [optional]
            create_composite (bool): [optional]
            create_drawing_if_possible (bool): [optional]
            encoded_filename (str): [optional]
            extract_assembly_hierarchy (bool): [optional]
            flatten_assemblies (bool): [optional]
            format_name (str): [optional]
            join_adjacent_surfaces (bool): [optional]
            location_element_id (str): [optional]
            location_group_id (str): [optional]
            location_position (int): [optional] if omitted the server will use the default value of -1
            notify_user (bool): [optional] if omitted the server will use the default value of True
            owner_id (str): [optional]
            parent_id (str): [optional]
            project_id (str): [optional]
            public (bool): [optional]
            one_part_per_doc (bool): [optional] if omitted the server will use the default value of False
            split_assemblies_into_multiple_documents (bool): [optional] if omitted the server will use the default value of False
            store_in_document (bool): [optional] if omitted the server will use the default value of True
            translate (bool): [optional] if omitted the server will use the default value of True
            unit (str): [optional] if omitted the server will use the default value of ""
            upload_id (str): [optional]
            version_string (str): [optional]
            y_axis_is_up (bool): [optional]
            import_within_document (bool): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTTranslationRequestInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        kwargs['wid'] = \
            wid
        return self.create_translation_endpoint.call_with_http_info(**kwargs)

    def delete_translation(
        self,
        tid,
        **kwargs
    ):
        """Delete translation status entry  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_translation(tid, async_req=True)
        >>> result = thread.get()

        Args:
            tid (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tid'] = \
            tid
        return self.delete_translation_endpoint.call_with_http_info(**kwargs)

    def get_all_translator_formats(
        self,
        **kwargs
    ):
        """Retrieve a list of translation formats. Some are valid only as an input format and cannot be used as an output format.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_all_translator_formats(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [BTModelFormatFullInfo]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.get_all_translator_formats_endpoint.call_with_http_info(**kwargs)

    def get_document_translations(
        self,
        did,
        **kwargs
    ):
        """Request a list of translations that were made against this document  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_document_translations(did, async_req=True)
        >>> result = thread.get()

        Args:
            did (str):

        Keyword Args:
            offset (int): [optional] if omitted the server will use the default value of 0
            limit (int): [optional] if omitted the server will use the default value of 20
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTListResponseBTTranslationRequestInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['did'] = \
            did
        return self.get_document_translations_endpoint.call_with_http_info(**kwargs)

    def get_translation(
        self,
        tid,
        **kwargs
    ):
        """Request information on an in-progress or completed translation  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_translation(tid, async_req=True)
        >>> result = thread.get()

        Args:
            tid (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BTTranslationRequestInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tid'] = \
            tid
        return self.get_translation_endpoint.call_with_http_info(**kwargs)

