"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError


def lazy_import():
    from onshape_client.oas.model.bt_assembly_feature_list_response1174 import BTAssemblyFeatureListResponse1174
    from onshape_client.oas.model.bt_assembly_feature_list_response1174_all_of import BTAssemblyFeatureListResponse1174AllOf
    from onshape_client.oas.model.bt_configuration_response2019 import BTConfigurationResponse2019
    from onshape_client.oas.model.bt_configuration_update_call2933 import BTConfigurationUpdateCall2933
    from onshape_client.oas.model.bt_feature_api_base1430 import BTFeatureApiBase1430
    from onshape_client.oas.model.bt_feature_definition_call1406 import BTFeatureDefinitionCall1406
    from onshape_client.oas.model.bt_feature_definition_response1617 import BTFeatureDefinitionResponse1617
    from onshape_client.oas.model.bt_feature_list_response2457 import BTFeatureListResponse2457
    from onshape_client.oas.model.bt_feature_script_eval_call2377 import BTFeatureScriptEvalCall2377
    from onshape_client.oas.model.bt_feature_script_eval_response1859 import BTFeatureScriptEvalResponse1859
    from onshape_client.oas.model.bt_feature_specs_response664 import BTFeatureSpecsResponse664
    from onshape_client.oas.model.bt_feature_state1688 import BTFeatureState1688
    from onshape_client.oas.model.bt_feature_studio_contents2239 import BTFeatureStudioContents2239
    from onshape_client.oas.model.bt_set_feature_rollback_call1899 import BTSetFeatureRollbackCall1899
    from onshape_client.oas.model.bt_set_feature_rollback_response1042 import BTSetFeatureRollbackResponse1042
    from onshape_client.oas.model.bt_update_features_call1748 import BTUpdateFeaturesCall1748
    from onshape_client.oas.model.bt_update_features_response1333 import BTUpdateFeaturesResponse1333
    from onshape_client.oas.model.btm_assembly_feature887 import BTMAssemblyFeature887
    globals()['BTAssemblyFeatureListResponse1174'] = BTAssemblyFeatureListResponse1174
    globals()['BTAssemblyFeatureListResponse1174AllOf'] = BTAssemblyFeatureListResponse1174AllOf
    globals()['BTConfigurationResponse2019'] = BTConfigurationResponse2019
    globals()['BTConfigurationUpdateCall2933'] = BTConfigurationUpdateCall2933
    globals()['BTFeatureApiBase1430'] = BTFeatureApiBase1430
    globals()['BTFeatureDefinitionCall1406'] = BTFeatureDefinitionCall1406
    globals()['BTFeatureDefinitionResponse1617'] = BTFeatureDefinitionResponse1617
    globals()['BTFeatureListResponse2457'] = BTFeatureListResponse2457
    globals()['BTFeatureScriptEvalCall2377'] = BTFeatureScriptEvalCall2377
    globals()['BTFeatureScriptEvalResponse1859'] = BTFeatureScriptEvalResponse1859
    globals()['BTFeatureSpecsResponse664'] = BTFeatureSpecsResponse664
    globals()['BTFeatureState1688'] = BTFeatureState1688
    globals()['BTFeatureStudioContents2239'] = BTFeatureStudioContents2239
    globals()['BTMAssemblyFeature887'] = BTMAssemblyFeature887
    globals()['BTSetFeatureRollbackCall1899'] = BTSetFeatureRollbackCall1899
    globals()['BTSetFeatureRollbackResponse1042'] = BTSetFeatureRollbackResponse1042
    globals()['BTUpdateFeaturesCall1748'] = BTUpdateFeaturesCall1748
    globals()['BTUpdateFeaturesResponse1333'] = BTUpdateFeaturesResponse1333


class BTAssemblyFeatureListResponse1174(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'bt_type': (str,),  # noqa: E501
            'feature_states': ({str: (BTFeatureState1688,)},),  # noqa: E501
            'features': ([BTMAssemblyFeature887],),  # noqa: E501
            'is_complete': (bool,),  # noqa: E501
            'library_version': (int,),  # noqa: E501
            'microversion_skew': (bool,),  # noqa: E501
            'reject_microversion_skew': (bool,),  # noqa: E501
            'serialization_version': (str,),  # noqa: E501
            'source_microversion': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        lazy_import()
        val = {
            'BTAssemblyFeatureListResponse-1174': BTAssemblyFeatureListResponse1174,
            'BTConfigurationResponse-2019': BTConfigurationResponse2019,
            'BTConfigurationUpdateCall-2933': BTConfigurationUpdateCall2933,
            'BTFeatureDefinitionCall-1406': BTFeatureDefinitionCall1406,
            'BTFeatureDefinitionResponse-1617': BTFeatureDefinitionResponse1617,
            'BTFeatureListResponse-2457': BTFeatureListResponse2457,
            'BTFeatureScriptEvalCall-2377': BTFeatureScriptEvalCall2377,
            'BTFeatureScriptEvalResponse-1859': BTFeatureScriptEvalResponse1859,
            'BTFeatureSpecsResponse-664': BTFeatureSpecsResponse664,
            'BTFeatureStudioContents-2239': BTFeatureStudioContents2239,
            'BTSetFeatureRollbackCall-1899': BTSetFeatureRollbackCall1899,
            'BTSetFeatureRollbackResponse-1042': BTSetFeatureRollbackResponse1042,
            'BTUpdateFeaturesCall-1748': BTUpdateFeaturesCall1748,
            'BTUpdateFeaturesResponse-1333': BTUpdateFeaturesResponse1333,
        }
        if not val:
            return None
        return {'bt_type': val}

    attribute_map = {
        'bt_type': 'btType',  # noqa: E501
        'feature_states': 'featureStates',  # noqa: E501
        'features': 'features',  # noqa: E501
        'is_complete': 'isComplete',  # noqa: E501
        'library_version': 'libraryVersion',  # noqa: E501
        'microversion_skew': 'microversionSkew',  # noqa: E501
        'reject_microversion_skew': 'rejectMicroversionSkew',  # noqa: E501
        'serialization_version': 'serializationVersion',  # noqa: E501
        'source_microversion': 'sourceMicroversion',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BTAssemblyFeatureListResponse1174 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            feature_states ({str: (BTFeatureState1688,)}): [optional]  # noqa: E501
            features ([BTMAssemblyFeature887]): [optional]  # noqa: E501
            is_complete (bool): [optional]  # noqa: E501
            library_version (int): [optional]  # noqa: E501
            microversion_skew (bool): [optional]  # noqa: E501
            reject_microversion_skew (bool): [optional]  # noqa: E501
            serialization_version (str): [optional]  # noqa: E501
            source_microversion (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BTAssemblyFeatureListResponse1174 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            feature_states ({str: (BTFeatureState1688,)}): [optional]  # noqa: E501
            features ([BTMAssemblyFeature887]): [optional]  # noqa: E501
            is_complete (bool): [optional]  # noqa: E501
            library_version (int): [optional]  # noqa: E501
            microversion_skew (bool): [optional]  # noqa: E501
            reject_microversion_skew (bool): [optional]  # noqa: E501
            serialization_version (str): [optional]  # noqa: E501
            source_microversion (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              BTAssemblyFeatureListResponse1174AllOf,
              BTFeatureApiBase1430,
          ],
          'oneOf': [
          ],
        }
