"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError



class BTInsertableInfo(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('body_type',): {
            'SOLID': "SOLID",
            'SHEET': "SHEET",
            'WIRE': "WIRE",
            'POINT': "POINT",
            'MATE_CONNECTOR': "MATE_CONNECTOR",
            'COMPOSITE': "COMPOSITE",
            'UNKNOWN': "UNKNOWN",
        },
        ('element_type',): {
            'PARTSTUDIO': "PARTSTUDIO",
            'ASSEMBLY': "ASSEMBLY",
            'DRAWING': "DRAWING",
            'FEATURESTUDIO': "FEATURESTUDIO",
            'BLOB': "BLOB",
            'APPLICATION': "APPLICATION",
            'TABLE': "TABLE",
            'BILLOFMATERIALS': "BILLOFMATERIALS",
            'UNKNOWN': "UNKNOWN",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'body_type': (str,),  # noqa: E501
            'class_type': (int,),  # noqa: E501
            'configuration_id': (str,),  # noqa: E501
            'configuration_parameter_values': ([str],),  # noqa: E501
            'configuration_parameters': ([str],),  # noqa: E501
            'data_type': (str,),  # noqa: E501
            'deterministic_id': (str,),  # noqa: E501
            'document_id': (str,),  # noqa: E501
            'element_id': (str,),  # noqa: E501
            'element_name': (str,),  # noqa: E501
            'element_type': (str,),  # noqa: E501
            'feature_id': (str,),  # noqa: E501
            'feature_name': (str,),  # noqa: E501
            'feature_spec': ([str],),  # noqa: E501
            'feature_type': (str,),  # noqa: E501
            'fs_computed_part_property_spec': ([str],),  # noqa: E501
            'fs_table_spec': ([str],),  # noqa: E501
            'has_faults': (bool,),  # noqa: E501
            'href': (str,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'insertable_query': (str,),  # noqa: E501
            'is_flattened_body': (bool,),  # noqa: E501
            'is_mesh': (bool,),  # noqa: E501
            'microversion_id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'parent_id': (str,),  # noqa: E501
            'part_identity': (str,),  # noqa: E501
            'part_name': (str,),  # noqa: E501
            'predictable_thumbnail_id': (str,),  # noqa: E501
            'thumbnail_uri': (str,),  # noqa: E501
            'unflattened_part_deterministic_id': (str,),  # noqa: E501
            'variable_name': (str,),  # noqa: E501
            'version_id': (str,),  # noqa: E501
            'version_name': (str,),  # noqa: E501
            'view_ref': (str,),  # noqa: E501
            'workspace_id': (str,),  # noqa: E501
            'workspace_name': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'body_type': 'bodyType',  # noqa: E501
        'class_type': 'classType',  # noqa: E501
        'configuration_id': 'configurationId',  # noqa: E501
        'configuration_parameter_values': 'configurationParameterValues',  # noqa: E501
        'configuration_parameters': 'configurationParameters',  # noqa: E501
        'data_type': 'dataType',  # noqa: E501
        'deterministic_id': 'deterministicId',  # noqa: E501
        'document_id': 'documentId',  # noqa: E501
        'element_id': 'elementId',  # noqa: E501
        'element_name': 'elementName',  # noqa: E501
        'element_type': 'elementType',  # noqa: E501
        'feature_id': 'featureId',  # noqa: E501
        'feature_name': 'featureName',  # noqa: E501
        'feature_spec': 'featureSpec',  # noqa: E501
        'feature_type': 'featureType',  # noqa: E501
        'fs_computed_part_property_spec': 'fsComputedPartPropertySpec',  # noqa: E501
        'fs_table_spec': 'fsTableSpec',  # noqa: E501
        'has_faults': 'hasFaults',  # noqa: E501
        'href': 'href',  # noqa: E501
        'id': 'id',  # noqa: E501
        'insertable_query': 'insertableQuery',  # noqa: E501
        'is_flattened_body': 'isFlattenedBody',  # noqa: E501
        'is_mesh': 'isMesh',  # noqa: E501
        'microversion_id': 'microversionId',  # noqa: E501
        'name': 'name',  # noqa: E501
        'parent_id': 'parentId',  # noqa: E501
        'part_identity': 'partIdentity',  # noqa: E501
        'part_name': 'partName',  # noqa: E501
        'predictable_thumbnail_id': 'predictableThumbnailId',  # noqa: E501
        'thumbnail_uri': 'thumbnailUri',  # noqa: E501
        'unflattened_part_deterministic_id': 'unflattenedPartDeterministicId',  # noqa: E501
        'variable_name': 'variableName',  # noqa: E501
        'version_id': 'versionId',  # noqa: E501
        'version_name': 'versionName',  # noqa: E501
        'view_ref': 'viewRef',  # noqa: E501
        'workspace_id': 'workspaceId',  # noqa: E501
        'workspace_name': 'workspaceName',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BTInsertableInfo - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            body_type (str): [optional]  # noqa: E501
            class_type (int): [optional]  # noqa: E501
            configuration_id (str): [optional]  # noqa: E501
            configuration_parameter_values ([str]): [optional]  # noqa: E501
            configuration_parameters ([str]): [optional]  # noqa: E501
            data_type (str): [optional]  # noqa: E501
            deterministic_id (str): [optional]  # noqa: E501
            document_id (str): [optional]  # noqa: E501
            element_id (str): [optional]  # noqa: E501
            element_name (str): [optional]  # noqa: E501
            element_type (str): [optional]  # noqa: E501
            feature_id (str): [optional]  # noqa: E501
            feature_name (str): [optional]  # noqa: E501
            feature_spec ([str]): [optional]  # noqa: E501
            feature_type (str): [optional]  # noqa: E501
            fs_computed_part_property_spec ([str]): [optional]  # noqa: E501
            fs_table_spec ([str]): [optional]  # noqa: E501
            has_faults (bool): [optional]  # noqa: E501
            href (str): [optional]  # noqa: E501
            id (str): [optional]  # noqa: E501
            insertable_query (str): [optional]  # noqa: E501
            is_flattened_body (bool): [optional]  # noqa: E501
            is_mesh (bool): [optional]  # noqa: E501
            microversion_id (str): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            parent_id (str): [optional]  # noqa: E501
            part_identity (str): [optional]  # noqa: E501
            part_name (str): [optional]  # noqa: E501
            predictable_thumbnail_id (str): [optional]  # noqa: E501
            thumbnail_uri (str): [optional]  # noqa: E501
            unflattened_part_deterministic_id (str): [optional]  # noqa: E501
            variable_name (str): [optional]  # noqa: E501
            version_id (str): [optional]  # noqa: E501
            version_name (str): [optional]  # noqa: E501
            view_ref (str): [optional]  # noqa: E501
            workspace_id (str): [optional]  # noqa: E501
            workspace_name (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BTInsertableInfo - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            body_type (str): [optional]  # noqa: E501
            class_type (int): [optional]  # noqa: E501
            configuration_id (str): [optional]  # noqa: E501
            configuration_parameter_values ([str]): [optional]  # noqa: E501
            configuration_parameters ([str]): [optional]  # noqa: E501
            data_type (str): [optional]  # noqa: E501
            deterministic_id (str): [optional]  # noqa: E501
            document_id (str): [optional]  # noqa: E501
            element_id (str): [optional]  # noqa: E501
            element_name (str): [optional]  # noqa: E501
            element_type (str): [optional]  # noqa: E501
            feature_id (str): [optional]  # noqa: E501
            feature_name (str): [optional]  # noqa: E501
            feature_spec ([str]): [optional]  # noqa: E501
            feature_type (str): [optional]  # noqa: E501
            fs_computed_part_property_spec ([str]): [optional]  # noqa: E501
            fs_table_spec ([str]): [optional]  # noqa: E501
            has_faults (bool): [optional]  # noqa: E501
            href (str): [optional]  # noqa: E501
            id (str): [optional]  # noqa: E501
            insertable_query (str): [optional]  # noqa: E501
            is_flattened_body (bool): [optional]  # noqa: E501
            is_mesh (bool): [optional]  # noqa: E501
            microversion_id (str): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            parent_id (str): [optional]  # noqa: E501
            part_identity (str): [optional]  # noqa: E501
            part_name (str): [optional]  # noqa: E501
            predictable_thumbnail_id (str): [optional]  # noqa: E501
            thumbnail_uri (str): [optional]  # noqa: E501
            unflattened_part_deterministic_id (str): [optional]  # noqa: E501
            variable_name (str): [optional]  # noqa: E501
            version_id (str): [optional]  # noqa: E501
            version_name (str): [optional]  # noqa: E501
            view_ref (str): [optional]  # noqa: E501
            workspace_id (str): [optional]  # noqa: E501
            workspace_name (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
