"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError


def lazy_import():
    from onshape_client.oas.model.bt_assembly_instance947 import BTAssemblyInstance947
    from onshape_client.oas.model.bt_document_with_version_and_element_id import BTDocumentWithVersionAndElementId
    from onshape_client.oas.model.bt_document_with_version_id import BTDocumentWithVersionId
    from onshape_client.oas.model.bt_element_reference725 import BTElementReference725
    from onshape_client.oas.model.bt_instance642_all_of import BTInstance642AllOf
    from onshape_client.oas.model.bt_instance_base2263 import BTInstanceBase2263
    from onshape_client.oas.model.bt_microversion_id366 import BTMicroversionId366
    from onshape_client.oas.model.bt_part_instance81 import BTPartInstance81
    from onshape_client.oas.model.bt_reference_custom_data1551 import BTReferenceCustomData1551
    from onshape_client.oas.model.bt_revision_custom_data2090 import BTRevisionCustomData2090
    from onshape_client.oas.model.btm_parameter1 import BTMParameter1
    from onshape_client.oas.model.btm_parameter_reference_with_configuration3028 import BTMParameterReferenceWithConfiguration3028
    from onshape_client.oas.model.btm_suppression_state1924 import BTMSuppressionState1924
    globals()['BTAssemblyInstance947'] = BTAssemblyInstance947
    globals()['BTDocumentWithVersionAndElementId'] = BTDocumentWithVersionAndElementId
    globals()['BTDocumentWithVersionId'] = BTDocumentWithVersionId
    globals()['BTElementReference725'] = BTElementReference725
    globals()['BTInstance642AllOf'] = BTInstance642AllOf
    globals()['BTInstanceBase2263'] = BTInstanceBase2263
    globals()['BTMParameter1'] = BTMParameter1
    globals()['BTMParameterReferenceWithConfiguration3028'] = BTMParameterReferenceWithConfiguration3028
    globals()['BTMSuppressionState1924'] = BTMSuppressionState1924
    globals()['BTMicroversionId366'] = BTMicroversionId366
    globals()['BTPartInstance81'] = BTPartInstance81
    globals()['BTReferenceCustomData1551'] = BTReferenceCustomData1551
    globals()['BTRevisionCustomData2090'] = BTRevisionCustomData2090


class BTInstance642(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'bt_type': (str,),  # noqa: E501
            'configuration': ([BTMParameter1],),  # noqa: E501
            'configured': (bool,),  # noqa: E501
            'document_id': (str,),  # noqa: E501
            'element_id': (str,),  # noqa: E501
            'element_reference': (BTElementReference725,),  # noqa: E501
            'external_document_with_version': (BTDocumentWithVersionId,),  # noqa: E501
            'external_document_with_version_and_element_id': (BTDocumentWithVersionAndElementId,),  # noqa: E501
            'locked_state': (BTMParameter1,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'parameters': ([BTMParameter1],),  # noqa: E501
            'reference_parameter': (BTMParameterReferenceWithConfiguration3028,),  # noqa: E501
            'version_id': (str,),  # noqa: E501
            'version_id_if_external': (str,),  # noqa: E501
            'import_microversion': (str,),  # noqa: E501
            'node_id': (str,),  # noqa: E501
            'assembly_instance': (bool,),  # noqa: E501
            'assembly_pattern': (bool,),  # noqa: E501
            'assembly_replicate': (bool,),  # noqa: E501
            'cloned_instance': (bool,),  # noqa: E501
            'custom_data': ({str: (BTReferenceCustomData1551,)},),  # noqa: E501
            'instance_folder': (bool,),  # noqa: E501
            'instance_name': (str,),  # noqa: E501
            'is_flattened_part': (bool,),  # noqa: E501
            'locked': (bool,),  # noqa: E501
            'microversion_id': (BTMicroversionId366,),  # noqa: E501
            'parametric_instance': (bool,),  # noqa: E501
            'part_instance': (bool,),  # noqa: E501
            'revision_custom_data': (BTRevisionCustomData2090,),  # noqa: E501
            'standard_content': (bool,),  # noqa: E501
            'standard_content_parameters_id': (str,),  # noqa: E501
            'suppressed': (bool,),  # noqa: E501
            'suppressed_field_index': (int,),  # noqa: E501
            'suppression_configured': (bool,),  # noqa: E501
            'suppression_state': (BTMSuppressionState1924,),  # noqa: E501
            'valid_revision_reference': (bool,),  # noqa: E501
            'version': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        lazy_import()
        val = {
            'BTAssemblyInstance-947': BTAssemblyInstance947,
            'BTPartInstance-81': BTPartInstance81,
        }
        if not val:
            return None
        return {'bt_type': val}

    attribute_map = {
        'bt_type': 'btType',  # noqa: E501
        'configuration': 'configuration',  # noqa: E501
        'configured': 'configured',  # noqa: E501
        'document_id': 'documentId',  # noqa: E501
        'element_id': 'elementId',  # noqa: E501
        'element_reference': 'elementReference',  # noqa: E501
        'external_document_with_version': 'externalDocumentWithVersion',  # noqa: E501
        'external_document_with_version_and_element_id': 'externalDocumentWithVersionAndElementId',  # noqa: E501
        'locked_state': 'lockedState',  # noqa: E501
        'name': 'name',  # noqa: E501
        'parameters': 'parameters',  # noqa: E501
        'reference_parameter': 'referenceParameter',  # noqa: E501
        'version_id': 'versionId',  # noqa: E501
        'version_id_if_external': 'versionIdIfExternal',  # noqa: E501
        'import_microversion': 'importMicroversion',  # noqa: E501
        'node_id': 'nodeId',  # noqa: E501
        'assembly_instance': 'assemblyInstance',  # noqa: E501
        'assembly_pattern': 'assemblyPattern',  # noqa: E501
        'assembly_replicate': 'assemblyReplicate',  # noqa: E501
        'cloned_instance': 'clonedInstance',  # noqa: E501
        'custom_data': 'customData',  # noqa: E501
        'instance_folder': 'instanceFolder',  # noqa: E501
        'instance_name': 'instanceName',  # noqa: E501
        'is_flattened_part': 'isFlattenedPart',  # noqa: E501
        'locked': 'locked',  # noqa: E501
        'microversion_id': 'microversionId',  # noqa: E501
        'parametric_instance': 'parametricInstance',  # noqa: E501
        'part_instance': 'partInstance',  # noqa: E501
        'revision_custom_data': 'revisionCustomData',  # noqa: E501
        'standard_content': 'standardContent',  # noqa: E501
        'standard_content_parameters_id': 'standardContentParametersId',  # noqa: E501
        'suppressed': 'suppressed',  # noqa: E501
        'suppressed_field_index': 'suppressedFieldIndex',  # noqa: E501
        'suppression_configured': 'suppressionConfigured',  # noqa: E501
        'suppression_state': 'suppressionState',  # noqa: E501
        'valid_revision_reference': 'validRevisionReference',  # noqa: E501
        'version': 'version',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BTInstance642 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            configuration ([BTMParameter1]): [optional]  # noqa: E501
            configured (bool): [optional]  # noqa: E501
            document_id (str): [optional]  # noqa: E501
            element_id (str): [optional]  # noqa: E501
            element_reference (BTElementReference725): [optional]  # noqa: E501
            external_document_with_version (BTDocumentWithVersionId): [optional]  # noqa: E501
            external_document_with_version_and_element_id (BTDocumentWithVersionAndElementId): [optional]  # noqa: E501
            locked_state (BTMParameter1): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            parameters ([BTMParameter1]): [optional]  # noqa: E501
            reference_parameter (BTMParameterReferenceWithConfiguration3028): [optional]  # noqa: E501
            version_id (str): [optional]  # noqa: E501
            version_id_if_external (str): [optional]  # noqa: E501
            import_microversion (str): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            assembly_instance (bool): [optional]  # noqa: E501
            assembly_pattern (bool): [optional]  # noqa: E501
            assembly_replicate (bool): [optional]  # noqa: E501
            cloned_instance (bool): [optional]  # noqa: E501
            custom_data ({str: (BTReferenceCustomData1551,)}): [optional]  # noqa: E501
            instance_folder (bool): [optional]  # noqa: E501
            instance_name (str): [optional]  # noqa: E501
            is_flattened_part (bool): [optional]  # noqa: E501
            locked (bool): [optional]  # noqa: E501
            microversion_id (BTMicroversionId366): [optional]  # noqa: E501
            parametric_instance (bool): [optional]  # noqa: E501
            part_instance (bool): [optional]  # noqa: E501
            revision_custom_data (BTRevisionCustomData2090): [optional]  # noqa: E501
            standard_content (bool): [optional]  # noqa: E501
            standard_content_parameters_id (str): [optional]  # noqa: E501
            suppressed (bool): [optional]  # noqa: E501
            suppressed_field_index (int): [optional]  # noqa: E501
            suppression_configured (bool): [optional]  # noqa: E501
            suppression_state (BTMSuppressionState1924): [optional]  # noqa: E501
            valid_revision_reference (bool): [optional]  # noqa: E501
            version (int): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BTInstance642 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            configuration ([BTMParameter1]): [optional]  # noqa: E501
            configured (bool): [optional]  # noqa: E501
            document_id (str): [optional]  # noqa: E501
            element_id (str): [optional]  # noqa: E501
            element_reference (BTElementReference725): [optional]  # noqa: E501
            external_document_with_version (BTDocumentWithVersionId): [optional]  # noqa: E501
            external_document_with_version_and_element_id (BTDocumentWithVersionAndElementId): [optional]  # noqa: E501
            locked_state (BTMParameter1): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            parameters ([BTMParameter1]): [optional]  # noqa: E501
            reference_parameter (BTMParameterReferenceWithConfiguration3028): [optional]  # noqa: E501
            version_id (str): [optional]  # noqa: E501
            version_id_if_external (str): [optional]  # noqa: E501
            import_microversion (str): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            assembly_instance (bool): [optional]  # noqa: E501
            assembly_pattern (bool): [optional]  # noqa: E501
            assembly_replicate (bool): [optional]  # noqa: E501
            cloned_instance (bool): [optional]  # noqa: E501
            custom_data ({str: (BTReferenceCustomData1551,)}): [optional]  # noqa: E501
            instance_folder (bool): [optional]  # noqa: E501
            instance_name (str): [optional]  # noqa: E501
            is_flattened_part (bool): [optional]  # noqa: E501
            locked (bool): [optional]  # noqa: E501
            microversion_id (BTMicroversionId366): [optional]  # noqa: E501
            parametric_instance (bool): [optional]  # noqa: E501
            part_instance (bool): [optional]  # noqa: E501
            revision_custom_data (BTRevisionCustomData2090): [optional]  # noqa: E501
            standard_content (bool): [optional]  # noqa: E501
            standard_content_parameters_id (str): [optional]  # noqa: E501
            suppressed (bool): [optional]  # noqa: E501
            suppressed_field_index (int): [optional]  # noqa: E501
            suppression_configured (bool): [optional]  # noqa: E501
            suppression_state (BTMSuppressionState1924): [optional]  # noqa: E501
            valid_revision_reference (bool): [optional]  # noqa: E501
            version (int): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              BTInstance642AllOf,
              BTInstanceBase2263,
          ],
          'oneOf': [
          ],
        }
