"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError


def lazy_import():
    from onshape_client.oas.model.bt_cache_data_path191 import BTCacheDataPath191
    from onshape_client.oas.model.bt_default_features119 import BTDefaultFeatures119
    from onshape_client.oas.model.bt_import import BTImport
    from onshape_client.oas.model.bt_model_properties1258 import BTModelProperties1258
    from onshape_client.oas.model.bt_part_properties293 import BTPartProperties293
    from onshape_client.oas.model.btm_configuration_data1560 import BTMConfigurationData1560
    from onshape_client.oas.model.btm_feature134 import BTMFeature134
    from onshape_client.oas.model.btm_import136 import BTMImport136
    from onshape_client.oas.model.btm_node19 import BTMNode19
    from onshape_client.oas.model.btm_rollback150 import BTMRollback150
    from onshape_client.oas.model.btm_units_default160 import BTMUnitsDefault160
    from onshape_client.oas.model.btm_variable_studio_reference2764 import BTMVariableStudioReference2764
    from onshape_client.oas.model.btp_module_id235 import BTPModuleId235
    globals()['BTCacheDataPath191'] = BTCacheDataPath191
    globals()['BTDefaultFeatures119'] = BTDefaultFeatures119
    globals()['BTImport'] = BTImport
    globals()['BTMConfigurationData1560'] = BTMConfigurationData1560
    globals()['BTMFeature134'] = BTMFeature134
    globals()['BTMImport136'] = BTMImport136
    globals()['BTMNode19'] = BTMNode19
    globals()['BTMRollback150'] = BTMRollback150
    globals()['BTMUnitsDefault160'] = BTMUnitsDefault160
    globals()['BTMVariableStudioReference2764'] = BTMVariableStudioReference2764
    globals()['BTModelProperties1258'] = BTModelProperties1258
    globals()['BTPModuleId235'] = BTPModuleId235
    globals()['BTPartProperties293'] = BTPartProperties293


class BTMModel141(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('bel_script_library_version_enum',): {
            'V0_ORIGINAL_VERSION': "V0_ORIGINAL_VERSION",
            'V1_SKETCH_DIRECTED_DIMENSIONS': "V1_SKETCH_DIRECTED_DIMENSIONS",
            'V2_DCM_VERSION_63_3': "V2_DCM_VERSION_63_3",
            'V3_SWEEP_GRID_TOPOLOGY_WITH_REMOVE_REDUNDANT': "V3_SWEEP_GRID_TOPOLOGY_WITH_REMOVE_REDUNDANT",
            'V4_DCM_VERSION_63_3_1': "V4_DCM_VERSION_63_3_1",
            'V5_IMPRINT_USE_MIN_DET_ID_IN_IMPRINTS': "V5_IMPRINT_USE_MIN_DET_ID_IN_IMPRINTS",
            'V6_SKETCH_DIAMETRAL_DIMENSIONS': "V6_SKETCH_DIAMETRAL_DIMENSIONS",
            'V7_PS_VERSION_27_0_161': "V7_PS_VERSION_27_0_161",
            'V8_DRAFT_LAMINAR_EDGE_DRAW': "V8_DRAFT_LAMINAR_EDGE_DRAW",
            'V9_REVOLVE_PLACEHOLDER_FEATURESCRIPT_ONLY_CHANGE': "V9_REVOLVE_PLACEHOLDER_FEATURESCRIPT_ONLY_CHANGE",
            'V10_SWEEP_PROFILE_START_VERTEX': "V10_SWEEP_PROFILE_START_VERTEX",
            'V11_SKETCH_ENFORCE_CENTRIPETAL_KNOTS': "V11_SKETCH_ENFORCE_CENTRIPETAL_KNOTS",
            'V12_SKETCH_PROJECTED_ENDS': "V12_SKETCH_PROJECTED_ENDS",
            'V13_SKETCH_SPECIFIC_CIRCLE_AND_ARC_PROJECTIONS': "V13_SKETCH_SPECIFIC_CIRCLE_AND_ARC_PROJECTIONS",
            'V14_SPLIT_ERROR_STATUS_CHECK': "V14_SPLIT_ERROR_STATUS_CHECK",
            'V15_PATTERN_CHECK_FOR_BAD_HISTORY_RECORDS': "V15_PATTERN_CHECK_FOR_BAD_HISTORY_RECORDS",
            'V16_SKETCH_TOOL_TYPES': "V16_SKETCH_TOOL_TYPES",
            'V17_PS_VERSION_27_0_178': "V17_PS_VERSION_27_0_178",
            'V18_STRICTER_DISAMBIGUATION_IN_EXACT_MATCH_QUERY_EVAL': "V18_STRICTER_DISAMBIGUATION_IN_EXACT_MATCH_QUERY_EVAL",
            'V19_BLEND_UNIQUE_SET_OF_DEPENDENCIES_IN_BLENDED_RECORD_FIXED': "V19_BLEND_UNIQUE_SET_OF_DEPENDENCIES_IN_BLENDED_RECORD_FIXED",
            'V20_DCM_VERSION_63_3_2': "V20_DCM_VERSION_63_3_2",
            'V21_CREATION_RECORD_COMPARISON_DEPENDENCIES_FIRST': "V21_CREATION_RECORD_COMPARISON_DEPENDENCIES_FIRST",
            'V22_SWEEP_ORDER_BEFORE_REMOVE_REDUNDANT': "V22_SWEEP_ORDER_BEFORE_REMOVE_REDUNDANT",
            'V23_PROCEDURAL_SWEPT_SURFACES': "V23_PROCEDURAL_SWEPT_SURFACES",
            'V24_SWEPTFEATURETRACKER_UPDATE_FIX': "V24_SWEPTFEATURETRACKER_UPDATE_FIX",
            'V25_BLEND_PROCESS_RECORDS_AFTER_MERGE': "V25_BLEND_PROCESS_RECORDS_AFTER_MERGE",
            'V26_SWEPTFEATURETRACKER_TWEAK_RECORDS': "V26_SWEPTFEATURETRACKER_TWEAK_RECORDS",
            'V27_SKETCH_ALLOW_IMPRINT_OF_FACES_ONLY': "V27_SKETCH_ALLOW_IMPRINT_OF_FACES_ONLY",
            'V28_SKETCH_FLAG_UNSOLVABLE_CONSTRAINTS': "V28_SKETCH_FLAG_UNSOLVABLE_CONSTRAINTS",
            'V29_DCM_VERSION_63_3_4': "V29_DCM_VERSION_63_3_4",
            'V30_BOOLEAN_COPY_RECORDS_FOR_TOOL_DERIVED': "V30_BOOLEAN_COPY_RECORDS_FOR_TOOL_DERIVED",
            'V31_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY': "V31_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY",
            'V32_AXIS_NEAR_BBOX_CENTER': "V32_AXIS_NEAR_BBOX_CENTER",
            'V33_SUPPRESSED_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY': "V33_SUPPRESSED_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY",
            'V34_NEW_VERSIONING_SCHEME': "V34_NEW_VERSIONING_SCHEME",
            'V35_NESTED_PROFILES': "V35_NESTED_PROFILES",
            'V36_INVALID': "V36_INVALID",
            'V37_INVALID': "V37_INVALID",
            'V38_INVALID': "V38_INVALID",
            'V39_INVALID': "V39_INVALID",
            'V40_INVALID': "V40_INVALID",
            'V41_INVALID': "V41_INVALID",
            'V42_INVALID': "V42_INVALID",
            'V43_INVALID': "V43_INVALID",
            'V44_INVALID': "V44_INVALID",
            'V45_INVALID': "V45_INVALID",
            'V46_NEW_VERSION_NUMBERING_SCHEME': "V46_NEW_VERSION_NUMBERING_SCHEME",
            'V47_FEATURE_SPECIFIC_VERSIONING': "V47_FEATURE_SPECIFIC_VERSIONING",
            'V48_JOURNAL_FAILING_FEATURES': "V48_JOURNAL_FAILING_FEATURES",
            'V49_EDGE_BLEND_SURF_INTERSECTION_CHECK': "V49_EDGE_BLEND_SURF_INTERSECTION_CHECK",
            'V50_HELIX': "V50_HELIX",
            'V51_RESUME_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY': "V51_RESUME_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY",
            'V52_CREATE_EMPTY_BOOLEAN_RECORDS': "V52_CREATE_EMPTY_BOOLEAN_RECORDS",
            'V53_ENFORCE_PRECONDITIONS': "V53_ENFORCE_PRECONDITIONS",
            'V54_RESUME_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY': "V54_RESUME_PROFILES_FROM_SKETCH_TRACKED_VIA_BOUNDARY",
            'V55_SUPPORT_EXPRESSIONS': "V55_SUPPORT_EXPRESSIONS",
            'V56_FIX_UP_UNITS': "V56_FIX_UP_UNITS",
            'V57_FIX_RADIAN_VALUE_BOUNDS': "V57_FIX_RADIAN_VALUE_BOUNDS",
            'V58_HELIX_DIRECTION': "V58_HELIX_DIRECTION",
            'V59_TRIG_FUNCTIONS_AND_DRAFT': "V59_TRIG_FUNCTIONS_AND_DRAFT",
            'V60_TRANSFORM_PART': "V60_TRANSFORM_PART",
            'V61_DCM_VERSION_63_3_6': "V61_DCM_VERSION_63_3_6",
            'V62_FACE_OPERATIONS_MODIFY_CHECK_TYPE': "V62_FACE_OPERATIONS_MODIFY_CHECK_TYPE",
            'V63_NEW_CHAMFER_TYPES': "V63_NEW_CHAMFER_TYPES",
            'V64_FIXED_CHAMFER_PRECONDITION': "V64_FIXED_CHAMFER_PRECONDITION",
            'V65_UPTO_NEXT_TARGETS_ONLY': "V65_UPTO_NEXT_TARGETS_ONLY",
            'V66_CHAMFER_RANGE_AND_UNDO_UPTO_NEXT': "V66_CHAMFER_RANGE_AND_UNDO_UPTO_NEXT",
            'V67_THICKEN': "V67_THICKEN",
            'V68_TRANSFORM_MANIPULATORS': "V68_TRANSFORM_MANIPULATORS",
            'V69_IMPRINTED_EDGE_DIRECTION': "V69_IMPRINTED_EDGE_DIRECTION",
            'V70_SKETCH_POLYGON': "V70_SKETCH_POLYGON",
            'V71_SKETCH_REGION_QUERY_UPDATE': "V71_SKETCH_REGION_QUERY_UPDATE",
            'V72_EXPERIMENT': "V72_EXPERIMENT",
            'V73_CHAMFER_THICKEN_FS_BUGS': "V73_CHAMFER_THICKEN_FS_BUGS",
            'V74_TRANSFORM_CHECKING': "V74_TRANSFORM_CHECKING",
            'V75_THICKEN_ENCHANCEMENTS': "V75_THICKEN_ENCHANCEMENTS",
            'V76_RETRIEVAL_UPGRADE': "V76_RETRIEVAL_UPGRADE",
            'V77_MINOR_FS_BUGS': "V77_MINOR_FS_BUGS",
            'V78_DCM_VERSION_64_0_0': "V78_DCM_VERSION_64_0_0",
            'V79_FILTER_FILLETS_FROM_MOVE_FACE': "V79_FILTER_FILLETS_FROM_MOVE_FACE",
            'V80_TRANSFORM_TRIAD': "V80_TRANSFORM_TRIAD",
            'V81_VARIABLES_SHADOW_FUNCTIONS': "V81_VARIABLES_SHADOW_FUNCTIONS",
            'V82_FILTER_FILLETS_FROM_DIRECT_EDIT_OPS': "V82_FILTER_FILLETS_FROM_DIRECT_EDIT_OPS",
            'V83_HIDE_PLANE_SIZE': "V83_HIDE_PLANE_SIZE",
            'V84_IMPORT_Y_UP': "V84_IMPORT_Y_UP",
            'V85_IMPORT_FS_TEST': "V85_IMPORT_FS_TEST",
            'V86_IMPORT_PARAMETER_FIX': "V86_IMPORT_PARAMETER_FIX",
            'V87_SKETCH_REGION_ORDERING': "V87_SKETCH_REGION_ORDERING",
            'V88_FILLET_SELECTION_TYPO': "V88_FILLET_SELECTION_TYPO",
            'V89_ARGUMENT_DEPENDENT_LOOKUP': "V89_ARGUMENT_DEPENDENT_LOOKUP",
            'V90_DEFINE_FEATURE': "V90_DEFINE_FEATURE",
            'V91_PS27_1_165': "V91_PS27_1_165",
            'V92_ERROR_PARAMETERS': "V92_ERROR_PARAMETERS",
            'V93_FACE_MIRROR': "V93_FACE_MIRROR",
            'V94_TRACK_TWEAK_EDGES_BY_TWEAK_FACE_DEPENDENCIES': "V94_TRACK_TWEAK_EDGES_BY_TWEAK_FACE_DEPENDENCIES",
            'V95_DCM_VERSION_64_3_0': "V95_DCM_VERSION_64_3_0",
            'V96_BOOLEAN_OFFSET': "V96_BOOLEAN_OFFSET",
            'V97_LESS_APPROXIMATE_SPLINE_ENDS': "V97_LESS_APPROXIMATE_SPLINE_ENDS",
            'V98_PIERCE_CONSTRAINT': "V98_PIERCE_CONSTRAINT",
            'V99_MIRROR_ERROR_FIX': "V99_MIRROR_ERROR_FIX",
            'V100_BOOLEAN_OFFSET_NO_FACE_ERROR': "V100_BOOLEAN_OFFSET_NO_FACE_ERROR",
            'V101_RETRIEVAL_UPGRADE': "V101_RETRIEVAL_UPGRADE",
            'V102_DUMMY': "V102_DUMMY",
            'V103_BOOLEAN_OFFSET_ERROR_PROPAGATION': "V103_BOOLEAN_OFFSET_ERROR_PROPAGATION",
            'V104_DRAFT_CHECK_STEEP': "V104_DRAFT_CHECK_STEEP",
            'V105_ANGULAR_MANIPULATOR_RANGE': "V105_ANGULAR_MANIPULATOR_RANGE",
            'V106_DIRECT_EDIT_IMPROVE_REDUNDANT_EDGE_REMOVAL': "V106_DIRECT_EDIT_IMPROVE_REDUNDANT_EDGE_REMOVAL",
            'V107_ENFORCE_MINIMUM_INTERPOLATED_KNOT_DISTANCE': "V107_ENFORCE_MINIMUM_INTERPOLATED_KNOT_DISTANCE",
            'V108_SWEEP_ALIGNMENT_OPTION': "V108_SWEEP_ALIGNMENT_OPTION",
            'V109_FIX_ROTATE_FACE_ZERO_LENGTH_MANIPULATOR': "V109_FIX_ROTATE_FACE_ZERO_LENGTH_MANIPULATOR",
            'V110_ANGULAR_MANIPULATOR_LIMIT_DEFAULTS': "V110_ANGULAR_MANIPULATOR_LIMIT_DEFAULTS",
            'V111_PREVENT_DUPLICATE_DET_IDS_ON_TWEAKED_TOPOLS': "V111_PREVENT_DUPLICATE_DET_IDS_ON_TWEAKED_TOPOLS",
            'V112_DEGENERATE_SKETCH_ENTITY_DISPLAY': "V112_DEGENERATE_SKETCH_ENTITY_DISPLAY",
            'V113_ALLOW_NEGATIVE_VALUES_IN_VECTOR_DEFINITIONS': "V113_ALLOW_NEGATIVE_VALUES_IN_VECTOR_DEFINITIONS",
            'V114_RESTRICT_MATECONNECTOR_OWNER_TO_ONE': "V114_RESTRICT_MATECONNECTOR_OWNER_TO_ONE",
            'V115_SKETCH_LINEAR_PATTERNS': "V115_SKETCH_LINEAR_PATTERNS",
            'V116_UI_HINT_ENUM': "V116_UI_HINT_ENUM",
            'V117_ERROR_CONTAINMENT': "V117_ERROR_CONTAINMENT",
            'V118_MORE_ACCURATE_HELIX': "V118_MORE_ACCURATE_HELIX",
            'V119_PATTERN_PRESELECTION_FIX': "V119_PATTERN_PRESELECTION_FIX",
            'V120_BOOLEAN_OFFSET_REAPPLY_FILLET': "V120_BOOLEAN_OFFSET_REAPPLY_FILLET",
            'V121_SKETCH_PIERCE_LOCATION_FIX': "V121_SKETCH_PIERCE_LOCATION_FIX",
            'V122_SKETCH_ELLIPSE': "V122_SKETCH_ELLIPSE",
            'V123_UNIFORM_SCALE': "V123_UNIFORM_SCALE",
            'V124_DELETE_IMPORTED_INSTANCE_FIX': "V124_DELETE_IMPORTED_INSTANCE_FIX",
            'V125_REMOVE_SCALE_MANIPULATOR': "V125_REMOVE_SCALE_MANIPULATOR",
            'V126_DCM_VERSION_64_3_1': "V126_DCM_VERSION_64_3_1",
            'V127_ELLIPSE_RADIUS_DIMENSIONS': "V127_ELLIPSE_RADIUS_DIMENSIONS",
            'V128_FIX_SPLIT_VERTEX_IMPRINT': "V128_FIX_SPLIT_VERTEX_IMPRINT",
            'V129_QUADRANT_CONSTRAINT': "V129_QUADRANT_CONSTRAINT",
            'V130_SKETCH_TEXT': "V130_SKETCH_TEXT",
            'V131_DIRECT_EDIT_PREVENT_EMPTY_SELECTION': "V131_DIRECT_EDIT_PREVENT_EMPTY_SELECTION",
            'V132_DCM_VERSION_64_3_2': "V132_DCM_VERSION_64_3_2",
            'V133_DIAMETER_CONSTRAINT': "V133_DIAMETER_CONSTRAINT",
            'V134_LOFT_SELECTION_FILTERS': "V134_LOFT_SELECTION_FILTERS",
            'V135_SECTION_PART_FIX': "V135_SECTION_PART_FIX",
            'V136_LOFT_ERRORS': "V136_LOFT_ERRORS",
            'V137_VERSION_HISTORY_ENTRY': "V137_VERSION_HISTORY_ENTRY",
            'V138_COEDGE_QUERIES': "V138_COEDGE_QUERIES",
            'V139_DIG_DEEPER_FOR_SKETCH_PLANE': "V139_DIG_DEEPER_FOR_SKETCH_PLANE",
            'V140_SKETCH_REGION_VIA_FLOOD_FILL': "V140_SKETCH_REGION_VIA_FLOOD_FILL",
            'V141_THICKEN_RECORDS_FIX': "V141_THICKEN_RECORDS_FIX",
            'V142_TWEAKS_AND_NO_EXPORT_IMPORT': "V142_TWEAKS_AND_NO_EXPORT_IMPORT",
            'V143_SECTION_PART_FIX': "V143_SECTION_PART_FIX",
            'V144_QUADRANT_CONSTRAINT_REWRITE': "V144_QUADRANT_CONSTRAINT_REWRITE",
            'V145_REMOVE_SCAR_EDGES': "V145_REMOVE_SCAR_EDGES",
            'V146_VERSIONING': "V146_VERSIONING",
            'V147_SPLIT_DET_ID_STABILITY': "V147_SPLIT_DET_ID_STABILITY",
            'V148_SKETCH_SILHOUETTES': "V148_SKETCH_SILHOUETTES",
            'V149_SKETCH_SILHOUETTES_2': "V149_SKETCH_SILHOUETTES_2",
            'V150_APP_ELEMENT_INTERNAL': "V150_APP_ELEMENT_INTERNAL",
            'V151_EXTRUDE_SECOND_DIRECTION': "V151_EXTRUDE_SECOND_DIRECTION",
            'V152_ADD_MANIPULATOR_STYLE': "V152_ADD_MANIPULATOR_STYLE",
            'V153_ADD_MIRROR_PATTERN_BOOLEANS': "V153_ADD_MIRROR_PATTERN_BOOLEANS",
            'V154_GET_LANGUAGE_VERSION': "V154_GET_LANGUAGE_VERSION",
            'V155_DISABLE_MIRROR_PATTERN_BOOLEANS': "V155_DISABLE_MIRROR_PATTERN_BOOLEANS",
            'V156_EXTRUDE_SECOND_DIRECTION_SYMMETRIC_FIX': "V156_EXTRUDE_SECOND_DIRECTION_SYMMETRIC_FIX",
            'V157_PS_VERSION_28_0_159': "V157_PS_VERSION_28_0_159",
            'V158_MATECONNECTOR_QUERY': "V158_MATECONNECTOR_QUERY",
            'V159_REVOLVE_SECOND_DIRECTION': "V159_REVOLVE_SECOND_DIRECTION",
            'V160_FIX_MIRROR_PATTERN_BOOLEAN': "V160_FIX_MIRROR_PATTERN_BOOLEAN",
            'V161_MATECONNECTORS_ON_CONSTRUCTION': "V161_MATECONNECTORS_ON_CONSTRUCTION",
            'V162_REVOLVE_SECOND_DIRECTION_FIX': "V162_REVOLVE_SECOND_DIRECTION_FIX",
            'V163_PERIODIC_LOFT_FIXES': "V163_PERIODIC_LOFT_FIXES",
            'V164_PS_VERSION_28_0_167': "V164_PS_VERSION_28_0_167",
            'V165_HOLLOWING_WITH_SHELL': "V165_HOLLOWING_WITH_SHELL",
            'V166_FLATTEN_IMPORT': "V166_FLATTEN_IMPORT",
            'V167_PROJECT_ELLIPSES': "V167_PROJECT_ELLIPSES",
            'V168_FILTER_SELECTOR': "V168_FILTER_SELECTOR",
            'V169_HOLLOWING_WITH_SHELL_FILTER': "V169_HOLLOWING_WITH_SHELL_FILTER",
            'V170_CHANGE_MIRROR_BOOLEAN_TOOLS': "V170_CHANGE_MIRROR_BOOLEAN_TOOLS",
            'V171_SHELL_PRESELECTION_REGRESSION_FIX': "V171_SHELL_PRESELECTION_REGRESSION_FIX",
            'V172_REVOLVE_TWO_DIRECTION_MANIPULATOR_REVERT': "V172_REVOLVE_TWO_DIRECTION_MANIPULATOR_REVERT",
            'V173_INTERSECTION_CREATES_BODIES': "V173_INTERSECTION_CREATES_BODIES",
            'V174_PS_VERSION_28_0_174': "V174_PS_VERSION_28_0_174",
            'V175_DCM_VERSION_64_3_3': "V175_DCM_VERSION_64_3_3",
            'V176_DCM_VERSION_64_3_4': "V176_DCM_VERSION_64_3_4",
            'V177_CONSTRUCTION_OBJECT_FILTER': "V177_CONSTRUCTION_OBJECT_FILTER",
            'V178_SPLINE_LENGTH_DIMENSIONS': "V178_SPLINE_LENGTH_DIMENSIONS",
            'V179_SUBTRACT_COMPLEMENT_HANDLED_IN_FS': "V179_SUBTRACT_COMPLEMENT_HANDLED_IN_FS",
            'V180_INTERSECT_KEEP_TOOLS': "V180_INTERSECT_KEEP_TOOLS",
            'V181_MASS_UNITS': "V181_MASS_UNITS",
            'V182_HOLE_FEATURE': "V182_HOLE_FEATURE",
            'V183_CONSOLIDATE_DEGENERATE_SKETCH_WIRE_CHECKS': "V183_CONSOLIDATE_DEGENERATE_SKETCH_WIRE_CHECKS",
            'V184_HOLE_FEATURE_HEURISTICS': "V184_HOLE_FEATURE_HEURISTICS",
            'V185_HOLE_FEATURE_QLV_CHANGES': "V185_HOLE_FEATURE_QLV_CHANGES",
            'V186_PLANE_COORDINATES': "V186_PLANE_COORDINATES",
            'V187_HOLE_FEATURE_IMPROVEMENTS': "V187_HOLE_FEATURE_IMPROVEMENTS",
            'V188_HOLE_FEATURE_QLV_PROMPT': "V188_HOLE_FEATURE_QLV_PROMPT",
            'V189_HOLE_FEATURE_SPELLING': "V189_HOLE_FEATURE_SPELLING",
            'V190_HOLE_FEATURE_ANGLE_MATH': "V190_HOLE_FEATURE_ANGLE_MATH",
            'V191_SKETCH_PROJECTION_ERROR': "V191_SKETCH_PROJECTION_ERROR",
            'V192_HOLE_FEATURE_REMOVE_COINC_POINTS': "V192_HOLE_FEATURE_REMOVE_COINC_POINTS",
            'V193_PS_VERSION_28_0_180': "V193_PS_VERSION_28_0_180",
            'V194_HOLE_FEATURE_SPELLING': "V194_HOLE_FEATURE_SPELLING",
            'V195_MOVE_FACE_TRANSFORM_CONTAINED_FILLET_GROUPS': "V195_MOVE_FACE_TRANSFORM_CONTAINED_FILLET_GROUPS",
            'V196_SPLIT_MERGE_REDUNDANT': "V196_SPLIT_MERGE_REDUNDANT",
            'V197_REDUCED_SKETCH_STATUS_CHECKS': "V197_REDUCED_SKETCH_STATUS_CHECKS",
            'V198_HOLE_FEATURE_HEURISTICS_2': "V198_HOLE_FEATURE_HEURISTICS_2",
            'V199_EXTRUDE_SEPARATE_BOUND_ENTITY_QUERY': "V199_EXTRUDE_SEPARATE_BOUND_ENTITY_QUERY",
            'V200_CENTERLINE_DIMENSIONS': "V200_CENTERLINE_DIMENSIONS",
            'V201_ERROR_HANDLING': "V201_ERROR_HANDLING",
            'V202_REMOVE_CONSTRAINT_TYPE': "V202_REMOVE_CONSTRAINT_TYPE",
            'V203_SWEEP_PATH_NO_CONSTRUCTION': "V203_SWEEP_PATH_NO_CONSTRUCTION",
            'V204_SKETCH_IMAGE': "V204_SKETCH_IMAGE",
            'V205_REMEMBER_FEATURE_VALUES': "V205_REMEMBER_FEATURE_VALUES",
            'V206_LINEAR_RANGE': "V206_LINEAR_RANGE",
            'V207_FIXED_FILLET_MANIPULATUOR': "V207_FIXED_FILLET_MANIPULATUOR",
            'V208_HOLE_FEATURE_HANDLE_FAILED_EXTRUDE': "V208_HOLE_FEATURE_HANDLE_FAILED_EXTRUDE",
            'V209_CHANGE_VARIABLE_ANNOTATION_CASE': "V209_CHANGE_VARIABLE_ANNOTATION_CASE",
            'V210_LOFT_END_CONDITIONS': "V210_LOFT_END_CONDITIONS",
            'V211_EXTRUDE_WITH_DRAFT': "V211_EXTRUDE_WITH_DRAFT",
            'V212_FIX_BOOLEAN_STATUS': "V212_FIX_BOOLEAN_STATUS",
            'V213_EXTRUDE_WITH_DRAFT2': "V213_EXTRUDE_WITH_DRAFT2",
            'SKIP_214': "SKIP_214",
            'SKIP_215': "SKIP_215",
            'SKIP_216': "SKIP_216",
            'SKIP_217': "SKIP_217",
            'V218_PS_VERSION_28_0_188': "V218_PS_VERSION_28_0_188",
            'V219_FACE_PATTERN_FEATURE_QLV': "V219_FACE_PATTERN_FEATURE_QLV",
            'V220_DRAFT_IS_STEEP_CHECK': "V220_DRAFT_IS_STEEP_CHECK",
            'V221_HELIX_REDIRECTION': "V221_HELIX_REDIRECTION",
            'V222_REMOVE_LOFT_INFO': "V222_REMOVE_LOFT_INFO",
            'V223_CHANGE_VARIABLE_NAME_TEMPLATE': "V223_CHANGE_VARIABLE_NAME_TEMPLATE",
            'V224_VERSION_BUMP': "V224_VERSION_BUMP",
            'V225_HOLE_FEATURE_FIX_BROKEN_DEPTH_CALC': "V225_HOLE_FEATURE_FIX_BROKEN_DEPTH_CALC",
            'SKIP_226': "SKIP_226",
            'SKIP_227': "SKIP_227",
            'SKIP_228': "SKIP_228",
            'SKIP_229': "SKIP_229",
            'V230_LARGE_ASSEMBLY_IMPORT_FIX': "V230_LARGE_ASSEMBLY_IMPORT_FIX",
            'V231_SURFACE_SPLIT': "V231_SURFACE_SPLIT",
            'V232_SKETCH_IMAGE_WITH_BLOB': "V232_SKETCH_IMAGE_WITH_BLOB",
            'V233_FS_EV_CURVE_DEFINITION': "V233_FS_EV_CURVE_DEFINITION",
            'V234_REVOLVE_TWO_DIRECTION': "V234_REVOLVE_TWO_DIRECTION",
            'V235_TRANSFORM_BY_MATE_CONNECTORS': "V235_TRANSFORM_BY_MATE_CONNECTORS",
            'V236_DEFAULT_MAX_ASSEMBLIES': "V236_DEFAULT_MAX_ASSEMBLIES",
            'SKIP_237': "SKIP_237",
            'SKIP_238': "SKIP_238",
            'SKIP_239': "SKIP_239",
            'SKIP_240': "SKIP_240",
            'V241_PS_VERSION_28_0_197': "V241_PS_VERSION_28_0_197",
            'V242_MATE_CONNECTOR_CSYS_AND_ANGLE_RENORM': "V242_MATE_CONNECTOR_CSYS_AND_ANGLE_RENORM",
            'V243_IMPRINT_USE_VERTEX_TOLERANCE': "V243_IMPRINT_USE_VERTEX_TOLERANCE",
            'V244_SKETCH_REGION_UPDATE': "V244_SKETCH_REGION_UPDATE",
            'SKIP_245': "SKIP_245",
            'SKIP_246': "SKIP_246",
            'SKIP_247': "SKIP_247",
            'SKIP_248': "SKIP_248",
            'SKIP_249': "SKIP_249",
            'V250_PS_VERSION_28_0_202': "V250_PS_VERSION_28_0_202",
            'V251_THICKEN_RECORDS_FIX2': "V251_THICKEN_RECORDS_FIX2",
            'V252_HOLE_FEATURE_FIX_ERROR_CHECK': "V252_HOLE_FEATURE_FIX_ERROR_CHECK",
            'V253_ADD_SPLIT_FACE': "V253_ADD_SPLIT_FACE",
            'V254_SKETCH_INTERSECTION': "V254_SKETCH_INTERSECTION",
            'V255_HOLE_FEATURE_FIX_ERROR_DISPLAY': "V255_HOLE_FEATURE_FIX_ERROR_DISPLAY",
            'SKIP_256': "SKIP_256",
            'SKIP_257': "SKIP_257",
            'SKIP_258': "SKIP_258",
            'SKIP_259': "SKIP_259",
            'SKIP_260': "SKIP_260",
            'V261_FACE_DISAMBIGUATION_ERROR': "V261_FACE_DISAMBIGUATION_ERROR",
            'V262_DCM_VERSION_65_0_0': "V262_DCM_VERSION_65_0_0",
            'V263_SURFACE_PATTERN_BOOLEAN': "V263_SURFACE_PATTERN_BOOLEAN",
            'V264_SKETCH_CONSTRAINT_PREPROCESS_FAILURE': "V264_SKETCH_CONSTRAINT_PREPROCESS_FAILURE",
            'V265_PS_VERSION_28_0_204': "V265_PS_VERSION_28_0_204",
            'V266_ALLOW_ZERO_OFFSETS': "V266_ALLOW_ZERO_OFFSETS",
            'V267_DISPLAY_TEARDROP_SPLINES': "V267_DISPLAY_TEARDROP_SPLINES",
            'V268_LOFT_BUGS': "V268_LOFT_BUGS",
            'V269_COUNT_MERGE_TOWARDS_SPLIT': "V269_COUNT_MERGE_TOWARDS_SPLIT",
            'V270_SKETCH_TEXT_CUSTOM_MISSING_CHAR': "V270_SKETCH_TEXT_CUSTOM_MISSING_CHAR",
            'V271_MATE_CONNECTOR_PARALLEL_FIX': "V271_MATE_CONNECTOR_PARALLEL_FIX",
            'V272_MODIFY_DISAMBIGUATION': "V272_MODIFY_DISAMBIGUATION",
            'V273_HISTORY_RECORD_FIXES': "V273_HISTORY_RECORD_FIXES",
            'V274_HOLE_LIMIT_NUM_LOCATIONS_100': "V274_HOLE_LIMIT_NUM_LOCATIONS_100",
            'V275_SKETCH_PATTERN_LOWER_LIMIT': "V275_SKETCH_PATTERN_LOWER_LIMIT",
            'SKIP_276': "SKIP_276",
            'SKIP_277': "SKIP_277",
            'SKIP_278': "SKIP_278",
            'SKIP_279': "SKIP_279",
            'SKIP_280': "SKIP_280",
            'V281_SEPARATE_REDUNDANDANT_TOPOLS_BY_TYPES': "V281_SEPARATE_REDUNDANDANT_TOPOLS_BY_TYPES",
            'V282_DCM_VERSION_65_5_1': "V282_DCM_VERSION_65_5_1",
            'V283_ROUND_FOR_ERRORS': "V283_ROUND_FOR_ERRORS",
            'V284_SWEEP_PROFILE_ALIGNMENT': "V284_SWEEP_PROFILE_ALIGNMENT",
            'V285_CONNECTOR_OWNER_EDIT_LOGIC': "V285_CONNECTOR_OWNER_EDIT_LOGIC",
            'V286_HOLE_ADD_STANDARDS': "V286_HOLE_ADD_STANDARDS",
            'V287_NEW_BTMFEATURE': "V287_NEW_BTMFEATURE",
            'V288_PS_VERSION_28_1_177': "V288_PS_VERSION_28_1_177",
            'V289_EVDISTANCE': "V289_EVDISTANCE",
            'V290_FS_USE_STD_REGEX': "V290_FS_USE_STD_REGEX",
            'V291_HOLE_FEATURE_STANDARD_DEFAULTS': "V291_HOLE_FEATURE_STANDARD_DEFAULTS",
            'V292_HOLE_FEATURE_CHANGE_TAP_DRILL_NAME': "V292_HOLE_FEATURE_CHANGE_TAP_DRILL_NAME",
            'V293_HOLE_FEATURE_BLIND_IN_LAST_ERROR_FIX': "V293_HOLE_FEATURE_BLIND_IN_LAST_ERROR_FIX",
            'SKIP_294': "SKIP_294",
            'SKIP_295': "SKIP_295",
            'V296_DCM_VERSION_65_5_2': "V296_DCM_VERSION_65_5_2",
            'V297_GEOMETRY_BUGS': "V297_GEOMETRY_BUGS",
            'V298_PS_VERSION_28_1_194': "V298_PS_VERSION_28_1_194",
            'V299_HOLE_FEATURE_FIX_BLIND_IN_LAST_FLIP': "V299_HOLE_FEATURE_FIX_BLIND_IN_LAST_FLIP",
            'V300_FEATURE_PATTERN': "V300_FEATURE_PATTERN",
            'V301_PLANE_DEFAULT_SIZE': "V301_PLANE_DEFAULT_SIZE",
            'V302_SECTION_PART_STUDIOS': "V302_SECTION_PART_STUDIOS",
            'V303_FEAT_PATTERN_SKETCH_FIX': "V303_FEAT_PATTERN_SKETCH_FIX",
            'V304_DCM_VERSION_65_5_1': "V304_DCM_VERSION_65_5_1",
            'V305_UPGRADE_TEST_FAIL': "V305_UPGRADE_TEST_FAIL",
            'V306_HOLE_FEATURE_FIX_UNDETERMINED_TARGET_BODY': "V306_HOLE_FEATURE_FIX_UNDETERMINED_TARGET_BODY",
            'V307_HOLE_FEATURE_FIX_UNDETERMINED_TARGET_BODY_2': "V307_HOLE_FEATURE_FIX_UNDETERMINED_TARGET_BODY_2",
            'V308_ADD_RIGHT_PAD_TO_TEXT': "V308_ADD_RIGHT_PAD_TO_TEXT",
            'V309_MOVE_FACE_SUPPORT_360_DEG_ROTATION': "V309_MOVE_FACE_SUPPORT_360_DEG_ROTATION",
            'V310_SKETCH_SILHOUETTES_IN_FACE': "V310_SKETCH_SILHOUETTES_IN_FACE",
            'V311_MATECONNECTOR_EDGE_INFERENCE_FIX': "V311_MATECONNECTOR_EDGE_INFERENCE_FIX",
            'V312_EXTRUDE_UP_TO_FACE_USE_OWNER_TOPOLOGY': "V312_EXTRUDE_UP_TO_FACE_USE_OWNER_TOPOLOGY",
            'V313_ORDER_INDEPENDENT_SKETCH_OFFSETS': "V313_ORDER_INDEPENDENT_SKETCH_OFFSETS",
            'V314_HOLE_FIX_CYL_CAST_EARLY_RETURN': "V314_HOLE_FIX_CYL_CAST_EARLY_RETURN",
            'V315_DCM_VERSION_65_5_4': "V315_DCM_VERSION_65_5_4",
            'V316_PLANE_DEFAULT_SIZE_FIX': "V316_PLANE_DEFAULT_SIZE_FIX",
            'SKIP_317': "SKIP_317",
            'SKIP_318': "SKIP_318",
            'SKIP_319': "SKIP_319",
            'SKIP_320': "SKIP_320",
            'SKIP_321': "SKIP_321",
            'V322_VERSION_BUMP_1_43': "V322_VERSION_BUMP_1_43",
            'V323_CONSISTENT_ELLIPSE_ORIENTATION': "V323_CONSISTENT_ELLIPSE_ORIENTATION",
            'V324_UPDATE_IMPRINT_CURVE_NORMAL': "V324_UPDATE_IMPRINT_CURVE_NORMAL",
            'V325_FEATURE_MIRROR': "V325_FEATURE_MIRROR",
            'V326_PS_VERSION_28_1_224': "V326_PS_VERSION_28_1_224",
            'V327_LOOKUP_TABLE_CAPITALIZE': "V327_LOOKUP_TABLE_CAPITALIZE",
            'V328_INTERNAL_DOCUMENTATION': "V328_INTERNAL_DOCUMENTATION",
            'SKIP_329': "SKIP_329",
            'SKIP_330': "SKIP_330",
            'SKIP_331': "SKIP_331",
            'SKIP_332': "SKIP_332",
            'V333_UPDATE_SKETCH_IMPRINT': "V333_UPDATE_SKETCH_IMPRINT",
            'V334_PS_VERSION_28_1_228': "V334_PS_VERSION_28_1_228",
            'V335_REQUIRE_STD_VERSIONS': "V335_REQUIRE_STD_VERSIONS",
            'V336_FS_ATTRIBUTES_IN_MERGE': "V336_FS_ATTRIBUTES_IN_MERGE",
            'SKIP_337': "SKIP_337",
            'SKIP_338': "SKIP_338",
            'SKIP_339': "SKIP_339",
            'SKIP_340': "SKIP_340",
            'SKIP_341': "SKIP_341",
            'V342_CHECK_INITIAL_GUESS': "V342_CHECK_INITIAL_GUESS",
            'V343_SUBFEATURES': "V343_SUBFEATURES",
            'V344_BOOLEAN_BLEND_BUGS': "V344_BOOLEAN_BLEND_BUGS",
            'V345_PS_VERSION_28_1_231': "V345_PS_VERSION_28_1_231",
            'V346_TRACKING_WITH_DET_IDS': "V346_TRACKING_WITH_DET_IDS",
            'V347_SHEET_METAL_FLATTEN': "V347_SHEET_METAL_FLATTEN",
            'SKIP_348': "SKIP_348",
            'SKIP_349': "SKIP_349",
            'SKIP_350': "SKIP_350",
            'SKIP_351': "SKIP_351",
            'SKIP_352': "SKIP_352",
            'V353_DCM_VERSION_65_5_6': "V353_DCM_VERSION_65_5_6",
            'V354_BETWEEN_ENTITY_ADDITIONAL_QUERY_REQUIRED': "V354_BETWEEN_ENTITY_ADDITIONAL_QUERY_REQUIRED",
            'V355_DOCUMENTATION_UPDATE': "V355_DOCUMENTATION_UPDATE",
            'SKIP_356': "SKIP_356",
            'SKIP_357': "SKIP_357",
            'SKIP_358': "SKIP_358",
            'SKIP_359': "SKIP_359",
            'V360_FEATURE_MAP': "V360_FEATURE_MAP",
            'V361_DETECT_INFINITE_SKETCH_DIMENSION': "V361_DETECT_INFINITE_SKETCH_DIMENSION",
            'V362_HOLE_IMPROVED_DEPTH_FINDING': "V362_HOLE_IMPROVED_DEPTH_FINDING",
            'V363_FS_ATTRIBUTE_MANAGEMENT': "V363_FS_ATTRIBUTE_MANAGEMENT",
            'V364_HOLE_FIX_FEATURE_MIRROR': "V364_HOLE_FIX_FEATURE_MIRROR",
            'V365_BOOLEAN_SURFACE_ERROR_FIX': "V365_BOOLEAN_SURFACE_ERROR_FIX",
            'V366_OPPOSITE_DIRECTION_CIRCULAR_UIHINT': "V366_OPPOSITE_DIRECTION_CIRCULAR_UIHINT",
            'V367_VERTEX_EXTRUDE_DEGENERATE_FIX': "V367_VERTEX_EXTRUDE_DEGENERATE_FIX",
            'V368_HOLE_FIELD_NAME_MISMATCH_FIX': "V368_HOLE_FIELD_NAME_MISMATCH_FIX",
            'V369_FS_ERROR_EXTRUDE_FIX': "V369_FS_ERROR_EXTRUDE_FIX",
            'V370_UPGRADE_COMPRESS_FIX': "V370_UPGRADE_COMPRESS_FIX",
            'V371_HOLE_IMPROVED_DISJOINT_CHECK': "V371_HOLE_IMPROVED_DISJOINT_CHECK",
            'V372_EVDISTANCE_INTERIOR_FIX': "V372_EVDISTANCE_INTERIOR_FIX",
            'V373_MESH_SUPPORT': "V373_MESH_SUPPORT",
            'V374_HELIX_ALIGNMENT': "V374_HELIX_ALIGNMENT",
            'V375_HOLE_FIX_EDIT_LOGIC': "V375_HOLE_FIX_EDIT_LOGIC",
            'V376_FS_VERSION_BUMP': "V376_FS_VERSION_BUMP",
            'SKIP_377': "SKIP_377",
            'SKIP_378': "SKIP_378",
            'V379_EDITING_LOGIC_QUERIES': "V379_EDITING_LOGIC_QUERIES",
            'V380_UPDATE_ELLIPSE_OFFSET_DATA': "V380_UPDATE_ELLIPSE_OFFSET_DATA",
            'V381_SKIP': "V381_SKIP",
            'V382_NORMALIZE_ELLIPSE_AXIS': "V382_NORMALIZE_ELLIPSE_AXIS",
            'V383_PS_VERSION_29_0_155': "V383_PS_VERSION_29_0_155",
            'V384_DCM_VERSION_66_0_0': "V384_DCM_VERSION_66_0_0",
            'V385_IMPORT_RECORD': "V385_IMPORT_RECORD",
            'V386_NEW_IMPRINT_API': "V386_NEW_IMPRINT_API",
            'V387_PROPER_CIRCLE_INVERSION': "V387_PROPER_CIRCLE_INVERSION",
            'V388_HOLE_FIX_FEATURE_PATTERN_TRANSFORM': "V388_HOLE_FIX_FEATURE_PATTERN_TRANSFORM",
            'V389_FACE_PATTERN_SKIP_LOOP_CHECK': "V389_FACE_PATTERN_SKIP_LOOP_CHECK",
            'V390_TIGHT_BOUNDING_BOX': "V390_TIGHT_BOUNDING_BOX",
            'V391_DOCUMENTATION_CORRECTION': "V391_DOCUMENTATION_CORRECTION",
            'V392_HOLE_FIX_EDIT_LOGIC': "V392_HOLE_FIX_EDIT_LOGIC",
            'SKIP_393': "SKIP_393",
            'SKIP_394': "SKIP_394",
            'SKIP_395': "SKIP_395",
            'V396_WILD_CARD_IN_QUERIES': "V396_WILD_CARD_IN_QUERIES",
            'V397_FLIP_CONE_HELIX': "V397_FLIP_CONE_HELIX",
            'V398_NORMAL_BY_ROTATION': "V398_NORMAL_BY_ROTATION",
            'V399_PS_VERSION_29_0_166': "V399_PS_VERSION_29_0_166",
            'V400_SHELL_FIX_TRACKING_ID': "V400_SHELL_FIX_TRACKING_ID",
            'V401_HOLE_CLEAR_START_FROM_SKETCH': "V401_HOLE_CLEAR_START_FROM_SKETCH",
            'V402_FACE_PATTERN_TRACKING': "V402_FACE_PATTERN_TRACKING",
            'V403_ACCOUNT_FOR_REVERSED_CURVE': "V403_ACCOUNT_FOR_REVERSED_CURVE",
            'V404_HANDLE_COLLAPSED_TEXT': "V404_HANDLE_COLLAPSED_TEXT",
            'V405_ERROR_DISPLAY_AND_FEATURE_STATUS': "V405_ERROR_DISPLAY_AND_FEATURE_STATUS",
            'V406_SPHERE_PRIMITIVE': "V406_SPHERE_PRIMITIVE",
            'V407_WITHIN_RADIUS': "V407_WITHIN_RADIUS",
            'V408_ERROR_ENUM_ASSEMBLY_PATTERN_NOT_SUPPORTED': "V408_ERROR_ENUM_ASSEMBLY_PATTERN_NOT_SUPPORTED",
            'SKIP_409': "SKIP_409",
            'SKIP_410': "SKIP_410",
            'SKIP_411': "SKIP_411",
            'V412_CHECK_VALID_BSPLINE_APPROX': "V412_CHECK_VALID_BSPLINE_APPROX",
            'V413_AUTOFIX_HELP_POINTS': "V413_AUTOFIX_HELP_POINTS",
            'V414_ASYMMETRIC_CHAMFER_MIRROR_BUG': "V414_ASYMMETRIC_CHAMFER_MIRROR_BUG",
            'V415_CPLANE_MANIPULATOR': "V415_CPLANE_MANIPULATOR",
            'V416_MESH_NOT_SUPPORTED_ERROR': "V416_MESH_NOT_SUPPORTED_ERROR",
            'V417_HOLE_CHANGE_TAP_CLEARANCE_TOOLTIP': "V417_HOLE_CHANGE_TAP_CLEARANCE_TOOLTIP",
            'V418_RIB_FIX_EXTEND_LOGIC': "V418_RIB_FIX_EXTEND_LOGIC",
            'V419_EVBOX3D_FIXES': "V419_EVBOX3D_FIXES",
            'V420_RIB_SIMPLER_HEURISTICS': "V420_RIB_SIMPLER_HEURISTICS",
            'V421_TRIM_HELIX_AT_CONE_APEX': "V421_TRIM_HELIX_AT_CONE_APEX",
            'V422_RIB_DELETE_ERROR_BODIES': "V422_RIB_DELETE_ERROR_BODIES",
            'V423_UNWRAP_POINT_BODIES': "V423_UNWRAP_POINT_BODIES",
            'V424_VARIABLE_WARNINGS': "V424_VARIABLE_WARNINGS",
            'V425_MORE_DEGENERATE_SKETCH_WIRE_CHECKS': "V425_MORE_DEGENERATE_SKETCH_WIRE_CHECKS",
            'V426_MOVE_FACE_IN_MIRROR': "V426_MOVE_FACE_IN_MIRROR",
            'V427_LOCK_SWEEP_DIRECTION_HELIX': "V427_LOCK_SWEEP_DIRECTION_HELIX",
            'V428_EDGE_DISAMBIGUATION_BY_SIDES': "V428_EDGE_DISAMBIGUATION_BY_SIDES",
            'V429_HOLE_SAFE_SKETCH_CLEANUP': "V429_HOLE_SAFE_SKETCH_CLEANUP",
            'V430_CONFIGURATIONS_PREP': "V430_CONFIGURATIONS_PREP",
            'V431_FIX_BODY_FILTERS': "V431_FIX_BODY_FILTERS",
            'V432_RIB_GROUP_BOOLEANS': "V432_RIB_GROUP_BOOLEANS",
            'SKIP_433': "SKIP_433",
            'SKIP_434': "SKIP_434",
            'SKIP_435': "SKIP_435",
            'SKIP_436': "SKIP_436",
            'V437_CONSISTENT_BOUNDS': "V437_CONSISTENT_BOUNDS",
            'V438_RIB_EXTEND_LOGIC': "V438_RIB_EXTEND_LOGIC",
            'V439_TWEAK_OP_TRACKING': "V439_TWEAK_OP_TRACKING",
            'V440_SYNTAX_ERRORS': "V440_SYNTAX_ERRORS",
            'V441_SHOW_LABEL_UIHINT': "V441_SHOW_LABEL_UIHINT",
            'V442_PARTING_OUT_TARGET_READONLY': "V442_PARTING_OUT_TARGET_READONLY",
            'SKIP_443': "SKIP_443",
            'SKIP_444': "SKIP_444",
            'SKIP_445': "SKIP_445",
            'SKIP_446': "SKIP_446",
            'V447_SPLIT_SHEET_METAL': "V447_SPLIT_SHEET_METAL",
            'V448_OWNER_BODY_DISAMBIGUATION': "V448_OWNER_BODY_DISAMBIGUATION",
            'V449_PS_VERSION_29_1_146': "V449_PS_VERSION_29_1_146",
            'V450_SPLIT_TRACKING_MERGED_EDGES': "V450_SPLIT_TRACKING_MERGED_EDGES",
            'V451_NO_MATECONNECTORS_IN_PATTERN': "V451_NO_MATECONNECTORS_IN_PATTERN",
            'V452_PARAMETER_GROUP_UIHINT': "V452_PARAMETER_GROUP_UIHINT",
            'V453_REMOVED_PARAMETER_GROUP': "V453_REMOVED_PARAMETER_GROUP",
            'V454_CORRECT_IMPORT_DEFAULT': "V454_CORRECT_IMPORT_DEFAULT",
            'V455_HOLE_INIT_IS_TAPPED_THROUGH': "V455_HOLE_INIT_IS_TAPPED_THROUGH",
            'SKIP_456': "SKIP_456",
            'SKIP_457': "SKIP_457",
            'SKIP_458': "SKIP_458",
            'V459_TOP_DISAMBIGUATION_IDS': "V459_TOP_DISAMBIGUATION_IDS",
            'V460_ENABLE_SHEET_METAL': "V460_ENABLE_SHEET_METAL",
            'V461_CURVE_PATTERN_FEATURE': "V461_CURVE_PATTERN_FEATURE",
            'V462_BLOCK_INCONTEXT_FACE_CURVE_PATTERN': "V462_BLOCK_INCONTEXT_FACE_CURVE_PATTERN",
            'V463_UPDATE_ISO_SCREW_STANDARDS': "V463_UPDATE_ISO_SCREW_STANDARDS",
            'V464_CURVE_PATTERN_STABILIZATION': "V464_CURVE_PATTERN_STABILIZATION",
            'SKIP_465': "SKIP_465",
            'SKIP_466': "SKIP_466",
            'V467_STRICTER_DISAMBIGUATION': "V467_STRICTER_DISAMBIGUATION",
            'V468_PROPAGATE_MERGE_ERROR': "V468_PROPAGATE_MERGE_ERROR",
            'V469_CHANGE_FACE_SWEPT_EDGES': "V469_CHANGE_FACE_SWEPT_EDGES",
            'V470_PS_VERSION_29_1_189': "V470_PS_VERSION_29_1_189",
            'V471_FEATURE_LIST_KEY': "V471_FEATURE_LIST_KEY",
            'V472_INCONTEXT_UPGRADE': "V472_INCONTEXT_UPGRADE",
            'V473_SHEET_METAL_COMMENTS': "V473_SHEET_METAL_COMMENTS",
            'V474_MOVE_FACE_FIX': "V474_MOVE_FACE_FIX",
            'V475_KEEP_TOOLS_AUTO_SELECTION': "V475_KEEP_TOOLS_AUTO_SELECTION",
            'V476_SM_BOOLEAN_PATTERN_ERROR': "V476_SM_BOOLEAN_PATTERN_ERROR",
            'V477_END_SM_UPDATE': "V477_END_SM_UPDATE",
            'SKIP_478': "SKIP_478",
            'SKIP_479': "SKIP_479",
            'SKIP_480': "SKIP_480",
            'V481_CLEAR_SHEET_METAL_DATA_IN_SECTION': "V481_CLEAR_SHEET_METAL_DATA_IN_SECTION",
            'V482_PS_VERSION_29_1_199': "V482_PS_VERSION_29_1_199",
            'V483_FLAT_QUERY_EVAL_FIX': "V483_FLAT_QUERY_EVAL_FIX",
            'V484_MOVE_FACE_0_DISTANCE': "V484_MOVE_FACE_0_DISTANCE",
            'V485_EXTEND_SHEET_BODY_SPLIT': "V485_EXTEND_SHEET_BODY_SPLIT",
            'V486_MOVE_FACE_PROPAGATE_INFO': "V486_MOVE_FACE_PROPAGATE_INFO",
            'V487_IMPORT_FILTER_POINT_BODIES': "V487_IMPORT_FILTER_POINT_BODIES",
            'V488_CLASSIFY_CORNER_RETURNS_MAP': "V488_CLASSIFY_CORNER_RETURNS_MAP",
            'V489_FLANGE_BUGS': "V489_FLANGE_BUGS",
            'V490_BEND_RELIEF_LOCATION': "V490_BEND_RELIEF_LOCATION",
            'V491_CURVE_PATTERN_WIRES_ONLY': "V491_CURVE_PATTERN_WIRES_ONLY",
            'V492_MULTIPLE_OUTLINE_PIECES': "V492_MULTIPLE_OUTLINE_PIECES",
            'V493_FLANGE_BASE_SHIFT_FIX': "V493_FLANGE_BASE_SHIFT_FIX",
            'V494_RECORD_SWAP_MULTIPLICITY': "V494_RECORD_SWAP_MULTIPLICITY",
            'V495_MOVE_FACE_ROTATION_AXIS': "V495_MOVE_FACE_ROTATION_AXIS",
            'V496_COMPLEX_BEND_ENDS': "V496_COMPLEX_BEND_ENDS",
            'V497_BLOCK_ILLEGAL_MODIFICATION': "V497_BLOCK_ILLEGAL_MODIFICATION",
            'V498_SM_SPATIAL_VERTEX_MATCHING': "V498_SM_SPATIAL_VERTEX_MATCHING",
            'V499_PS_VERSION_29_1_214': "V499_PS_VERSION_29_1_214",
            'V500_EXTERNAL_DISAMBIGUATION': "V500_EXTERNAL_DISAMBIGUATION",
            'V501_BEND_END_ADAPTIVE_SMOOTHING': "V501_BEND_END_ADAPTIVE_SMOOTHING",
            'V502_CORNER_CLASSIFICATION_FIX': "V502_CORNER_CLASSIFICATION_FIX",
            'V503_EXTRUDE_WITH_OFFSET': "V503_EXTRUDE_WITH_OFFSET",
            'V504_MODIFY_TO_SPLIT': "V504_MODIFY_TO_SPLIT",
            'V505_EXTRUDE_WITH_OFFSET_DIALOG': "V505_EXTRUDE_WITH_OFFSET_DIALOG",
            'SKIP_506': "SKIP_506",
            'SKIP_507': "SKIP_507",
            'SKIP_508': "SKIP_508",
            'SKIP_509': "SKIP_509",
            'SKIP_510': "SKIP_510",
            'SKIP_511': "SKIP_511",
            'V512_MOVE_FACE_OVERLAP': "V512_MOVE_FACE_OVERLAP",
            'V513_CONFIGURATION_DATA_UPGRADE': "V513_CONFIGURATION_DATA_UPGRADE",
            'V514_OFFSET_FACE': "V514_OFFSET_FACE",
            'V515_EXTRUDE_CHECK_LOCAL_STATUS': "V515_EXTRUDE_CHECK_LOCAL_STATUS",
            'V516_SURFACE_BOOLEAN_EDGE_EVENTS': "V516_SURFACE_BOOLEAN_EDGE_EVENTS",
            'V517_MOVE_FACE_CHECK_BEND_EDGE': "V517_MOVE_FACE_CHECK_BEND_EDGE",
            'V518_MIRRORING_LIN_PATTERNS': "V518_MIRRORING_LIN_PATTERNS",
            'V519_EXPANDED_CORNER_VERTEX_SET': "V519_EXPANDED_CORNER_VERTEX_SET",
            'V520_BLOCK_ILLEGAL_MODIFICATION': "V520_BLOCK_ILLEGAL_MODIFICATION",
            'V521_SM_CLEARANCE': "V521_SM_CLEARANCE",
            'V522_MOVE_FACE_NONPLANAR': "V522_MOVE_FACE_NONPLANAR",
            'V523_SWEEP_PATH_START_VERTEX': "V523_SWEEP_PATH_START_VERTEX",
            'V524_HOLE_TAP_MAJOR_DIAMETER': "V524_HOLE_TAP_MAJOR_DIAMETER",
            'V525_SM_THICKEN_NO_NEIGHBORS': "V525_SM_THICKEN_NO_NEIGHBORS",
            'V526_FLANGE_SIDE_PLANE_DIR': "V526_FLANGE_SIDE_PLANE_DIR",
            'V527_MOVE_FACE_MOVE_CREATE_TAB': "V527_MOVE_FACE_MOVE_CREATE_TAB",
            'V528_MOVE_FACE_MERGE': "V528_MOVE_FACE_MERGE",
            'V529_MOVE_FACE_UI_UPDATES': "V529_MOVE_FACE_UI_UPDATES",
            'V530_MOVE_FACE_SCOPE': "V530_MOVE_FACE_SCOPE",
            'V531_HOLE_MAJOR_DIAMETER_UPGRADE': "V531_HOLE_MAJOR_DIAMETER_UPGRADE",
            'SKIP_532': "SKIP_532",
            'V533_OFFSET_CIRCLE_HELP_POINTS': "V533_OFFSET_CIRCLE_HELP_POINTS",
            'V534_INFORM_IN_CONTEXT_SM_THICKEN': "V534_INFORM_IN_CONTEXT_SM_THICKEN",
            'V535_DETERMINISTIC_DISAMBIGUATION': "V535_DETERMINISTIC_DISAMBIGUATION",
            'V536_RIB_PROFILE_EXTN_CHECK_ANGLE': "V536_RIB_PROFILE_EXTN_CHECK_ANGLE",
            'V537_IN_FLAT_QUERY': "V537_IN_FLAT_QUERY",
            'V538_GENERAL_SHEET_INTERSECTION': "V538_GENERAL_SHEET_INTERSECTION",
            'V539_SKETCH_CONICS': "V539_SKETCH_CONICS",
            'V540_SHEET_METAL_REMOVE_REDUNDANT': "V540_SHEET_METAL_REMOVE_REDUNDANT",
            'V541_REVERT_540': "V541_REVERT_540",
            'V542_REMAP_ATTACHED': "V542_REMAP_ATTACHED",
            'V543_RECURSIVE_UNION': "V543_RECURSIVE_UNION",
            'SKIP_544': "SKIP_544",
            'SKIP_545': "SKIP_545",
            'V546_GEOMETRY_QUERY_FIX': "V546_GEOMETRY_QUERY_FIX",
            'V547_SM_CORNERS_MERGE_SHORT_RIP_EDGES': "V547_SM_CORNERS_MERGE_SHORT_RIP_EDGES",
            'V548_PS_VERSION_29_1_233': "V548_PS_VERSION_29_1_233",
            'V549_SM_ALIGNMENT_APPROXIMATE_ANGLE': "V549_SM_ALIGNMENT_APPROXIMATE_ANGLE",
            'V550_EXTRUDE_OFFSET_VERIFICATION': "V550_EXTRUDE_OFFSET_VERIFICATION",
            'V551_DELETE_FACE_NO_HEAL': "V551_DELETE_FACE_NO_HEAL",
            'V552_FILLET_EARLY_VERIFICATION': "V552_FILLET_EARLY_VERIFICATION",
            'V553_MULTI_LOOP_ALIGNMENT': "V553_MULTI_LOOP_ALIGNMENT",
            'V554_SURFACE_JOIN': "V554_SURFACE_JOIN",
            'V555_CURVE_FEATURE_TEXT_CHANGES': "V555_CURVE_FEATURE_TEXT_CHANGES",
            'V556_SURFACE_JOIN_FS_FIXES': "V556_SURFACE_JOIN_FS_FIXES",
            'V557_NO_BEND_CENTERLINE_IN_DERIVED': "V557_NO_BEND_CENTERLINE_IN_DERIVED",
            'V558_PROJECT_EDGES_SAME_SKETCH': "V558_PROJECT_EDGES_SAME_SKETCH",
            'V559_REMOVE_LOGGING': "V559_REMOVE_LOGGING",
            'SKIP_560': "SKIP_560",
            'SKIP_561': "SKIP_561",
            'V562_REMOVE_SCAR_EDGES': "V562_REMOVE_SCAR_EDGES",
            'V563_EDGE_BLEND_FILTER_ORDER': "V563_EDGE_BLEND_FILTER_ORDER",
            'V564_Q_FARTHEST_ALONG_SIGN': "V564_Q_FARTHEST_ALONG_SIGN",
            'V565_COMPUTED_DATA_SKETCH_TRANSFORM': "V565_COMPUTED_DATA_SKETCH_TRANSFORM",
            'V566_MODIFIABLE_ONLY_IN_DERIVED': "V566_MODIFIABLE_ONLY_IN_DERIVED",
            'V567_GET_VARIABLE_THROWS': "V567_GET_VARIABLE_THROWS",
            'V568_RHO_DIMENSION_NOT_CONSISTENT': "V568_RHO_DIMENSION_NOT_CONSISTENT",
            'V569_FLANGE_NEXT_TO_RIP': "V569_FLANGE_NEXT_TO_RIP",
            'V570_DISAMBIGUATION_PRESENCE': "V570_DISAMBIGUATION_PRESENCE",
            'V571_HOLE_BLIND_IN_LAST_PROJECTION': "V571_HOLE_BLIND_IN_LAST_PROJECTION",
            'V572_TAP_CLEARANCE_TO_REAL': "V572_TAP_CLEARANCE_TO_REAL",
            'V573_FS_ATTRIBUTES_MERGED_TO_WIRES': "V573_FS_ATTRIBUTES_MERGED_TO_WIRES",
            'V574_SKETCH_PROJECT_VERTEX_TOLERANCE': "V574_SKETCH_PROJECT_VERTEX_TOLERANCE",
            'V575_SHEET_METAL_FILLET_CHAMFER': "V575_SHEET_METAL_FILLET_CHAMFER",
            'V576_GET_WIRE_LAMINAR_DEPENDENCIES': "V576_GET_WIRE_LAMINAR_DEPENDENCIES",
            'V577_CORNER_BREAK_ADJUST': "V577_CORNER_BREAK_ADJUST",
            'V578_FIX_DELETE_FACE_MODIFICATION': "V578_FIX_DELETE_FACE_MODIFICATION",
            'V579_FIT_SPLINE_ZERO_MAGNITUDE': "V579_FIT_SPLINE_ZERO_MAGNITUDE",
            'V580_CORNER_BREAK_STABILIZATION': "V580_CORNER_BREAK_STABILIZATION",
            'V581_REMOVE_HELIX_CONTROL_VISIBILITY': "V581_REMOVE_HELIX_CONTROL_VISIBILITY",
            'V582_MERGE_MAPS_BUG': "V582_MERGE_MAPS_BUG",
            'V583_AVOID_SKETCH_TEXT_TOUCHING': "V583_AVOID_SKETCH_TEXT_TOUCHING",
            'V584_FILTER_FACES_IN_THICKEN': "V584_FILTER_FACES_IN_THICKEN",
            'V585_SHOW_TAPPED_DEPTH_UPDATE': "V585_SHOW_TAPPED_DEPTH_UPDATE",
            'V586_DUPLICATE_EXTRUDE_TRANSFORM': "V586_DUPLICATE_EXTRUDE_TRANSFORM",
            'V587_SPINE_IN_LOFT': "V587_SPINE_IN_LOFT",
            'V588_MERGE_IN_FILLET_FIX': "V588_MERGE_IN_FILLET_FIX",
            'V589_STABLE_BREAK_REMOVAL': "V589_STABLE_BREAK_REMOVAL",
            'V590_DEFER_SM_BODY_DELETE': "V590_DEFER_SM_BODY_DELETE",
            'V591_BREAK_TOUCHING_WALL': "V591_BREAK_TOUCHING_WALL",
            'V592_LOFT_FS_CHANGES_IN_REL': "V592_LOFT_FS_CHANGES_IN_REL",
            'V593_MASTER_MODEL_DOC': "V593_MASTER_MODEL_DOC",
            'SKIP_594': "SKIP_594",
            'SKIP_595': "SKIP_595",
            'V596_ENCLOSE_FEATURE': "V596_ENCLOSE_FEATURE",
            'V597_VERTEX_TOL_LIMITS': "V597_VERTEX_TOL_LIMITS",
            'V598_EXTRUDE_NO_FLAT': "V598_EXTRUDE_NO_FLAT",
            'V599_SM_ASSOCIATION_FIX': "V599_SM_ASSOCIATION_FIX",
            'V600_PIERCE_COEDGE': "V600_PIERCE_COEDGE",
            'V601_CHECK_IMPORT_NAMES': "V601_CHECK_IMPORT_NAMES",
            'V602_TRACE_THROUGH_COPY': "V602_TRACE_THROUGH_COPY",
            'V603_SUBQUERY_EVALUATION': "V603_SUBQUERY_EVALUATION",
            'V604_DCM_VERSION_67_5_1': "V604_DCM_VERSION_67_5_1",
            'V605_EXTRUDE_CAP_ENTITIES': "V605_EXTRUDE_CAP_ENTITIES",
            'V606_TOLERANT_BRIDGING_CURVE': "V606_TOLERANT_BRIDGING_CURVE",
            'V607_HOLE_FEATURE_FIT_UPDATE': "V607_HOLE_FEATURE_FIT_UPDATE",
            'V608_MERGE_FROM_TOOLS': "V608_MERGE_FROM_TOOLS",
            'SKIP_609': "SKIP_609",
            'SKIP_610': "SKIP_610",
            'SKIP_611': "SKIP_611",
            'SKIP_612': "SKIP_612",
            'SKIP_613': "SKIP_613",
            'V614_CHANGE_FACE_GROW': "V614_CHANGE_FACE_GROW",
            'V615_DCM_VERSION_67_5_2': "V615_DCM_VERSION_67_5_2",
            'V616_DRILL_SIZES_UPDATE': "V616_DRILL_SIZES_UPDATE",
            'V617_GEOM_BUGS': "V617_GEOM_BUGS",
            'V618_SKETCH_LIMIT_DIMENSIONS': "V618_SKETCH_LIMIT_DIMENSIONS",
            'V619_PS_VERSION_30_0_185': "V619_PS_VERSION_30_0_185",
            'V620_DONT_MERGE_SECTION_FACE': "V620_DONT_MERGE_SECTION_FACE",
            'V621_SHEET_METAL_HOLES': "V621_SHEET_METAL_HOLES",
            'V622_LOFT_GUIDE_WITH_END_CONDITION': "V622_LOFT_GUIDE_WITH_END_CONDITION",
            'V623_SHEETMETAL_HOLE_ATTRIBUTE_FIX': "V623_SHEETMETAL_HOLE_ATTRIBUTE_FIX",
            'V624_FILL_SURFACE_UI_UPDATES': "V624_FILL_SURFACE_UI_UPDATES",
            'V625_FILL_FS_FIXES': "V625_FILL_FS_FIXES",
            'V626_COLLAPSE_ARRAY_ITEMS_UIHINT': "V626_COLLAPSE_ARRAY_ITEMS_UIHINT",
            'SKIP_627': "SKIP_627",
            'V628_LOFT_BUG_FIXES': "V628_LOFT_BUG_FIXES",
            'V629_SM_MODEL_FRONT_N_BACK': "V629_SM_MODEL_FRONT_N_BACK",
            'V630_SM_BOOLEAN_NOOP_HANDLING': "V630_SM_BOOLEAN_NOOP_HANDLING",
            'V631_THROW_ID_TREE_ERROR': "V631_THROW_ID_TREE_ERROR",
            'V632_PROFILE_THROUGH_ALL': "V632_PROFILE_THROUGH_ALL",
            'V633_EXTRUDE_CONNECTED_PROFILE': "V633_EXTRUDE_CONNECTED_PROFILE",
            'V634_MERGE_FROM_TOOLS_EVAL': "V634_MERGE_FROM_TOOLS_EVAL",
            'V635_PREVENT_MOVE_FACE_DISASSOCIATION': "V635_PREVENT_MOVE_FACE_DISASSOCIATION",
            'V636_CONIC_FILLET_API_UPDATE': "V636_CONIC_FILLET_API_UPDATE",
            'V637_PS_VERSION_30_0_185': "V637_PS_VERSION_30_0_185",
            'V638_LONGER_BEND_RELIEF_AT_START': "V638_LONGER_BEND_RELIEF_AT_START",
            'SKIP_639': "SKIP_639",
            'SKIP_640': "SKIP_640",
            'SKIP_641': "SKIP_641",
            'SKIP_642': "SKIP_642",
            'SKIP_643': "SKIP_643",
            'V644_TYPE_FOR_VARIABLE_FEATURE': "V644_TYPE_FOR_VARIABLE_FEATURE",
            'V645_LOFT_BUGS': "V645_LOFT_BUGS",
            'V646_SM_MULTI_TOOL_FIX': "V646_SM_MULTI_TOOL_FIX",
            'V647_ENCLOSE_DELETE_MODIFIABLE_TOOLS': "V647_ENCLOSE_DELETE_MODIFIABLE_TOOLS",
            'V648_EXTRUDE_REFERENCE_ALL_PROFILES': "V648_EXTRUDE_REFERENCE_ALL_PROFILES",
            'V649_FLANGE_LOOSEN_EDGE_Y': "V649_FLANGE_LOOSEN_EDGE_Y",
            'V650_TAB_IDENTITY': "V650_TAB_IDENTITY",
            'V651_BLOCK_SM_FEATURE_PATTERN': "V651_BLOCK_SM_FEATURE_PATTERN",
            'V652_DCM_VERSION_67_5_4': "V652_DCM_VERSION_67_5_4",
            'V653_EV_EDGE_TANGENT_LINES_FIX': "V653_EV_EDGE_TANGENT_LINES_FIX",
            'V654_MISMATCHED_BEND_END': "V654_MISMATCHED_BEND_END",
            'V655_EXTEND_SHEET_BODY_WITH_SPLIT': "V655_EXTEND_SHEET_BODY_WITH_SPLIT",
            'V656_VRFILLET_SERVER': "V656_VRFILLET_SERVER",
            'V657_SURFACE_JOIN_BUGS': "V657_SURFACE_JOIN_BUGS",
            'V658_SURFACE_JOIN_FS_CHANGES': "V658_SURFACE_JOIN_FS_CHANGES",
            'V659_HOLE_FEATURE_INITIAL_FOCUS_BUG': "V659_HOLE_FEATURE_INITIAL_FOCUS_BUG",
            'V660_ENCLOSE_AUTO_MATCHING': "V660_ENCLOSE_AUTO_MATCHING",
            'SKIP_661': "SKIP_661",
            'SKIP_662': "SKIP_662",
            'V663_REVOLVE_ID_FIX': "V663_REVOLVE_ID_FIX",
            'V664_FLAT_JOINT_TO_RIP': "V664_FLAT_JOINT_TO_RIP",
            'V665_PERTURBED_SM_TOL': "V665_PERTURBED_SM_TOL",
            'V666_FEATURE_PATTERN_ENTITIES': "V666_FEATURE_PATTERN_ENTITIES",
            'V667_PS_VERSION_30_0_226': "V667_PS_VERSION_30_0_226",
            'V668_ASME_HOLE_SCREW_CLEARANCES': "V668_ASME_HOLE_SCREW_CLEARANCES",
            'V669_TIGHTER_SKETCH_OFFSET_APPROXIMATION': "V669_TIGHTER_SKETCH_OFFSET_APPROXIMATION",
            'V670_VR_FILLET_UPGRADE_TASK': "V670_VR_FILLET_UPGRADE_TASK",
            'V671_FRESH_CORNER_OVERRIDE': "V671_FRESH_CORNER_OVERRIDE",
            'V672_TAB_IDENTITY': "V672_TAB_IDENTITY",
            'V673_VRFILLET_FIXES': "V673_VRFILLET_FIXES",
            'V674_TAB_FIXES': "V674_TAB_FIXES",
            'V675_MORE_TAB_FIXES': "V675_MORE_TAB_FIXES",
            'SKIP_676': "SKIP_676",
            'SKIP_677': "SKIP_677",
            'SKIP_678': "SKIP_678",
            'SKIP_679': "SKIP_679",
            'V680_SHELL_RECORD_FIX': "V680_SHELL_RECORD_FIX",
            'V681_ANGLE_BOUNDS_CHANGE': "V681_ANGLE_BOUNDS_CHANGE",
            'V682_REPLACE_FACE_NO_MERGE': "V682_REPLACE_FACE_NO_MERGE",
            'V683_LOFT_ARRAY_PARAMETERS': "V683_LOFT_ARRAY_PARAMETERS",
            'V684_SM_SWEPT_SUPPORT': "V684_SM_SWEPT_SUPPORT",
            'V685_EXTEND_SHEET_BODY_STEP_EDGES': "V685_EXTEND_SHEET_BODY_STEP_EDGES",
            'V686_LOFT_FS_BUG_FIXES': "V686_LOFT_FS_BUG_FIXES",
            'SKIP_687': "SKIP_687",
            'SKIP_688': "SKIP_688",
            'SKIP_689': "SKIP_689",
            'SKIP_690': "SKIP_690",
            'V691_FILL_GUIDE_CURVES': "V691_FILL_GUIDE_CURVES",
            'V692_VECTOR_IMPRINT': "V692_VECTOR_IMPRINT",
            'V693_SM_PATTERN': "V693_SM_PATTERN",
            'V694_FILL_GUIDE_CURVES_FS': "V694_FILL_GUIDE_CURVES_FS",
            'V695_SM_SWEPT_SUPPORT': "V695_SM_SWEPT_SUPPORT",
            'V696_REMOVE_ADDED_REDUNDANCY': "V696_REMOVE_ADDED_REDUNDANCY",
            'V697_FILL_UPDATE': "V697_FILL_UPDATE",
            'V698_EXTEND_SHEET_PERIODIC': "V698_EXTEND_SHEET_PERIODIC",
            'V699_SM_PATTERN_FIXES': "V699_SM_PATTERN_FIXES",
            'V700_REVERTED_TANGENT_JOINT': "V700_REVERTED_TANGENT_JOINT",
            'V701_REVERTED_SM_FACE_PATTERN': "V701_REVERTED_SM_FACE_PATTERN",
            'SKIP_702': "SKIP_702",
            'V703_EXTERNAL_ROLL_BACK': "V703_EXTERNAL_ROLL_BACK",
            'V704_MOVE_FACE_ROLLED_SM': "V704_MOVE_FACE_ROLLED_SM",
            'V705_G2_CURVES': "V705_G2_CURVES",
            'V706_SM_PATTERN_RIP': "V706_SM_PATTERN_RIP",
            'V707_FITSPLINE_UPGRADE': "V707_FITSPLINE_UPGRADE",
            'V708_SM_BOOLEAN': "V708_SM_BOOLEAN",
            'SKIP_709': "SKIP_709",
            'SKIP_710': "SKIP_710",
            'V711_LOFT_BUG_FIX': "V711_LOFT_BUG_FIX",
            'V712_SKIP_TARGET_BOOLEAN': "V712_SKIP_TARGET_BOOLEAN",
            'V713_SM_PATTERN_COLORS': "V713_SM_PATTERN_COLORS",
            'V714_SM_BEND_DETERMINISM': "V714_SM_BEND_DETERMINISM",
            'V715_SM_PATTERN_FAIL_MIRROR': "V715_SM_PATTERN_FAIL_MIRROR",
            'V716_PS_VERSION_30_0_280': "V716_PS_VERSION_30_0_280",
            'V717_DEFER_SM_BODY_DELETE_2': "V717_DEFER_SM_BODY_DELETE_2",
            'V718_ADD_DEPRECATED_FS_FOR_MOBILE': "V718_ADD_DEPRECATED_FS_FOR_MOBILE",
            'SKIP_719': "SKIP_719",
            'SKIP_720': "SKIP_720",
            'SKIP_721': "SKIP_721",
            'V722_DELETE_FACE_REDUNDANCY': "V722_DELETE_FACE_REDUNDANCY",
            'V723_REMAP_TAB_BREAKS': "V723_REMAP_TAB_BREAKS",
            'V724_SM_MAKE_JOINT_TYPE': "V724_SM_MAKE_JOINT_TYPE",
            'V725_FLANGE_ROLLED_SIDE': "V725_FLANGE_ROLLED_SIDE",
            'V726_ROLLED_CORNER_RELIEF': "V726_ROLLED_CORNER_RELIEF",
            'V727_SM_SUPPORT_ROLLED': "V727_SM_SUPPORT_ROLLED",
            'V728_ACTIVE_SKETCH_ON_FLAT': "V728_ACTIVE_SKETCH_ON_FLAT",
            'V729_UPGRADE_FIXES': "V729_UPGRADE_FIXES",
            'V730_EXTEND_SHEET_BODY_INTERSECTION_CLASSIFICATION': "V730_EXTEND_SHEET_BODY_INTERSECTION_CLASSIFICATION",
            'V731_SM_BLEND_PARTIAL': "V731_SM_BLEND_PARTIAL",
            'V732_HOLE_PROPAGATE_EDGE': "V732_HOLE_PROPAGATE_EDGE",
            'V733_EDGE_CHANGE': "V733_EDGE_CHANGE",
            'V734_PS_VERSION_30_1_168': "V734_PS_VERSION_30_1_168",
            'V735_MOVE_FACE_BUG_FIXES': "V735_MOVE_FACE_BUG_FIXES",
            'V736_SM_74': "V736_SM_74",
            'SKIP_737': "SKIP_737",
            'SKIP_738': "SKIP_738",
            'SKIP_739': "SKIP_739",
            'V740_PROPAGATE_PROPERTIES_IN_PATTERNS': "V740_PROPAGATE_PROPERTIES_IN_PATTERNS",
            'V741_FLATTENED_BEND_SWAP': "V741_FLATTENED_BEND_SWAP",
            'V742_REPLACE_FACES_UPGRADE': "V742_REPLACE_FACES_UPGRADE",
            'V743_EDGE_ORIENTATION': "V743_EDGE_ORIENTATION",
            'V744_SM_FLANGE_PATTERN_EDGE_CHANGE': "V744_SM_FLANGE_PATTERN_EDGE_CHANGE",
            'V745_COMPRESSED_QUERIES': "V745_COMPRESSED_QUERIES",
            'V746_EXTERNAL_DISAMBIGUATION': "V746_EXTERNAL_DISAMBIGUATION",
            'V747_SPLIT_ALLOW_FACES': "V747_SPLIT_ALLOW_FACES",
            'V748_SM_FAIL_SHEET_DELETION': "V748_SM_FAIL_SHEET_DELETION",
            'V749_SPLIT_UX_FIXES': "V749_SPLIT_UX_FIXES",
            'SKIP_750': "SKIP_750",
            'SKIP_751': "SKIP_751",
            'SKIP_752': "SKIP_752",
            'SKIP_753': "SKIP_753",
            'SKIP_754': "SKIP_754",
            'SKIP_755': "SKIP_755",
            'SKIP_756': "SKIP_756",
            'SKIP_757': "SKIP_757",
            'V758_PATTERN_MATE_CONNECTORS': "V758_PATTERN_MATE_CONNECTORS",
            'V759_MULTI_MODEL_SM_REBUILD': "V759_MULTI_MODEL_SM_REBUILD",
            'V760_LOFT_REFACTOR': "V760_LOFT_REFACTOR",
            'V761_WIRE_EDGE_DET_ID': "V761_WIRE_EDGE_DET_ID",
            'V762_FLANGE_NEAR_ROLLED': "V762_FLANGE_NEAR_ROLLED",
            'V763_HOLE_CUT_ALL': "V763_HOLE_CUT_ALL",
            'V764_EDGE_PATTERN': "V764_EDGE_PATTERN",
            'V765_SM_PATTERN_FAIL_MIRROR_2': "V765_SM_PATTERN_FAIL_MIRROR_2",
            'SKIP_766': "SKIP_766",
            'SKIP_767': "SKIP_767",
            'SKIP_768': "SKIP_768",
            'SKIP_769': "SKIP_769",
            'SKIP_770': "SKIP_770",
            'SKIP_771': "SKIP_771",
            'SKIP_772': "SKIP_772",
            'SKIP_773': "SKIP_773",
            'SKIP_774': "SKIP_774",
            'V775_DETACHED_FILLET': "V775_DETACHED_FILLET",
            'V776_SURFACE_JOIN_BUG_FIX': "V776_SURFACE_JOIN_BUG_FIX",
            'V777_HOLE_ATTRIBUTE_FIX': "V777_HOLE_ATTRIBUTE_FIX",
            'V778_MOVE_FACE_UPGRADE': "V778_MOVE_FACE_UPGRADE",
            'V779_BOOLEAN_TRACK_MERGE': "V779_BOOLEAN_TRACK_MERGE",
            'V780_THICKEN_STRICT_ORDER': "V780_THICKEN_STRICT_ORDER",
            'V781_THREE_BEND_SIZED': "V781_THREE_BEND_SIZED",
            'V782_HOLE_ERROR_REPORTING': "V782_HOLE_ERROR_REPORTING",
            'SKIP_783': "SKIP_783",
            'SKIP_784': "SKIP_784",
            'SKIP_785': "SKIP_785",
            'SKIP_786': "SKIP_786",
            'SKIP_787': "SKIP_787",
            'SKIP_788': "SKIP_788",
            'SKIP_789': "SKIP_789",
            'SKIP_790': "SKIP_790",
            'SKIP_791': "SKIP_791",
            'V792_OFFSET_CORRECT_LOOP': "V792_OFFSET_CORRECT_LOOP",
            'V793_CHECK_UNROLLED_MATCH': "V793_CHECK_UNROLLED_MATCH",
            'V794_EDGE_PATTERN_BREAKS': "V794_EDGE_PATTERN_BREAKS",
            'V795_SPLIT_FIXES': "V795_SPLIT_FIXES",
            'V796_PLANE_ORIENTATION_INSTABILITY': "V796_PLANE_ORIENTATION_INSTABILITY",
            'V797_EDGE_DISAMBIGUATION': "V797_EDGE_DISAMBIGUATION",
            'V798_BOOLEAN_TRACKING': "V798_BOOLEAN_TRACKING",
            'V799_FIX_UNROLL_ORIGIN': "V799_FIX_UNROLL_ORIGIN",
            'SKIP_800': "SKIP_800",
            'SKIP_801': "SKIP_801",
            'SKIP_802': "SKIP_802",
            'SKIP_803': "SKIP_803",
            'SKIP_804': "SKIP_804",
            'SKIP_805': "SKIP_805",
            'SKIP_806': "SKIP_806",
            'SKIP_807': "SKIP_807",
            'SKIP_808': "SKIP_808",
            'SKIP_809': "SKIP_809",
            'V810_EXTRUDE_OFFSET_EDGE_CAP': "V810_EXTRUDE_OFFSET_EDGE_CAP",
            'V811_BRACKETS_CONFIG_ACCESS': "V811_BRACKETS_CONFIG_ACCESS",
            'V812_PS_VERSION_30_1_232': "V812_PS_VERSION_30_1_232",
            'V813_FILLET_BEND': "V813_FILLET_BEND",
            'V814_EDGE_CHANGE_PRECISION': "V814_EDGE_CHANGE_PRECISION",
            'V815_STABLE_SWEPT_EDGE': "V815_STABLE_SWEPT_EDGE",
            'V816_FAST_FEATURE_PATTERN': "V816_FAST_FEATURE_PATTERN",
            'V817_SM_OPTIMIZATION': "V817_SM_OPTIMIZATION",
            'V818_FFP_FIX': "V818_FFP_FIX",
            'V819_ERROR_STRING_ENUM_ASSEMBLY_PATTERN_EXCEED_MAX_INSTANCE_COUNT': "V819_ERROR_STRING_ENUM_ASSEMBLY_PATTERN_EXCEED_MAX_INSTANCE_COUNT",
            'SKIP_820': "SKIP_820",
            'SKIP_821': "SKIP_821",
            'SKIP_822': "SKIP_822",
            'SKIP_823': "SKIP_823",
            'SKIP_824': "SKIP_824",
            'SKIP_825': "SKIP_825",
            'SKIP_826': "SKIP_826",
            'SKIP_827': "SKIP_827",
            'V828_DRAFT_ONLY_SELECTED': "V828_DRAFT_ONLY_SELECTED",
            'V829_REDEFINE_BEND_RELIEF_SCALE': "V829_REDEFINE_BEND_RELIEF_SCALE",
            'V830_SWEPT_EDGE_ON_VERTEX': "V830_SWEPT_EDGE_ON_VERTEX",
            'V831_HOLE_TOLERANT_DIST': "V831_HOLE_TOLERANT_DIST",
            'V832_PARTING_LINE_DRAFT': "V832_PARTING_LINE_DRAFT",
            'V833_PARTING_LINE_DRAFT_FIXES': "V833_PARTING_LINE_DRAFT_FIXES",
            'V834_PARTING_LINE_DRAFT_FLIP': "V834_PARTING_LINE_DRAFT_FLIP",
            'SKIP_835': "SKIP_835",
            'SKIP_836': "SKIP_836",
            'SKIP_837': "SKIP_837",
            'SKIP_838': "SKIP_838",
            'SKIP_839': "SKIP_839",
            'SKIP_840': "SKIP_840",
            'SKIP_841': "SKIP_841",
            'SKIP_842': "SKIP_842",
            'V843_RESTORE_COPY_VS_MODIFY': "V843_RESTORE_COPY_VS_MODIFY",
            'V844_PS_VERSION_30_1_256': "V844_PS_VERSION_30_1_256",
            'V845_SM_BUG_FIXES': "V845_SM_BUG_FIXES",
            'V846_ERROR_STRING_VERSION_BUMP': "V846_ERROR_STRING_VERSION_BUMP",
            'V847_PL_DRAFT_STABLE': "V847_PL_DRAFT_STABLE",
            'SKIP_848': "SKIP_848",
            'SKIP_849': "SKIP_849",
            'SKIP_850': "SKIP_850",
            'SKIP_851': "SKIP_851",
            'SKIP_852': "SKIP_852",
            'SKIP_853': "SKIP_853",
            'SKIP_854': "SKIP_854",
            'SKIP_855': "SKIP_855",
            'V856_EVCURVATURE_RENAME': "V856_EVCURVATURE_RENAME",
            'V857_BEND_INTERVAL': "V857_BEND_INTERVAL",
            'V858_SM_FLAT_BUG_FIXES': "V858_SM_FLAT_BUG_FIXES",
            'V859_SM_HOLE_ATTRIBUTE': "V859_SM_HOLE_ATTRIBUTE",
            'V860_SM_FLAT_ERRORS': "V860_SM_FLAT_ERRORS",
            'SKIP_861': "SKIP_861",
            'SKIP_862': "SKIP_862",
            'SKIP_863': "SKIP_863",
            'SKIP_864': "SKIP_864",
            'SKIP_865': "SKIP_865",
            'SKIP_866': "SKIP_866",
            'SKIP_867': "SKIP_867",
            'SKIP_868': "SKIP_868",
            'SKIP_869': "SKIP_869",
            'V870_DELETE_SKETCH_UNFOLD_FAILURE': "V870_DELETE_SKETCH_UNFOLD_FAILURE",
            'V871_MATE_CONNECTORS_AS_AXES': "V871_MATE_CONNECTORS_AS_AXES",
            'V872_DCM_VERSION_68_2_2': "V872_DCM_VERSION_68_2_2",
            'V873_SM_OFFSET_ORDER': "V873_SM_OFFSET_ORDER",
            'V874_CORNER_BY_BODY': "V874_CORNER_BY_BODY",
            'V875_MC_USE_BOTTOM_AXIS_FIX': "V875_MC_USE_BOTTOM_AXIS_FIX",
            'V876_PS_VERSION_31_0_154': "V876_PS_VERSION_31_0_154",
            'V877_SM_CORNERS': "V877_SM_CORNERS",
            'SKIP_878': "SKIP_878",
            'SKIP_879': "SKIP_879",
            'SKIP_880': "SKIP_880",
            'SKIP_881': "SKIP_881",
            'SKIP_882': "SKIP_882",
            'SKIP_883': "SKIP_883",
            'SKIP_884': "SKIP_884",
            'SKIP_885': "SKIP_885",
            'SKIP_886': "SKIP_886",
            'SKIP_887': "SKIP_887",
            'V888_MATE_CONNECTOR_REMAP': "V888_MATE_CONNECTOR_REMAP",
            'V889_IMPORT_WITH_FAULTS_PARAM': "V889_IMPORT_WITH_FAULTS_PARAM",
            'V890_FIX_FIT_SPLINE': "V890_FIX_FIT_SPLINE",
            'V891_EXPOSE_REFERENCE_PARAMETER': "V891_EXPOSE_REFERENCE_PARAMETER",
            'SKIP_892': "SKIP_892",
            'SKIP_893': "SKIP_893",
            'SKIP_894': "SKIP_894",
            'SKIP_895': "SKIP_895",
            'SKIP_896': "SKIP_896",
            'SKIP_897': "SKIP_897",
            'SKIP_898': "SKIP_898",
            'SKIP_899': "SKIP_899",
            'V900_USE_CIRCLE': "V900_USE_CIRCLE",
            'V901_DET_ID_FIRST': "V901_DET_ID_FIRST",
            'SKIP_902': "SKIP_902",
            'SKIP_903': "SKIP_903",
            'SKIP_904': "SKIP_904",
            'SKIP_905': "SKIP_905",
            'SKIP_906': "SKIP_906",
            'SKIP_907': "SKIP_907",
            'SKIP_908': "SKIP_908",
            'SKIP_909': "SKIP_909",
            'SKIP_910': "SKIP_910",
            'SKIP_911': "SKIP_911",
            'V912_TRACK_TRANFORMS': "V912_TRACK_TRANFORMS",
            'V913_TOOL_CLASH_FINE': "V913_TOOL_CLASH_FINE",
            'V914_SM_JOINT_TO_WALL': "V914_SM_JOINT_TO_WALL",
            'V915_PS_VERSION_31_0_203': "V915_PS_VERSION_31_0_203",
            'V916_DERIVED_VISIBILITY': "V916_DERIVED_VISIBILITY",
            'V917_SM_BOOLEAN_MATCH': "V917_SM_BOOLEAN_MATCH",
            'V918_SM_BOOLEAN_TOOLS': "V918_SM_BOOLEAN_TOOLS",
            'V919_SPLIT_JOINT_TYPO': "V919_SPLIT_JOINT_TYPO",
            'V920_FS_ROUND_TO_PRECISION': "V920_FS_ROUND_TO_PRECISION",
            'SKIP_921': "SKIP_921",
            'SKIP_922': "SKIP_922",
            'SKIP_923': "SKIP_923",
            'SKIP_924': "SKIP_924",
            'SKIP_925': "SKIP_925",
            'SKIP_926': "SKIP_926",
            'SKIP_927': "SKIP_927",
            'SKIP_928': "SKIP_928",
            'V929_SM_ALIGN_UNROLLED': "V929_SM_ALIGN_UNROLLED",
            'V930_SUBQUERY_STABILIZATION': "V930_SUBQUERY_STABILIZATION",
            'V931_MESH_BOOLEAN': "V931_MESH_BOOLEAN",
            'V932_SPLIT_PART_BOX': "V932_SPLIT_PART_BOX",
            'V933_SM_MOVE_FACE_NO_MERGE': "V933_SM_MOVE_FACE_NO_MERGE",
            'V934_FIT_SPLINE_PARAM': "V934_FIT_SPLINE_PARAM",
            'V935_FILL_TRACKING_FIXES': "V935_FILL_TRACKING_FIXES",
            'V936_CUSTOM_PROPERTY_DOC_FIX': "V936_CUSTOM_PROPERTY_DOC_FIX",
            'V937_SM_RADIUS_BOUNDS_FIX': "V937_SM_RADIUS_BOUNDS_FIX",
            'SKIP_938': "SKIP_938",
            'SKIP_939': "SKIP_939",
            'SKIP_940': "SKIP_940",
            'SKIP_941': "SKIP_941",
            'SKIP_942': "SKIP_942",
            'SKIP_943': "SKIP_943",
            'SKIP_944': "SKIP_944",
            'V945_STOP_REQUIRING_MATE_CONNECTOR_OWNER_PART': "V945_STOP_REQUIRING_MATE_CONNECTOR_OWNER_PART",
            'V946_BEND_RELIEF_PLACEMENT': "V946_BEND_RELIEF_PLACEMENT",
            'V947_EVDISTANCE_ARCLENGTH': "V947_EVDISTANCE_ARCLENGTH",
            'V948_BOOLEAN_TOOLS_STRICTER': "V948_BOOLEAN_TOOLS_STRICTER",
            'V949_BLOCK_EXCESSIVE_MERGE': "V949_BLOCK_EXCESSIVE_MERGE",
            'V950_PARTIAL_BEND_CUT': "V950_PARTIAL_BEND_CUT",
            'V951_FAIL_SURFACE_BOOLEAN': "V951_FAIL_SURFACE_BOOLEAN",
            'SKIP_952': "SKIP_952",
            'SKIP_953': "SKIP_953",
            'SKIP_954': "SKIP_954",
            'SKIP_955': "SKIP_955",
            'SKIP_956': "SKIP_956",
            'SKIP_957': "SKIP_957",
            'SKIP_958': "SKIP_958",
            'V959_SKETCH_FAIL_SPLIT_VERTEX': "V959_SKETCH_FAIL_SPLIT_VERTEX",
            'V960_HOLE_IDENTITY': "V960_HOLE_IDENTITY",
            'V961_HEM_AS_BEND': "V961_HEM_AS_BEND",
            'SKIP_962': "SKIP_962",
            'SKIP_963': "SKIP_963",
            'SKIP_964': "SKIP_964",
            'SKIP_965': "SKIP_965",
            'SKIP_966': "SKIP_966",
            'SKIP_967': "SKIP_967",
            'SKIP_968': "SKIP_968",
            'SKIP_969': "SKIP_969",
            'SKIP_970': "SKIP_970",
            'SKIP_971': "SKIP_971",
            'V972_PS_VERSION_31_0_249': "V972_PS_VERSION_31_0_249",
            'V973_TOLERANT_LOFT': "V973_TOLERANT_LOFT",
            'V974_ERROR_AFTER_SPLIT': "V974_ERROR_AFTER_SPLIT",
            'V975_BEND_LINE_EXTENTS': "V975_BEND_LINE_EXTENTS",
            'SKIP_976': "SKIP_976",
            'SKIP_977': "SKIP_977",
            'SKIP_978': "SKIP_978",
            'SKIP_979': "SKIP_979",
            'SKIP_980': "SKIP_980",
            'SKIP_981': "SKIP_981",
            'SKIP_982': "SKIP_982",
            'SKIP_983': "SKIP_983",
            'V984_DCM_VERSION_69_1_0': "V984_DCM_VERSION_69_1_0",
            'V985_BEND_SMOOTHING': "V985_BEND_SMOOTHING",
            'V986_STRICT_INTERSECT': "V986_STRICT_INTERSECT",
            'V987_DERIP_SIGNED_DISTANCE': "V987_DERIP_SIGNED_DISTANCE",
            'V988_FIX_HELIX_START': "V988_FIX_HELIX_START",
            'V989_ENCLOSE_DONT_DELETE_SKETCHES': "V989_ENCLOSE_DONT_DELETE_SKETCHES",
            'V990_REFERENCE_PARAMETER_IN_INSTANCE': "V990_REFERENCE_PARAMETER_IN_INSTANCE",
            'V991_ROLL_SURFACE_BUMP': "V991_ROLL_SURFACE_BUMP",
            'V992_FLANGE_END_FIX': "V992_FLANGE_END_FIX",
            'V993_CLAMP_BASE_CONTEXT_VERSION': "V993_CLAMP_BASE_CONTEXT_VERSION",
            'SKIP_994': "SKIP_994",
            'SKIP_995': "SKIP_995",
            'SKIP_996': "SKIP_996",
            'SKIP_997': "SKIP_997",
            'SKIP_998': "SKIP_998",
            'SKIP_999': "SKIP_999",
            'V1000_FEATURESCRIPT_V1K': "V1000_FEATURESCRIPT_V1K",
            'V1001_COMPARE_ORIGINALS': "V1001_COMPARE_ORIGINALS",
            'V1002_UNHIDE_MATE_CONNECTOR_FLIP_PARAMETERS': "V1002_UNHIDE_MATE_CONNECTOR_FLIP_PARAMETERS",
            'V1003_DUMMY_FEATURE': "V1003_DUMMY_FEATURE",
            'V1004_MATE_CONNECTOR_AS_PLANE': "V1004_MATE_CONNECTOR_AS_PLANE",
            'V1005_INTERNAL_HEM': "V1005_INTERNAL_HEM",
            'V1006_CPLANE_MATE_CONNECTOR': "V1006_CPLANE_MATE_CONNECTOR",
            'V1007_RENAME_AXIS_PARAM': "V1007_RENAME_AXIS_PARAM",
            'V1008_SKIP_MATE_CONNECTOR_PATTERNS': "V1008_SKIP_MATE_CONNECTOR_PATTERNS",
            'V1009_SM_BOOLEAN_TRACK': "V1009_SM_BOOLEAN_TRACK",
            'V1010_SECTION_PART_NO_NEGATIVE_DEPTH': "V1010_SECTION_PART_NO_NEGATIVE_DEPTH",
            'SKIP_1011': "SKIP_1011",
            'SKIP_1012': "SKIP_1012",
            'SKIP_1013': "SKIP_1013",
            'SKIP_1014': "SKIP_1014",
            'V1015_SUBSTUTUTION_EVAL': "V1015_SUBSTUTUTION_EVAL",
            'V1016_EXPECTED_VECTOR_SIZE': "V1016_EXPECTED_VECTOR_SIZE",
            'V1017_SUBTRACT_COMPLEMENT': "V1017_SUBTRACT_COMPLEMENT",
            'V1018_DERIVED': "V1018_DERIVED",
            'V1019_PS_VERSION_31_1_188': "V1019_PS_VERSION_31_1_188",
            'V1020_SURFACE_BOOLEAN': "V1020_SURFACE_BOOLEAN",
            'V1021_HOLE_MATE_CONNECTOR_CSYS': "V1021_HOLE_MATE_CONNECTOR_CSYS",
            'V1022_FIX_MASS_PROPS': "V1022_FIX_MASS_PROPS",
            'V1023_FIX_HOLE_NAME': "V1023_FIX_HOLE_NAME",
            'V1024_UPDATE_DOCS': "V1024_UPDATE_DOCS",
            'SKIP_1025': "SKIP_1025",
            'SKIP_1026': "SKIP_1026",
            'SKIP_1027': "SKIP_1027",
            'SKIP_1028': "SKIP_1028",
            'SKIP_1029': "SKIP_1029",
            'SKIP_1030': "SKIP_1030",
            'V1031_BODY_NET_IN_LOFT': "V1031_BODY_NET_IN_LOFT",
            'V1032_MESH_SCALING_IN_TRANSLATOR': "V1032_MESH_SCALING_IN_TRANSLATOR",
            'V1033_BODY_NET_IN_FILL': "V1033_BODY_NET_IN_FILL",
            'V1034_EVRAYCAST_FIX': "V1034_EVRAYCAST_FIX",
            'V1035_SURFACE_MATCH': "V1035_SURFACE_MATCH",
            'V1036_IMPORT_NAMES_AND_COLORS': "V1036_IMPORT_NAMES_AND_COLORS",
            'SKIP_1037': "SKIP_1037",
            'SKIP_1038': "SKIP_1038",
            'SKIP_1039': "SKIP_1039",
            'SKIP_1040': "SKIP_1040",
            'SKIP_1041': "SKIP_1041",
            'SKIP_1042': "SKIP_1042",
            'SKIP_1043': "SKIP_1043",
            'V1044_COPLANAR_PLANES': "V1044_COPLANAR_PLANES",
            'V1045_SHEET_BOOLEAN_ALIGN_FACE': "V1045_SHEET_BOOLEAN_ALIGN_FACE",
            'V1046_FAILED_PARAMETERS': "V1046_FAILED_PARAMETERS",
            'V1047_MOVE_FACE_JOINTS': "V1047_MOVE_FACE_JOINTS",
            'V1048_FLANGE_AND_HEM_EDGES': "V1048_FLANGE_AND_HEM_EDGES",
            'V1049_COMMON_FS': "V1049_COMMON_FS",
            'V1050_HEM_REATED_FIXES': "V1050_HEM_REATED_FIXES",
            'V1051_SM_MOVE_FACE_BEND_ERROR': "V1051_SM_MOVE_FACE_BEND_ERROR",
            'V1052_HEM_BUMP': "V1052_HEM_BUMP",
            'V1053_HEM_RELEASE': "V1053_HEM_RELEASE",
            'SKIP_1054': "SKIP_1054",
            'SKIP_1055': "SKIP_1055",
            'SKIP_1056': "SKIP_1056",
            'SKIP_1057': "SKIP_1057",
            'V1058_PS_VERSION_31_1_232': "V1058_PS_VERSION_31_1_232",
            'V1059_SM_ALIGMENT': "V1059_SM_ALIGMENT",
            'V1060_SET_CHAMFERS_SEPARATELY': "V1060_SET_CHAMFERS_SEPARATELY",
            'V1061_DISAMBIGUATE_COPY': "V1061_DISAMBIGUATE_COPY",
            'V1062_GET_SM_ENTS': "V1062_GET_SM_ENTS",
            'V1063_ORPHANED_BEND': "V1063_ORPHANED_BEND",
            'SKIP_1064': "SKIP_1064",
            'SKIP_1065': "SKIP_1065",
            'SKIP_1066': "SKIP_1066",
            'SKIP_1067': "SKIP_1067",
            'SKIP_1068': "SKIP_1068",
            'SKIP_1069': "SKIP_1069",
            'SKIP_1070': "SKIP_1070",
            'SKIP_1071': "SKIP_1071",
            'SKIP_1072': "SKIP_1072",
            'V1073_REFINE_SKETCH_INTERSECTIONS': "V1073_REFINE_SKETCH_INTERSECTIONS",
            'V1074_SKIP_IN_CONTEXT_PATTERN': "V1074_SKIP_IN_CONTEXT_PATTERN",
            'V1075_DEDUPLICATE_CREATE': "V1075_DEDUPLICATE_CREATE",
            'V1076_TRANSIENT_QUERY': "V1076_TRANSIENT_QUERY",
            'V1077_ERROR_STRING': "V1077_ERROR_STRING",
            'SKIP_1078': "SKIP_1078",
            'SKIP_1079': "SKIP_1079",
            'SKIP_1080': "SKIP_1080",
            'SKIP_1081': "SKIP_1081",
            'SKIP_1082': "SKIP_1082",
            'SKIP_1083': "SKIP_1083",
            'SKIP_1084': "SKIP_1084",
            'SKIP_1085': "SKIP_1085",
            'V1086_EDGE_PATTERN_THICKNESS': "V1086_EDGE_PATTERN_THICKNESS",
            'V1087_EXTEND_SURFACE': "V1087_EXTEND_SURFACE",
            'V1088_SUBSTITUTION_EVAL': "V1088_SUBSTITUTION_EVAL",
            'V1089_SKETCH_CURVATURE_CONSTRAINT': "V1089_SKETCH_CURVATURE_CONSTRAINT",
            'V1090_KEEP_SKETCHES_IN_SECTION_CUT': "V1090_KEEP_SKETCHES_IN_SECTION_CUT",
            'V1091_BUMP_FOR_FEATURE_SPECS_TRANSLATION': "V1091_BUMP_FOR_FEATURE_SPECS_TRANSLATION",
            'V1092_SURFACE_MATE_CONNECTOR_OWNER': "V1092_SURFACE_MATE_CONNECTOR_OWNER",
            'V1093_HOLE_THREAD_FIX': "V1093_HOLE_THREAD_FIX",
            'V1094_HOLE_SM_FIX': "V1094_HOLE_SM_FIX",
            'V1095_INTERNAL_FEATURE': "V1095_INTERNAL_FEATURE",
            'V1096_FIX_STD': "V1096_FIX_STD",
            'SKIP_1097': "SKIP_1097",
            'SKIP_1098': "SKIP_1098",
            'SKIP_1099': "SKIP_1099",
            'SKIP_1100': "SKIP_1100",
            'V1101_SM_BEND_END': "V1101_SM_BEND_END",
            'V1102_DCM_VERSION_70_0_0': "V1102_DCM_VERSION_70_0_0",
            'V1103_CONSTRUCTION_VERTEX_CHANGE': "V1103_CONSTRUCTION_VERTEX_CHANGE",
            'V1104_WRAP': "V1104_WRAP",
            'V1105_ALLOW_SHEETS_IN_SECTION': "V1105_ALLOW_SHEETS_IN_SECTION",
            'V1106_WRAP_BUMP': "V1106_WRAP_BUMP",
            'V1107_HOLE_SELECTION': "V1107_HOLE_SELECTION",
            'V1108_HOLE_TAP_FIX': "V1108_HOLE_TAP_FIX",
            'V1109_CLUSTER_VERTICES': "V1109_CLUSTER_VERTICES",
            'V1110_WRAP_POSTPONED': "V1110_WRAP_POSTPONED",
            'V1111_LOFT_VERTEX': "V1111_LOFT_VERTEX",
            'V1112_LOFT_VERTEX_REGEN': "V1112_LOFT_VERTEX_REGEN",
            'SKIP_1113': "SKIP_1113",
            'SKIP_1114': "SKIP_1114",
            'V1115_SM_CORNER_FIX': "V1115_SM_CORNER_FIX",
            'V1116_WRAP_OVERLAP_CHECK': "V1116_WRAP_OVERLAP_CHECK",
            'V1117_NO_GUIDES_ERROR': "V1117_NO_GUIDES_ERROR",
            'V1118_SKETCH_TEXT_CONSTRUCTION': "V1118_SKETCH_TEXT_CONSTRUCTION",
            'V1119_INTERNAL_ENUM_VALUE': "V1119_INTERNAL_ENUM_VALUE",
            'V1120_SCALE_NONUNIFORMLY': "V1120_SCALE_NONUNIFORMLY",
            'SKIP_1121': "SKIP_1121",
            'SKIP_1122': "SKIP_1122",
            'SKIP_1123': "SKIP_1123",
            'SKIP_1124': "SKIP_1124",
            'SKIP_1125': "SKIP_1125",
            'SKIP_1126': "SKIP_1126",
            'SKIP_1127': "SKIP_1127",
            'V1128_PATTERN_OF_ONE': "V1128_PATTERN_OF_ONE",
            'V1129_NEWLY_LAMINAR_SPLIT': "V1129_NEWLY_LAMINAR_SPLIT",
            'V1130_SURFACING_IMPROVEMENTS': "V1130_SURFACING_IMPROVEMENTS",
            'V1131_DISALLOW_SPLIT_IN_COPY': "V1131_DISALLOW_SPLIT_IN_COPY",
            'V1132_WRAP_RELEASE': "V1132_WRAP_RELEASE",
            'V1133_BLIND_IN_LAST_FIX': "V1133_BLIND_IN_LAST_FIX",
            'V1134_WRAP_BUMP': "V1134_WRAP_BUMP",
            'V1135_HOLE_TAP_CHECK': "V1135_HOLE_TAP_CHECK",
            'SKIP_1136': "SKIP_1136",
            'SKIP_1137': "SKIP_1137",
            'SKIP_1138': "SKIP_1138",
            'SKIP_1139': "SKIP_1139",
            'SKIP_1140': "SKIP_1140",
            'SKIP_1141': "SKIP_1141",
            'V1142_HOLE_FIXES': "V1142_HOLE_FIXES",
            'V1143_ROLLED_OUTLINE_INNER_LOOPS': "V1143_ROLLED_OUTLINE_INNER_LOOPS",
            'V1144_PS_VERSION_32_0_152': "V1144_PS_VERSION_32_0_152",
            'V1145_SKETCH_HELPERS_CONSTRUCTION': "V1145_SKETCH_HELPERS_CONSTRUCTION",
            'V1146_COMPOSITE_ERROR_VERSION_BUMP': "V1146_COMPOSITE_ERROR_VERSION_BUMP",
            'V1147_EDGE_BLEND_HISTORY': "V1147_EDGE_BLEND_HISTORY",
            'V1148_SECTION_PART': "V1148_SECTION_PART",
            'V1149_COMPOSITE_INPUT_CHECKS': "V1149_COMPOSITE_INPUT_CHECKS",
            'V1150_COMPOSITE_FEATURE_PATTERN': "V1150_COMPOSITE_FEATURE_PATTERN",
            'SKIP_1151': "SKIP_1151",
            'SKIP_1152': "SKIP_1152",
            'SKIP_1153': "SKIP_1153",
            'SKIP_1154': "SKIP_1154",
            'SKIP_1155': "SKIP_1155",
            'V1156_PS_VERSION_32_0_170': "V1156_PS_VERSION_32_0_170",
            'V1157_UNSTABLE_COMP_QUERY': "V1157_UNSTABLE_COMP_QUERY",
            'V1158_SM_UNFOLDER': "V1158_SM_UNFOLDER",
            'V1159_BETTER_HOLE_TAGS': "V1159_BETTER_HOLE_TAGS",
            'V1160_SECTION_PART': "V1160_SECTION_PART",
            'SKIP_1161': "SKIP_1161",
            'SKIP_1162': "SKIP_1162",
            'SKIP_1163': "SKIP_1163",
            'SKIP_1164': "SKIP_1164",
            'SKIP_1165': "SKIP_1165",
            'SKIP_1166': "SKIP_1166",
            'SKIP_1167': "SKIP_1167",
            'SKIP_1168': "SKIP_1168",
            'V1169_UVMAPPER_TOLERANCE': "V1169_UVMAPPER_TOLERANCE",
            'V1170_ROLLED_OUTLINE_REVERT': "V1170_ROLLED_OUTLINE_REVERT",
            'V1171_BCURVE_DEFINITION_ADJUST': "V1171_BCURVE_DEFINITION_ADJUST",
            'V1172_LOFT_BUG': "V1172_LOFT_BUG",
            'V1173_BSPLINESRUFACE_BUMP': "V1173_BSPLINESRUFACE_BUMP",
            'V1174_BSPLINESRUFACE_BUMP_2': "V1174_BSPLINESRUFACE_BUMP_2",
            'SKIP_1175': "SKIP_1175",
            'SKIP_1176': "SKIP_1176",
            'SKIP_1177': "SKIP_1177",
            'SKIP_1178': "SKIP_1178",
            'SKIP_1179': "SKIP_1179",
            'SKIP_1180': "SKIP_1180",
            'SKIP_1181': "SKIP_1181",
            'SKIP_1182': "SKIP_1182",
            'V1183_SURFACE_AUTOMATCH_TOL': "V1183_SURFACE_AUTOMATCH_TOL",
            'V1184_BSPLINE_LIMITS': "V1184_BSPLINE_LIMITS",
            'V1185_COMPOSITE_PART_SELECT_ERROR': "V1185_COMPOSITE_PART_SELECT_ERROR",
            'V1186_COMPOSITE_QUERY': "V1186_COMPOSITE_QUERY",
            'V1187_COMPOSITE_DERIVE_MATE_CONNECTORS': "V1187_COMPOSITE_DERIVE_MATE_CONNECTORS",
            'V1188_FS_EXPOSE_COMPOSITE_PARTS': "V1188_FS_EXPOSE_COMPOSITE_PARTS",
            'SKIP_1189': "SKIP_1189",
            'SKIP_1190': "SKIP_1190",
            'SKIP_1191': "SKIP_1191",
            'SKIP_1192': "SKIP_1192",
            'SKIP_1193': "SKIP_1193",
            'SKIP_1194': "SKIP_1194",
            'V1195_CLEANUP_PLANES_BEFORE_BOOLEAN': "V1195_CLEANUP_PLANES_BEFORE_BOOLEAN",
            'V1196_FORCE_MERGE_DELETION': "V1196_FORCE_MERGE_DELETION",
            'V1197_DETECT_SURFACE_JOIN_CPP': "V1197_DETECT_SURFACE_JOIN_CPP",
            'V1198_RECORD_SM_DEACTIVATION': "V1198_RECORD_SM_DEACTIVATION",
            'V1199_LOFT_COMPOSITE_CLAMP_FIX': "V1199_LOFT_COMPOSITE_CLAMP_FIX",
            'V1200_JOIN_SURFACE_PATTERN': "V1200_JOIN_SURFACE_PATTERN",
            'V1201_SURFACE_MIRROR_MERGE_WITH_ALL': "V1201_SURFACE_MIRROR_MERGE_WITH_ALL",
            'V1202_ERROR_MESSAGE_CHANGE_IN_REL': "V1202_ERROR_MESSAGE_CHANGE_IN_REL",
            'V1203_BOOLEAN_PATTERN_OF_ONE': "V1203_BOOLEAN_PATTERN_OF_ONE",
            'V1204_FIX_BOOLEAN_PATTERN_OF_ONE': "V1204_FIX_BOOLEAN_PATTERN_OF_ONE",
            'SKIP_1205': "SKIP_1205",
            'SKIP_1206': "SKIP_1206",
            'SKIP_1207': "SKIP_1207",
            'SKIP_1208': "SKIP_1208",
            'SKIP_1209': "SKIP_1209",
            'V1210_FROM_SKETCH_FIXES': "V1210_FROM_SKETCH_FIXES",
            'V1211_PS_VERSION_32_0_225': "V1211_PS_VERSION_32_0_225",
            'V1212_SKETCH_DUPLICATION': "V1212_SKETCH_DUPLICATION",
            'V1213_PATTERN_SECTION_ON_COMPOSITE': "V1213_PATTERN_SECTION_ON_COMPOSITE",
            'V1214_BETTER_COMPOSITE_DELETION': "V1214_BETTER_COMPOSITE_DELETION",
            'V1215_BOOLEANS_OF_SURFACES': "V1215_BOOLEANS_OF_SURFACES",
            'V1216_SECTION_PART_COMPOSITE': "V1216_SECTION_PART_COMPOSITE",
            'V1217_BOOLEANS_CHECK_CLASH_DETECTION': "V1217_BOOLEANS_CHECK_CLASH_DETECTION",
            'V1218_SECTION_PART_KEEP_COMPOSITES': "V1218_SECTION_PART_KEEP_COMPOSITES",
            'SKIP_1219': "SKIP_1219",
            'SKIP_1220': "SKIP_1220",
            'SKIP_1221': "SKIP_1221",
            'SKIP_1222': "SKIP_1222",
            'V1223_DIRECT_EDIT_STABILITY': "V1223_DIRECT_EDIT_STABILITY",
            'V1224_DRAWINGS_VERSION_BUMP': "V1224_DRAWINGS_VERSION_BUMP",
            'SKIP_1225': "SKIP_1225",
            'SKIP_1226': "SKIP_1226",
            'SKIP_1227': "SKIP_1227",
            'SKIP_1228': "SKIP_1228",
            'SKIP_1229': "SKIP_1229",
            'SKIP_1230': "SKIP_1230",
            'SKIP_1231': "SKIP_1231",
            'SKIP_1232': "SKIP_1232",
            'SKIP_1233': "SKIP_1233",
            'SKIP_1234': "SKIP_1234",
            'V1235_TAB_MERGE_AND_SUBTRACT': "V1235_TAB_MERGE_AND_SUBTRACT",
            'V1236_ERROR_MESSAGE_CHANGE_IN_REL': "V1236_ERROR_MESSAGE_CHANGE_IN_REL",
            'V1237_ASSEMBLY_SECTION_CUT_FIXES': "V1237_ASSEMBLY_SECTION_CUT_FIXES",
            'SKIP_1238': "SKIP_1238",
            'SKIP_1239': "SKIP_1239",
            'SKIP_1240': "SKIP_1240",
            'SKIP_1241': "SKIP_1241",
            'SKIP_1242': "SKIP_1242",
            'SKIP_1243': "SKIP_1243",
            'SKIP_1244': "SKIP_1244",
            'SKIP_1245': "SKIP_1245",
            'V1246_SM_SECTION_PART_FIXES': "V1246_SM_SECTION_PART_FIXES",
            'V1247_ERROR_STRING_BUMP': "V1247_ERROR_STRING_BUMP",
            'SKIP_1248': "SKIP_1248",
            'SKIP_1249': "SKIP_1249",
            'SKIP_1250': "SKIP_1250",
            'SKIP_1251': "SKIP_1251",
            'SKIP_1252': "SKIP_1252",
            'SKIP_1253': "SKIP_1253",
            'SKIP_1254': "SKIP_1254",
            'SKIP_1255': "SKIP_1255",
            'SKIP_1256': "SKIP_1256",
            'V1257_PS_VERSION_32_1_157': "V1257_PS_VERSION_32_1_157",
            'V1258_SHARED_DELETIONS': "V1258_SHARED_DELETIONS",
            'V1259_ATTACH_UNBOUNDED_CURVES': "V1259_ATTACH_UNBOUNDED_CURVES",
            'V1260_REVOLVE_LATERALS': "V1260_REVOLVE_LATERALS",
            'SKIP_1261': "SKIP_1261",
            'SKIP_1262': "SKIP_1262",
            'SKIP_1263': "SKIP_1263",
            'SKIP_1264': "SKIP_1264",
            'SKIP_1265': "SKIP_1265",
            'SKIP_1266': "SKIP_1266",
            'SKIP_1267': "SKIP_1267",
            'SKIP_1268': "SKIP_1268",
            'SKIP_1269': "SKIP_1269",
            'SKIP_1270': "SKIP_1270",
            'V1271_GENERAL_BODY_CHECK': "V1271_GENERAL_BODY_CHECK",
            'SKIP_1272': "SKIP_1272",
            'SKIP_1273': "SKIP_1273",
            'SKIP_1274': "SKIP_1274",
            'SKIP_1275': "SKIP_1275",
            'SKIP_1276': "SKIP_1276",
            'SKIP_1277': "SKIP_1277",
            'SKIP_1278': "SKIP_1278",
            'SKIP_1279': "SKIP_1279",
            'SKIP_1280': "SKIP_1280",
            'SKIP_1281': "SKIP_1281",
            'V1282_CUSTOMER_BUGS': "V1282_CUSTOMER_BUGS",
            'V1283_HOLE_REDUCE': "V1283_HOLE_REDUCE",
            'V1284_NORMALIZE': "V1284_NORMALIZE",
            'V1285_HOLE_SCOPE_DEFAULT': "V1285_HOLE_SCOPE_DEFAULT",
            'V1286_NORMAL_REVERT': "V1286_NORMAL_REVERT",
            'V1287_ERROR_STRING_BUMP': "V1287_ERROR_STRING_BUMP",
            'SKIP_1288': "SKIP_1288",
            'SKIP_1289': "SKIP_1289",
            'SKIP_1290': "SKIP_1290",
            'SKIP_1291': "SKIP_1291",
            'SKIP_1292': "SKIP_1292",
            'SKIP_1293': "SKIP_1293",
            'V1294_MULTI_BODY_MOVE_FACE': "V1294_MULTI_BODY_MOVE_FACE",
            'V1295_SECTION_SOLID_SURFACE_ONLY': "V1295_SECTION_SOLID_SURFACE_ONLY",
            'V1296_DELETE_ALL_FACES': "V1296_DELETE_ALL_FACES",
            'V1297_PS_VERSION_32_1_212': "V1297_PS_VERSION_32_1_212",
            'V1298_IMPORT_FACE_COLORS': "V1298_IMPORT_FACE_COLORS",
            'V1299_TABLES_ENABLED': "V1299_TABLES_ENABLED",
            'V1300_TABLE_DOCS': "V1300_TABLE_DOCS",
            'V1301_ALLOW_FACES_DOC': "V1301_ALLOW_FACES_DOC",
            'SKIP_1302': "SKIP_1302",
            'SKIP_1303': "SKIP_1303",
            'SKIP_1304': "SKIP_1304",
            'SKIP_1305': "SKIP_1305",
            'SKIP_1306': "SKIP_1306",
            'SKIP_1307': "SKIP_1307",
            'SKIP_1308': "SKIP_1308",
            'V1309_SPLIT_BODY_DISAMBIGUATION': "V1309_SPLIT_BODY_DISAMBIGUATION",
            'V1310_OWNER_BODY': "V1310_OWNER_BODY",
            'V1311_FIX_CONFIGURE_FACE_COLOR_SOURCE': "V1311_FIX_CONFIGURE_FACE_COLOR_SOURCE",
            'SKIP_1312': "SKIP_1312",
            'SKIP_1313': "SKIP_1313",
            'SKIP_1314': "SKIP_1314",
            'SKIP_1315': "SKIP_1315",
            'SKIP_1316': "SKIP_1316",
            'SKIP_1317': "SKIP_1317",
            'SKIP_1318': "SKIP_1318",
            'SKIP_1319': "SKIP_1319",
            'SKIP_1320': "SKIP_1320",
            'SKIP_1321': "SKIP_1321",
            'V1322_REUSE_COMPOSITE_BODY': "V1322_REUSE_COMPOSITE_BODY",
            'V1323_PROPERTY_SOURCE_TYPE': "V1323_PROPERTY_SOURCE_TYPE",
            'V1324_FLIP_NORMAL': "V1324_FLIP_NORMAL",
            'SKIP_1325': "SKIP_1325",
            'SKIP_1326': "SKIP_1326",
            'SKIP_1327': "SKIP_1327",
            'SKIP_1328': "SKIP_1328",
            'SKIP_1329': "SKIP_1329",
            'SKIP_1330': "SKIP_1330",
            'SKIP_1331': "SKIP_1331",
            'SKIP_1332': "SKIP_1332",
            'SKIP_1333': "SKIP_1333",
            'V1334_SPLIT_WITH_MATE_CONNECTOR': "V1334_SPLIT_WITH_MATE_CONNECTOR",
            'V1335_COMPARE_CURVATURES': "V1335_COMPARE_CURVATURES",
            'V1336_REVERT_SPLIT_DISAMBIGUATION': "V1336_REVERT_SPLIT_DISAMBIGUATION",
            'V1337_EXCLUDE_MESH_UPTO': "V1337_EXCLUDE_MESH_UPTO",
            'SKIP_1338': "SKIP_1338",
            'SKIP_1339': "SKIP_1339",
            'SKIP_1340': "SKIP_1340",
            'SKIP_1341': "SKIP_1341",
            'SKIP_1342': "SKIP_1342",
            'SKIP_1343': "SKIP_1343",
            'SKIP_1344': "SKIP_1344",
            'SKIP_1345': "SKIP_1345",
            'V1346_FILLET_ORDERING': "V1346_FILLET_ORDERING",
            'V1347_DEFAULT_ALLOW_FACES': "V1347_DEFAULT_ALLOW_FACES",
            'V1348_SM_UNFOLD': "V1348_SM_UNFOLD",
            'V1349_DELETE_FACE_EDIT_LOGIC': "V1349_DELETE_FACE_EDIT_LOGIC",
            'SKIP_1350': "SKIP_1350",
            'SKIP_1351': "SKIP_1351",
            'SKIP_1352': "SKIP_1352",
            'SKIP_1353': "SKIP_1353",
            'SKIP_1354': "SKIP_1354",
            'SKIP_1355': "SKIP_1355",
            'SKIP_1356': "SKIP_1356",
            'SKIP_1357': "SKIP_1357",
            'SKIP_1358': "SKIP_1358",
            'V1359_TWEAK_FACE_DISAMBIGUATION': "V1359_TWEAK_FACE_DISAMBIGUATION",
            'V1360_SPLIT_BODY_DISAMBIGUATION': "V1360_SPLIT_BODY_DISAMBIGUATION",
            'V1361_PS_VERSION_33_0_171': "V1361_PS_VERSION_33_0_171",
            'V1362_SPLINE_THROUGH_EDGES': "V1362_SPLINE_THROUGH_EDGES",
            'V1363_SPLINE_THROUGH_EDGES_BUGFIXES': "V1363_SPLINE_THROUGH_EDGES_BUGFIXES",
            'V1364_SPLINE_THROUGH_EDGES_STRINGS': "V1364_SPLINE_THROUGH_EDGES_STRINGS",
            'SKIP_1365': "SKIP_1365",
            'SKIP_1366': "SKIP_1366",
            'SKIP_1367': "SKIP_1367",
            'SKIP_1368': "SKIP_1368",
            'SKIP_1369': "SKIP_1369",
            'SKIP_1370': "SKIP_1370",
            'V1371_SM_MOVE_FACE_SET_BACKS': "V1371_SM_MOVE_FACE_SET_BACKS",
            'V1372_USE_UV_ATT_CYL_BENDS': "V1372_USE_UV_ATT_CYL_BENDS",
            'V1373_CREATED_BY_FOR_PROPERTIES': "V1373_CREATED_BY_FOR_PROPERTIES",
            'V1374_FILLET_KEEP_EDGES': "V1374_FILLET_KEEP_EDGES",
            'V1375_FLIP_OTHER_DIRECTION': "V1375_FLIP_OTHER_DIRECTION",
            'V1376_FS_VERSION_BUMP': "V1376_FS_VERSION_BUMP",
            'V1377_PERIODIC_UNROLL': "V1377_PERIODIC_UNROLL",
            'V1378_EXPLODE_LINE_NOT_ON_EXPLODED_INSTANCE': "V1378_EXPLODE_LINE_NOT_ON_EXPLODED_INSTANCE",
            'SKIP_1379': "SKIP_1379",
            'SKIP_1380': "SKIP_1380",
            'SKIP_1381': "SKIP_1381",
            'SKIP_1382': "SKIP_1382",
            'SKIP_1383': "SKIP_1383",
            'SKIP_1384': "SKIP_1384",
            'SKIP_1385': "SKIP_1385",
            'V1386_FILLET_PROPAGATE_UNIFICATION': "V1386_FILLET_PROPAGATE_UNIFICATION",
            'V1387_FLAT_OPERATION_SP_CURVES': "V1387_FLAT_OPERATION_SP_CURVES",
            'V1388_VRFILLET_UPDATE': "V1388_VRFILLET_UPDATE",
            'V1389_SPLIT_BODY': "V1389_SPLIT_BODY",
            'SKIP_1390': "SKIP_1390",
            'SKIP_1391': "SKIP_1391",
            'SKIP_1392': "SKIP_1392",
            'SKIP_1393': "SKIP_1393",
            'SKIP_1394': "SKIP_1394",
            'SKIP_1395': "SKIP_1395",
            'SKIP_1396': "SKIP_1396",
            'SKIP_1397': "SKIP_1397",
            'SKIP_1398': "SKIP_1398",
            'SKIP_1399': "SKIP_1399",
            'V1400_IMPRINT_AS_INTERSECT': "V1400_IMPRINT_AS_INTERSECT",
            'V1401_DISAMBIGUATION': "V1401_DISAMBIGUATION",
            'V1402_FLAT_OP_ALIGNMENT': "V1402_FLAT_OP_ALIGNMENT",
            'V1403_BODY_NET': "V1403_BODY_NET",
            'SKIP_1404': "SKIP_1404",
            'SKIP_1405': "SKIP_1405",
            'SKIP_1406': "SKIP_1406",
            'SKIP_1407': "SKIP_1407",
            'SKIP_1408': "SKIP_1408",
            'SKIP_1409': "SKIP_1409",
            'SKIP_1410': "SKIP_1410",
            'SKIP_1411': "SKIP_1411",
            'SKIP_1412': "SKIP_1412",
            'SKIP_1413': "SKIP_1413",
            'V1414_LOFT_CONNECTORS': "V1414_LOFT_CONNECTORS",
            'V1415_CURVE_ON_FACE_RECORDS': "V1415_CURVE_ON_FACE_RECORDS",
            'V1416_EXTERNAL_DISAMBIGUATION': "V1416_EXTERNAL_DISAMBIGUATION",
            'V1417_IMPLIED_DETECT_ADJACENCY': "V1417_IMPLIED_DETECT_ADJACENCY",
            'V1418_CHERRYPICK_LOFTFIX': "V1418_CHERRYPICK_LOFTFIX",
            'V1419_FOCUS_INNER_QUERY_UIHINT': "V1419_FOCUS_INNER_QUERY_UIHINT",
            'V1420_LOFT_BLOCK_CONNECTIONS': "V1420_LOFT_BLOCK_CONNECTIONS",
            'SKIP_1421': "SKIP_1421",
            'SKIP_1422': "SKIP_1422",
            'SKIP_1423': "SKIP_1423",
            'SKIP_1424': "SKIP_1424",
            'SKIP_1425': "SKIP_1425",
            'SKIP_1426': "SKIP_1426",
            'SKIP_1427': "SKIP_1427",
            'V1428_PS_VERSION_33_0_229': "V1428_PS_VERSION_33_0_229",
            'V1429_DCM_VERSION_72_3_0': "V1429_DCM_VERSION_72_3_0",
            'V1430_REMOVE_TRANSIENT_BUILTINS': "V1430_REMOVE_TRANSIENT_BUILTINS",
            'V1431_ATTRIBUTES_THROUGH_DERIVED': "V1431_ATTRIBUTES_THROUGH_DERIVED",
            'SKIP_1432': "SKIP_1432",
            'SKIP_1433': "SKIP_1433",
            'SKIP_1434': "SKIP_1434",
            'SKIP_1435': "SKIP_1435",
            'SKIP_1436': "SKIP_1436",
            'SKIP_1437': "SKIP_1437",
            'SKIP_1438': "SKIP_1438",
            'SKIP_1439': "SKIP_1439",
            'SKIP_1440': "SKIP_1440",
            'V1441_WORKFLOW': "V1441_WORKFLOW",
            'V1442_SOURCE_MESH_DUPLICATE': "V1442_SOURCE_MESH_DUPLICATE",
            'V1443_LOFT_RESTORE_CONNECTIONS': "V1443_LOFT_RESTORE_CONNECTIONS",
            'V1444_BODY_NET_TRACKUNG': "V1444_BODY_NET_TRACKUNG",
            'V1445_IMPRINT_DISAMBIGUATION': "V1445_IMPRINT_DISAMBIGUATION",
            'V1446_LOFT_TRIM_PROFILES': "V1446_LOFT_TRIM_PROFILES",
            'V1447_LOFT_CONNECTIONS_BUGFIX': "V1447_LOFT_CONNECTIONS_BUGFIX",
            'SKIP_1448': "SKIP_1448",
            'SKIP_1449': "SKIP_1449",
            'SKIP_1450': "SKIP_1450",
            'SKIP_1451': "SKIP_1451",
            'SKIP_1452': "SKIP_1452",
            'SKIP_1453': "SKIP_1453",
            'SKIP_1454': "SKIP_1454",
            'SKIP_1455': "SKIP_1455",
            'SKIP_1456': "SKIP_1456",
            'V1457_SM_CLOSED_RELIEF_FALLBACK': "V1457_SM_CLOSED_RELIEF_FALLBACK",
            'V1458_REVERSE_ALL_EDGES': "V1458_REVERSE_ALL_EDGES",
            'SKIP_1459': "SKIP_1459",
            'SKIP_1460': "SKIP_1460",
            'SKIP_1461': "SKIP_1461",
            'SKIP_1462': "SKIP_1462",
            'SKIP_1463': "SKIP_1463",
            'SKIP_1464': "SKIP_1464",
            'SKIP_1465': "SKIP_1465",
            'SKIP_1466': "SKIP_1466",
            'SKIP_1467': "SKIP_1467",
            'SKIP_1468': "SKIP_1468",
            'V1469_FS_REGEX_UNARY_MINUS': "V1469_FS_REGEX_UNARY_MINUS",
            'V1470_LOFT_TANGENCY': "V1470_LOFT_TANGENCY",
            'V1471_PERIODIC_PARAMS_IN_INTERVAL': "V1471_PERIODIC_PARAMS_IN_INTERVAL",
            'V1472_FILL_VERTEX_MATCHING': "V1472_FILL_VERTEX_MATCHING",
            'SKIP_1473': "SKIP_1473",
            'SKIP_1474': "SKIP_1474",
            'SKIP_1475': "SKIP_1475",
            'SKIP_1476': "SKIP_1476",
            'SKIP_1477': "SKIP_1477",
            'SKIP_1478': "SKIP_1478",
            'SKIP_1479': "SKIP_1479",
            'SKIP_1480': "SKIP_1480",
            'SKIP_1481': "SKIP_1481",
            'V1482_DONT_COPY_SM_TOOLS': "V1482_DONT_COPY_SM_TOOLS",
            'V1483_EXPOSE_WORKFLOW_MODULES': "V1483_EXPOSE_WORKFLOW_MODULES",
            'SKIP_1484': "SKIP_1484",
            'SKIP_1485': "SKIP_1485",
            'SKIP_1486': "SKIP_1486",
            'SKIP_1487': "SKIP_1487",
            'SKIP_1488': "SKIP_1488",
            'SKIP_1489': "SKIP_1489",
            'SKIP_1490': "SKIP_1490",
            'SKIP_1491': "SKIP_1491",
            'SKIP_1492': "SKIP_1492",
            'V1493_QUERY_EXEC': "V1493_QUERY_EXEC",
            'V1494_FIX_METADATA_ENUM_VALUES': "V1494_FIX_METADATA_ENUM_VALUES",
            'SKIP_1495': "SKIP_1495",
            'SKIP_1496': "SKIP_1496",
            'SKIP_1497': "SKIP_1497",
            'SKIP_1498': "SKIP_1498",
            'SKIP_1499': "SKIP_1499",
            'SKIP_1500': "SKIP_1500",
            'SKIP_1501': "SKIP_1501",
            'SKIP_1502': "SKIP_1502",
            'SKIP_1503': "SKIP_1503",
            'V1504_PS_VERSION_33_1_200': "V1504_PS_VERSION_33_1_200",
            'V1505_LOFT_GUIDE_STABLE': "V1505_LOFT_GUIDE_STABLE",
            'V1506_SINGLE_FACE_IMPRINT': "V1506_SINGLE_FACE_IMPRINT",
            'V1507_FULL_ROUND_FILLET': "V1507_FULL_ROUND_FILLET",
            'V1508_FULL_ROUND_FILLET_BUGFIXES': "V1508_FULL_ROUND_FILLET_BUGFIXES",
            'V1509_FULL_ROUND_QLV_SPELLING': "V1509_FULL_ROUND_QLV_SPELLING",
            'V1510_FULL_ROUND_FILLET_BUGFIX_2': "V1510_FULL_ROUND_FILLET_BUGFIX_2",
            'V1511_FIX_WORKFLOW_PROPERTY_TYPES': "V1511_FIX_WORKFLOW_PROPERTY_TYPES",
            'SKIP_1512': "SKIP_1512",
            'SKIP_1513': "SKIP_1513",
            'SKIP_1514': "SKIP_1514",
            'SKIP_1515': "SKIP_1515",
            'SKIP_1516': "SKIP_1516",
            'SKIP_1517': "SKIP_1517",
            'V1518_SPLIT_BODY_USE_SIDE': "V1518_SPLIT_BODY_USE_SIDE",
            'V1519_INTERSECTION_EDGES': "V1519_INTERSECTION_EDGES",
            'V1520_VERSION_BUMP': "V1520_VERSION_BUMP",
            'V1521_WORKFLOW_VWU_SUPPORT': "V1521_WORKFLOW_VWU_SUPPORT",
            'SKIP_1522': "SKIP_1522",
            'SKIP_1523': "SKIP_1523",
            'SKIP_1524': "SKIP_1524",
            'SKIP_1525': "SKIP_1525",
            'SKIP_1526': "SKIP_1526",
            'SKIP_1527': "SKIP_1527",
            'SKIP_1528': "SKIP_1528",
            'SKIP_1529': "SKIP_1529",
            'SKIP_1530': "SKIP_1530",
            'V1531_SWITCH_CREATE_FITTED': "V1531_SWITCH_CREATE_FITTED",
            'V1532_CORRECT_Z_MID_COORDINATE': "V1532_CORRECT_Z_MID_COORDINATE",
            'V1533_CLEAR_SM_ATTRIBUTES': "V1533_CLEAR_SM_ATTRIBUTES",
            'V1534_NEW_EXTRUDE_SYMMETRIC': "V1534_NEW_EXTRUDE_SYMMETRIC",
            'V1535_EXTRUDE_REMOVE_SND_DIR_ENUMS': "V1535_EXTRUDE_REMOVE_SND_DIR_ENUMS",
            'V1536_RAYCAST_PER_BODY': "V1536_RAYCAST_PER_BODY",
            'V1537_REL_BUMP': "V1537_REL_BUMP",
            'V1538_SYM_CHANGE_BUMP': "V1538_SYM_CHANGE_BUMP",
            'V1539_HOLE_ERROR': "V1539_HOLE_ERROR",
            'V1540_SYM_CHKBX_CHANGE_BUMP': "V1540_SYM_CHKBX_CHANGE_BUMP",
            'SKIP_1541': "SKIP_1541",
            'SKIP_1542': "SKIP_1542",
            'SKIP_1543': "SKIP_1543",
            'SKIP_1544': "SKIP_1544",
            'SKIP_1545': "SKIP_1545",
            'SKIP_1546': "SKIP_1546",
            'V1547_CLEAR_SM_ATTRIBUTES': "V1547_CLEAR_SM_ATTRIBUTES",
            'V1548_OP_HOLE': "V1548_OP_HOLE",
            'V1549_HOLE_REVERT_BUMP': "V1549_HOLE_REVERT_BUMP",
            'SKIP_1550': "SKIP_1550",
            'SKIP_1551': "SKIP_1551",
            'SKIP_1552': "SKIP_1552",
            'SKIP_1553': "SKIP_1553",
            'SKIP_1554': "SKIP_1554",
            'SKIP_1555': "SKIP_1555",
            'SKIP_1556': "SKIP_1556",
            'SKIP_1557': "SKIP_1557",
            'SKIP_1558': "SKIP_1558",
            'V1559_LOFT_BUG_FIX': "V1559_LOFT_BUG_FIX",
            'V1560_STATUS_ON_THROW': "V1560_STATUS_ON_THROW",
            'SKIP_1561': "SKIP_1561",
            'SKIP_1562': "SKIP_1562",
            'SKIP_1563': "SKIP_1563",
            'SKIP_1564': "SKIP_1564",
            'SKIP_1565': "SKIP_1565",
            'SKIP_1566': "SKIP_1566",
            'SKIP_1567': "SKIP_1567",
            'SKIP_1568': "SKIP_1568",
            'SKIP_1569': "SKIP_1569",
            'SKIP_1570': "SKIP_1570",
            'V1571_LOFT_END_CONDITION_FIX': "V1571_LOFT_END_CONDITION_FIX",
            'V1572_DEPRECATE_GET_SUBFEATURE_ID': "V1572_DEPRECATE_GET_SUBFEATURE_ID",
            'V1573_ORIGINAL_SET_DISAMBIGUATION': "V1573_ORIGINAL_SET_DISAMBIGUATION",
            'V1574_WIRES_IN_SPLIT': "V1574_WIRES_IN_SPLIT",
            'V1575_RULED_SURFACE_VERSION_BUMP': "V1575_RULED_SURFACE_VERSION_BUMP",
            'V1576_RULED_SURFACE_INTERNAL_MODULE': "V1576_RULED_SURFACE_INTERNAL_MODULE",
            'SKIP_1577': "SKIP_1577",
            'SKIP_1578': "SKIP_1578",
            'SKIP_1579': "SKIP_1579",
            'SKIP_1580': "SKIP_1580",
            'SKIP_1581': "SKIP_1581",
            'SKIP_1582': "SKIP_1582",
            'SKIP_1583': "SKIP_1583",
            'SKIP_1584': "SKIP_1584",
            'V1585_HOLE_NEW_PIPELINE': "V1585_HOLE_NEW_PIPELINE",
            'V1586_PS_VERSION_34_0_135': "V1586_PS_VERSION_34_0_135",
            'V1587_MERGE_BACK_RULED_SURFACE': "V1587_MERGE_BACK_RULED_SURFACE",
            'V1588_RULED_SURFACE_VERSION_BUMP': "V1588_RULED_SURFACE_VERSION_BUMP",
            'V1589_RULED_SURFACE_136': "V1589_RULED_SURFACE_136",
            'SKIP_1590': "SKIP_1590",
            'SKIP_1591': "SKIP_1591",
            'SKIP_1592': "SKIP_1592",
            'SKIP_1593': "SKIP_1593",
            'SKIP_1594': "SKIP_1594",
            'SKIP_1595': "SKIP_1595",
            'SKIP_1596': "SKIP_1596",
            'V1597_COMPOUND_UNITS_BUMP': "V1597_COMPOUND_UNITS_BUMP",
            'V1598_SHEET_BODY_ALIGNED_SECTION_VIEW_FIX': "V1598_SHEET_BODY_ALIGNED_SECTION_VIEW_FIX",
            'V1599_SHEET_EXTEND_TRACKING': "V1599_SHEET_EXTEND_TRACKING",
            'V1600_COMPOUND_UNITS_BUMP': "V1600_COMPOUND_UNITS_BUMP",
            'V1601_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY': "V1601_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY",
            'V1602_TANGENT_PLANES_AT_EDGE_BUILTIN': "V1602_TANGENT_PLANES_AT_EDGE_BUILTIN",
            'V1603_LOFT_END_CONDITIONS_INNER_EDGE_FIX': "V1603_LOFT_END_CONDITIONS_INNER_EDGE_FIX",
            'V1604_ORIGINAL_IN_RANGE': "V1604_ORIGINAL_IN_RANGE",
            'V1605_RULED_SURFACE_BUMP': "V1605_RULED_SURFACE_BUMP",
            'SKIP_1606': "SKIP_1606",
            'SKIP_1607': "SKIP_1607",
            'SKIP_1608': "SKIP_1608",
            'SKIP_1609': "SKIP_1609",
            'SKIP_1610': "SKIP_1610",
            'SKIP_1611': "SKIP_1611",
            'SKIP_1612': "SKIP_1612",
            'SKIP_1613': "SKIP_1613",
            'SKIP_1614': "SKIP_1614",
            'V1615_PS_VERSION_34_0_176': "V1615_PS_VERSION_34_0_176",
            'V1616_FILTER_CONSTRUCTION_POINTS': "V1616_FILTER_CONSTRUCTION_POINTS",
            'V1617_HOLE_NEW_PIPELINE_2': "V1617_HOLE_NEW_PIPELINE_2",
            'V1618_ENLARGE_CROP_VIEW_BBOX': "V1618_ENLARGE_CROP_VIEW_BBOX",
            'SKIP_1619': "SKIP_1619",
            'SKIP_1620': "SKIP_1620",
            'SKIP_1621': "SKIP_1621",
            'SKIP_1622': "SKIP_1622",
            'SKIP_1623': "SKIP_1623",
            'SKIP_1624': "SKIP_1624",
            'SKIP_1625': "SKIP_1625",
            'SKIP_1626': "SKIP_1626",
            'SKIP_1627': "SKIP_1627",
            'SKIP_1628': "SKIP_1628",
            'V1629_LOFT_END_CONDITIONS_INNER_EDGE_FIX': "V1629_LOFT_END_CONDITIONS_INNER_EDGE_FIX",
            'V1630_RULED_SURFACE_PRECISE_ARC_LENGTH': "V1630_RULED_SURFACE_PRECISE_ARC_LENGTH",
            'V1631_COMPOUND_UNITS_ASSEMBLY_BUMP': "V1631_COMPOUND_UNITS_ASSEMBLY_BUMP",
            'V1632_NEW_FEATURE_SCOPE': "V1632_NEW_FEATURE_SCOPE",
            'V1633_CHORD_FILLET_BUMP': "V1633_CHORD_FILLET_BUMP",
            'V1634_ALIGNED_SECTION_BODY_MAP': "V1634_ALIGNED_SECTION_BODY_MAP",
            'SKIP_1635': "SKIP_1635",
            'SKIP_1636': "SKIP_1636",
            'SKIP_1637': "SKIP_1637",
            'SKIP_1638': "SKIP_1638",
            'SKIP_1639': "SKIP_1639",
            'SKIP_1640': "SKIP_1640",
            'SKIP_1641': "SKIP_1641",
            'SKIP_1642': "SKIP_1642",
            'V1643_CREATED_BY': "V1643_CREATED_BY",
            'V1644_SKETCH_ROLLBACK': "V1644_SKETCH_ROLLBACK",
            'V1645_VERSION_BUMP_TO_CAPTURE_V1634': "V1645_VERSION_BUMP_TO_CAPTURE_V1634",
            'V1646_VERSION_BUMP_FOR_CHAMFER_FIX': "V1646_VERSION_BUMP_FOR_CHAMFER_FIX",
            'V1647_TOLERANCE_BUMP': "V1647_TOLERANCE_BUMP",
            'V1648_LOFT_UV_BUMP': "V1648_LOFT_UV_BUMP",
            'V1649_ADD_THICKEN_DEFAULT_KEEP_TOOL': "V1649_ADD_THICKEN_DEFAULT_KEEP_TOOL",
            'V1650_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY': "V1650_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY",
            'V1651_MODIFY_COMPOSITE_BY_ROTATED_BODY': "V1651_MODIFY_COMPOSITE_BY_ROTATED_BODY",
            'V1652_UNUSED': "V1652_UNUSED",
            'V1653_UNUSED': "V1653_UNUSED",
            'V1654_UNUSED': "V1654_UNUSED",
            'V1655_UNUSED': "V1655_UNUSED",
            'V1656_EMPTY_DISAMBIGUATION_SET': "V1656_EMPTY_DISAMBIGUATION_SET",
            'V1657_BUMP_VERSION_TO_MODIFY_COMPOSITE': "V1657_BUMP_VERSION_TO_MODIFY_COMPOSITE",
            'V1658_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY': "V1658_MIGRATE_OLD_DOCS_TO_FILTER_HISTORY",
            'V1659_USE_ATTRIBUTE_QUERY_FOR_STANDARD_CONTENT': "V1659_USE_ATTRIBUTE_QUERY_FOR_STANDARD_CONTENT",
            'V1660_FIX_DRAWING_MICROVERSION_ELEMENT_TYPE': "V1660_FIX_DRAWING_MICROVERSION_ELEMENT_TYPE",
            'SKIP_1661': "SKIP_1661",
            'SKIP_1662': "SKIP_1662",
            'SKIP_1663': "SKIP_1663",
            'SKIP_1664': "SKIP_1664",
            'SKIP_1665': "SKIP_1665",
            'V1666_EMPTY_DISAMBIGUATION_SET': "V1666_EMPTY_DISAMBIGUATION_SET",
            'V1667_BUMP_VERSION_TO_SUPPORT_STANDARD_CONTENT': "V1667_BUMP_VERSION_TO_SUPPORT_STANDARD_CONTENT",
            'V1668_EDGE_TOPOLOGY': "V1668_EDGE_TOPOLOGY",
            'V1669_SPLIT_TRACKING': "V1669_SPLIT_TRACKING",
            'V1670_MODIFY_COMPOSITE_BEFORE_EXTRUDE_CUT': "V1670_MODIFY_COMPOSITE_BEFORE_EXTRUDE_CUT",
            'V1671_LOFT_REARRANGE': "V1671_LOFT_REARRANGE",
            'V1672_FIX_MV_CAUSE_ELEMENT_ASSOCIATION': "V1672_FIX_MV_CAUSE_ELEMENT_ASSOCIATION",
            'V1673_VARIABLE_FILLET_BUG_FIXES': "V1673_VARIABLE_FILLET_BUG_FIXES",
            'V1674_VERSION_BUMP_TO_SPLIT_SIDE_MANIPULATOR_FIX': "V1674_VERSION_BUMP_TO_SPLIT_SIDE_MANIPULATOR_FIX",
            'V1675_VERSION_BUMP_FOR_COMPUTED_PROPERTIES_DOC': "V1675_VERSION_BUMP_FOR_COMPUTED_PROPERTIES_DOC",
            'SKIP_1676': "SKIP_1676",
            'SKIP_1677': "SKIP_1677",
            'SKIP_1678': "SKIP_1678",
            'SKIP_1679': "SKIP_1679",
            'SKIP_1680': "SKIP_1680",
            'V1681_NEW_BRIDGING_CURVE': "V1681_NEW_BRIDGING_CURVE",
            'V1682_SPLIT_FACE_SIDES': "V1682_SPLIT_FACE_SIDES",
            'V1683_CLEAR_SM_ATTRIBUTE_BY_RECORD': "V1683_CLEAR_SM_ATTRIBUTE_BY_RECORD",
            'V1684_SM_RECORD_SWAP': "V1684_SM_RECORD_SWAP",
            'V1685_SPLIT_AUTO_MATCH': "V1685_SPLIT_AUTO_MATCH",
            'V1686_FACE_BLEND_WARNING': "V1686_FACE_BLEND_WARNING",
            'V1687_BODY_NET_START': "V1687_BODY_NET_START",
            'V1688_EXTRACT_SURFACE_BODY_PROCESSING': "V1688_EXTRACT_SURFACE_BODY_PROCESSING",
            'V1689_PS_VERSION_34_0_235': "V1689_PS_VERSION_34_0_235",
            'V1690_BRIDGING_CURVE_FIXES': "V1690_BRIDGING_CURVE_FIXES",
            'SKIP_1691': "SKIP_1691",
            'SKIP_1692': "SKIP_1692",
            'SKIP_1693': "SKIP_1693",
            'SKIP_1694': "SKIP_1694",
            'SKIP_1695': "SKIP_1695",
            'SKIP_1696': "SKIP_1696",
            'SKIP_1697': "SKIP_1697",
            'SKIP_1698': "SKIP_1698",
            'V1699_RESTRICT_LOFT_NORMAL_TO_PROFILE_FIX': "V1699_RESTRICT_LOFT_NORMAL_TO_PROFILE_FIX",
            'UNKNOWN': "UNKNOWN",
        },
    }

    validations = {
        ('import_set',): {
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'all_features': ([BTMFeature134],),  # noqa: E501
            'all_features_and_sub_features': ([BTMFeature134],),  # noqa: E501
            'bel_script_library_major_version': (int,),  # noqa: E501
            'bel_script_library_version': (str,),  # noqa: E501
            'bel_script_library_version_enum': (str,),  # noqa: E501
            'bt_type': (str,),  # noqa: E501
            'children': ([BTMNode19],),  # noqa: E501
            'configuration_data': (BTMConfigurationData1560,),  # noqa: E501
            'configured': (bool,),  # noqa: E501
            'deep_imports': ({str: ([BTImport],)},),  # noqa: E501
            'default_features': (BTDefaultFeatures119,),  # noqa: E501
            'default_units': (BTMUnitsDefault160,),  # noqa: E501
            'feature_imports': ({str: ([BTImport],)},),  # noqa: E501
            'first_rollback_index': (int,),  # noqa: E501
            'import_microversion': (str,),  # noqa: E501
            'import_set': ([BTPModuleId235],),  # noqa: E501
            'imports': ([BTMImport136],),  # noqa: E501
            'last_feature_before_roll_back': (BTMFeature134,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'node_id': (str,),  # noqa: E501
            'part_properties': (BTPartProperties293,),  # noqa: E501
            'path_to_cache': (BTCacheDataPath191,),  # noqa: E501
            'properties': (BTModelProperties1258,),  # noqa: E501
            'rollback_bar': (BTMRollback150,),  # noqa: E501
            'rolled_back_to_end': (bool,),  # noqa: E501
            'variable_studios': ([BTMVariableStudioReference2764],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'all_features': 'allFeatures',  # noqa: E501
        'all_features_and_sub_features': 'allFeaturesAndSubFeatures',  # noqa: E501
        'bel_script_library_major_version': 'belScriptLibraryMajorVersion',  # noqa: E501
        'bel_script_library_version': 'belScriptLibraryVersion',  # noqa: E501
        'bel_script_library_version_enum': 'belScriptLibraryVersionEnum',  # noqa: E501
        'bt_type': 'btType',  # noqa: E501
        'children': 'children',  # noqa: E501
        'configuration_data': 'configurationData',  # noqa: E501
        'configured': 'configured',  # noqa: E501
        'deep_imports': 'deepImports',  # noqa: E501
        'default_features': 'defaultFeatures',  # noqa: E501
        'default_units': 'defaultUnits',  # noqa: E501
        'feature_imports': 'featureImports',  # noqa: E501
        'first_rollback_index': 'firstRollbackIndex',  # noqa: E501
        'import_microversion': 'importMicroversion',  # noqa: E501
        'import_set': 'importSet',  # noqa: E501
        'imports': 'imports',  # noqa: E501
        'last_feature_before_roll_back': 'lastFeatureBeforeRollBack',  # noqa: E501
        'name': 'name',  # noqa: E501
        'node_id': 'nodeId',  # noqa: E501
        'part_properties': 'partProperties',  # noqa: E501
        'path_to_cache': 'pathToCache',  # noqa: E501
        'properties': 'properties',  # noqa: E501
        'rollback_bar': 'rollbackBar',  # noqa: E501
        'rolled_back_to_end': 'rolledBackToEnd',  # noqa: E501
        'variable_studios': 'variableStudios',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BTMModel141 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            all_features ([BTMFeature134]): [optional]  # noqa: E501
            all_features_and_sub_features ([BTMFeature134]): [optional]  # noqa: E501
            bel_script_library_major_version (int): [optional]  # noqa: E501
            bel_script_library_version (str): [optional]  # noqa: E501
            bel_script_library_version_enum (str): [optional]  # noqa: E501
            bt_type (str): [optional]  # noqa: E501
            children ([BTMNode19]): [optional]  # noqa: E501
            configuration_data (BTMConfigurationData1560): [optional]  # noqa: E501
            configured (bool): [optional]  # noqa: E501
            deep_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            default_features (BTDefaultFeatures119): [optional]  # noqa: E501
            default_units (BTMUnitsDefault160): [optional]  # noqa: E501
            feature_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            first_rollback_index (int): [optional]  # noqa: E501
            import_microversion (str): [optional]  # noqa: E501
            import_set ([BTPModuleId235]): [optional]  # noqa: E501
            imports ([BTMImport136]): [optional]  # noqa: E501
            last_feature_before_roll_back (BTMFeature134): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            part_properties (BTPartProperties293): [optional]  # noqa: E501
            path_to_cache (BTCacheDataPath191): [optional]  # noqa: E501
            properties (BTModelProperties1258): [optional]  # noqa: E501
            rollback_bar (BTMRollback150): [optional]  # noqa: E501
            rolled_back_to_end (bool): [optional]  # noqa: E501
            variable_studios ([BTMVariableStudioReference2764]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BTMModel141 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            all_features ([BTMFeature134]): [optional]  # noqa: E501
            all_features_and_sub_features ([BTMFeature134]): [optional]  # noqa: E501
            bel_script_library_major_version (int): [optional]  # noqa: E501
            bel_script_library_version (str): [optional]  # noqa: E501
            bel_script_library_version_enum (str): [optional]  # noqa: E501
            bt_type (str): [optional]  # noqa: E501
            children ([BTMNode19]): [optional]  # noqa: E501
            configuration_data (BTMConfigurationData1560): [optional]  # noqa: E501
            configured (bool): [optional]  # noqa: E501
            deep_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            default_features (BTDefaultFeatures119): [optional]  # noqa: E501
            default_units (BTMUnitsDefault160): [optional]  # noqa: E501
            feature_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            first_rollback_index (int): [optional]  # noqa: E501
            import_microversion (str): [optional]  # noqa: E501
            import_set ([BTPModuleId235]): [optional]  # noqa: E501
            imports ([BTMImport136]): [optional]  # noqa: E501
            last_feature_before_roll_back (BTMFeature134): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            part_properties (BTPartProperties293): [optional]  # noqa: E501
            path_to_cache (BTCacheDataPath191): [optional]  # noqa: E501
            properties (BTModelProperties1258): [optional]  # noqa: E501
            rollback_bar (BTMRollback150): [optional]  # noqa: E501
            rolled_back_to_end (bool): [optional]  # noqa: E501
            variable_studios ([BTMVariableStudioReference2764]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
