"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError


def lazy_import():
    from onshape_client.oas.model.bt_cache_data_path191 import BTCacheDataPath191
    from onshape_client.oas.model.bt_import import BTImport
    from onshape_client.oas.model.bt_lazily_parsed_feature_script import BTLazilyParsedFeatureScript
    from onshape_client.oas.model.bt_microversion_id366 import BTMicroversionId366
    from onshape_client.oas.model.btp_annotation231 import BTPAnnotation231
    from onshape_client.oas.model.btp_argument_declaration232 import BTPArgumentDeclaration232
    from onshape_client.oas.model.btp_builtin_identifier233 import BTPBuiltinIdentifier233
    from onshape_client.oas.model.btp_literal_map_entry257 import BTPLiteralMapEntry257
    from onshape_client.oas.model.btp_literal_number258 import BTPLiteralNumber258
    from onshape_client.oas.model.btp_module234 import BTPModule234
    from onshape_client.oas.model.btp_module234_all_of import BTPModule234AllOf
    from onshape_client.oas.model.btp_module_id235 import BTPModuleId235
    from onshape_client.oas.model.btp_name261 import BTPName261
    from onshape_client.oas.model.btp_node7 import BTPNode7
    from onshape_client.oas.model.btp_property_accessor23 import BTPPropertyAccessor23
    from onshape_client.oas.model.btp_space10 import BTPSpace10
    from onshape_client.oas.model.btp_statement269 import BTPStatement269
    from onshape_client.oas.model.btp_top_level_import285 import BTPTopLevelImport285
    from onshape_client.oas.model.btp_top_level_node286 import BTPTopLevelNode286
    from onshape_client.oas.model.btp_type_name290 import BTPTypeName290
    from onshape_client.oas.model.btpl_value249 import BTPLValue249
    globals()['BTCacheDataPath191'] = BTCacheDataPath191
    globals()['BTImport'] = BTImport
    globals()['BTLazilyParsedFeatureScript'] = BTLazilyParsedFeatureScript
    globals()['BTMicroversionId366'] = BTMicroversionId366
    globals()['BTPAnnotation231'] = BTPAnnotation231
    globals()['BTPArgumentDeclaration232'] = BTPArgumentDeclaration232
    globals()['BTPBuiltinIdentifier233'] = BTPBuiltinIdentifier233
    globals()['BTPLValue249'] = BTPLValue249
    globals()['BTPLiteralMapEntry257'] = BTPLiteralMapEntry257
    globals()['BTPLiteralNumber258'] = BTPLiteralNumber258
    globals()['BTPModule234'] = BTPModule234
    globals()['BTPModule234AllOf'] = BTPModule234AllOf
    globals()['BTPModuleId235'] = BTPModuleId235
    globals()['BTPName261'] = BTPName261
    globals()['BTPNode7'] = BTPNode7
    globals()['BTPPropertyAccessor23'] = BTPPropertyAccessor23
    globals()['BTPSpace10'] = BTPSpace10
    globals()['BTPStatement269'] = BTPStatement269
    globals()['BTPTopLevelImport285'] = BTPTopLevelImport285
    globals()['BTPTopLevelNode286'] = BTPTopLevelNode286
    globals()['BTPTypeName290'] = BTPTypeName290


class BTPModule234(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('documentation_type',): {
            'FUNCTION': "FUNCTION",
            'PREDICATE': "PREDICATE",
            'CONSTANT': "CONSTANT",
            'ENUM': "ENUM",
            'USER_TYPE': "USER_TYPE",
            'FEATURE_DEFINITION': "FEATURE_DEFINITION",
            'FILE_HEADER': "FILE_HEADER",
            'UNDOCUMENTABLE': "UNDOCUMENTABLE",
            'CONST_LAMBDA': "CONST_LAMBDA",
            'UNKNOWN': "UNKNOWN",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'bt_type': (str,),  # noqa: E501
            'deep_imports': ({str: ([BTImport],)},),  # noqa: E501
            'imports': ([BTPTopLevelImport285],),  # noqa: E501
            'is_blob': (bool,),  # noqa: E501
            'is_internal_module': (bool,),  # noqa: E501
            'may_have_implicit_imports': (bool,),  # noqa: E501
            'path_map': ({str: (BTMicroversionId366,)},),  # noqa: E501
            'path_to_cache': (BTCacheDataPath191,),  # noqa: E501
            'to_be_parsed': (BTLazilyParsedFeatureScript,),  # noqa: E501
            'top_level': ([BTPTopLevelNode286],),  # noqa: E501
            'version': (BTPLiteralNumber258,),  # noqa: E501
            'version_number': (int,),  # noqa: E501
            'atomic': (bool,),  # noqa: E501
            'documentation_type': (str,),  # noqa: E501
            'end_source_location': (int,),  # noqa: E501
            'node_id': (str,),  # noqa: E501
            'short_descriptor': (str,),  # noqa: E501
            'space_after': (BTPSpace10,),  # noqa: E501
            'space_before': (BTPSpace10,),  # noqa: E501
            'space_default': (bool,),  # noqa: E501
            'start_source_location': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        lazy_import()
        val = {
            'BTPAnnotation-231': BTPAnnotation231,
            'BTPArgumentDeclaration-232': BTPArgumentDeclaration232,
            'BTPBuiltinIdentifier-233': BTPBuiltinIdentifier233,
            'BTPLValue-249': BTPLValue249,
            'BTPLiteralMapEntry-257': BTPLiteralMapEntry257,
            'BTPModule-234': BTPModule234,
            'BTPModuleId-235': BTPModuleId235,
            'BTPName-261': BTPName261,
            'BTPPropertyAccessor-23': BTPPropertyAccessor23,
            'BTPStatement-269': BTPStatement269,
            'BTPTopLevelNode-286': BTPTopLevelNode286,
            'BTPTypeName-290': BTPTypeName290,
        }
        if not val:
            return None
        return {'bt_type': val}

    attribute_map = {
        'bt_type': 'btType',  # noqa: E501
        'deep_imports': 'deepImports',  # noqa: E501
        'imports': 'imports',  # noqa: E501
        'is_blob': 'isBlob',  # noqa: E501
        'is_internal_module': 'isInternalModule',  # noqa: E501
        'may_have_implicit_imports': 'mayHaveImplicitImports',  # noqa: E501
        'path_map': 'pathMap',  # noqa: E501
        'path_to_cache': 'pathToCache',  # noqa: E501
        'to_be_parsed': 'toBeParsed',  # noqa: E501
        'top_level': 'topLevel',  # noqa: E501
        'version': 'version',  # noqa: E501
        'version_number': 'versionNumber',  # noqa: E501
        'atomic': 'atomic',  # noqa: E501
        'documentation_type': 'documentationType',  # noqa: E501
        'end_source_location': 'endSourceLocation',  # noqa: E501
        'node_id': 'nodeId',  # noqa: E501
        'short_descriptor': 'shortDescriptor',  # noqa: E501
        'space_after': 'spaceAfter',  # noqa: E501
        'space_before': 'spaceBefore',  # noqa: E501
        'space_default': 'spaceDefault',  # noqa: E501
        'start_source_location': 'startSourceLocation',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """BTPModule234 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            deep_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            imports ([BTPTopLevelImport285]): [optional]  # noqa: E501
            is_blob (bool): [optional]  # noqa: E501
            is_internal_module (bool): [optional]  # noqa: E501
            may_have_implicit_imports (bool): [optional]  # noqa: E501
            path_map ({str: (BTMicroversionId366,)}): [optional]  # noqa: E501
            path_to_cache (BTCacheDataPath191): [optional]  # noqa: E501
            to_be_parsed (BTLazilyParsedFeatureScript): [optional]  # noqa: E501
            top_level ([BTPTopLevelNode286]): [optional]  # noqa: E501
            version (BTPLiteralNumber258): [optional]  # noqa: E501
            version_number (int): [optional]  # noqa: E501
            atomic (bool): [optional]  # noqa: E501
            documentation_type (str): [optional]  # noqa: E501
            end_source_location (int): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            short_descriptor (str): [optional]  # noqa: E501
            space_after (BTPSpace10): [optional]  # noqa: E501
            space_before (BTPSpace10): [optional]  # noqa: E501
            space_default (bool): [optional]  # noqa: E501
            start_source_location (int): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """BTPModule234 - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bt_type (str): [optional]  # noqa: E501
            deep_imports ({str: ([BTImport],)}): [optional]  # noqa: E501
            imports ([BTPTopLevelImport285]): [optional]  # noqa: E501
            is_blob (bool): [optional]  # noqa: E501
            is_internal_module (bool): [optional]  # noqa: E501
            may_have_implicit_imports (bool): [optional]  # noqa: E501
            path_map ({str: (BTMicroversionId366,)}): [optional]  # noqa: E501
            path_to_cache (BTCacheDataPath191): [optional]  # noqa: E501
            to_be_parsed (BTLazilyParsedFeatureScript): [optional]  # noqa: E501
            top_level ([BTPTopLevelNode286]): [optional]  # noqa: E501
            version (BTPLiteralNumber258): [optional]  # noqa: E501
            version_number (int): [optional]  # noqa: E501
            atomic (bool): [optional]  # noqa: E501
            documentation_type (str): [optional]  # noqa: E501
            end_source_location (int): [optional]  # noqa: E501
            node_id (str): [optional]  # noqa: E501
            short_descriptor (str): [optional]  # noqa: E501
            space_after (BTPSpace10): [optional]  # noqa: E501
            space_before (BTPSpace10): [optional]  # noqa: E501
            space_default (bool): [optional]  # noqa: E501
            start_source_location (int): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              BTPModule234AllOf,
              BTPNode7,
          ],
          'oneOf': [
          ],
        }
