"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.143.3263-a9e651bcae07
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from onshape_client.oas.exceptions import ApiAttributeError



class GlobalPermissionInfo(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'access_reports': (bool,),  # noqa: E501
            'admin_enterprise': (bool,),  # noqa: E501
            'allow_app_store_access': (bool,),  # noqa: E501
            'allow_public_documents_access': (bool,),  # noqa: E501
            'approve_releases': (bool,),  # noqa: E501
            'create_change_orders': (bool,),  # noqa: E501
            'create_change_requests': (bool,),  # noqa: E501
            'create_documents_in_root': (bool,),  # noqa: E501
            'create_project': (bool,),  # noqa: E501
            'create_releases': (bool,),  # noqa: E501
            'delete_permanently': (bool,),  # noqa: E501
            'manage_guest_users': (bool,),  # noqa: E501
            'manage_non_geometric_items': (bool,),  # noqa: E501
            'manage_rbac': (bool,),  # noqa: E501
            'manage_users': (bool,),  # noqa: E501
            'manage_workflows': (bool,),  # noqa: E501
            'share_for_anonymous_access': (bool,),  # noqa: E501
            'view_change_orders': (bool,),  # noqa: E501
            'view_change_requests': (bool,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'access_reports': 'accessReports',  # noqa: E501
        'admin_enterprise': 'adminEnterprise',  # noqa: E501
        'allow_app_store_access': 'allowAppStoreAccess',  # noqa: E501
        'allow_public_documents_access': 'allowPublicDocumentsAccess',  # noqa: E501
        'approve_releases': 'approveReleases',  # noqa: E501
        'create_change_orders': 'createChangeOrders',  # noqa: E501
        'create_change_requests': 'createChangeRequests',  # noqa: E501
        'create_documents_in_root': 'createDocumentsInRoot',  # noqa: E501
        'create_project': 'createProject',  # noqa: E501
        'create_releases': 'createReleases',  # noqa: E501
        'delete_permanently': 'deletePermanently',  # noqa: E501
        'manage_guest_users': 'manageGuestUsers',  # noqa: E501
        'manage_non_geometric_items': 'manageNonGeometricItems',  # noqa: E501
        'manage_rbac': 'manageRbac',  # noqa: E501
        'manage_users': 'manageUsers',  # noqa: E501
        'manage_workflows': 'manageWorkflows',  # noqa: E501
        'share_for_anonymous_access': 'shareForAnonymousAccess',  # noqa: E501
        'view_change_orders': 'viewChangeOrders',  # noqa: E501
        'view_change_requests': 'viewChangeRequests',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """GlobalPermissionInfo - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_reports (bool): [optional]  # noqa: E501
            admin_enterprise (bool): [optional]  # noqa: E501
            allow_app_store_access (bool): [optional]  # noqa: E501
            allow_public_documents_access (bool): [optional]  # noqa: E501
            approve_releases (bool): [optional]  # noqa: E501
            create_change_orders (bool): [optional]  # noqa: E501
            create_change_requests (bool): [optional]  # noqa: E501
            create_documents_in_root (bool): [optional]  # noqa: E501
            create_project (bool): [optional]  # noqa: E501
            create_releases (bool): [optional]  # noqa: E501
            delete_permanently (bool): [optional]  # noqa: E501
            manage_guest_users (bool): [optional]  # noqa: E501
            manage_non_geometric_items (bool): [optional]  # noqa: E501
            manage_rbac (bool): [optional]  # noqa: E501
            manage_users (bool): [optional]  # noqa: E501
            manage_workflows (bool): [optional]  # noqa: E501
            share_for_anonymous_access (bool): [optional]  # noqa: E501
            view_change_orders (bool): [optional]  # noqa: E501
            view_change_requests (bool): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """GlobalPermissionInfo - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_reports (bool): [optional]  # noqa: E501
            admin_enterprise (bool): [optional]  # noqa: E501
            allow_app_store_access (bool): [optional]  # noqa: E501
            allow_public_documents_access (bool): [optional]  # noqa: E501
            approve_releases (bool): [optional]  # noqa: E501
            create_change_orders (bool): [optional]  # noqa: E501
            create_change_requests (bool): [optional]  # noqa: E501
            create_documents_in_root (bool): [optional]  # noqa: E501
            create_project (bool): [optional]  # noqa: E501
            create_releases (bool): [optional]  # noqa: E501
            delete_permanently (bool): [optional]  # noqa: E501
            manage_guest_users (bool): [optional]  # noqa: E501
            manage_non_geometric_items (bool): [optional]  # noqa: E501
            manage_rbac (bool): [optional]  # noqa: E501
            manage_users (bool): [optional]  # noqa: E501
            manage_workflows (bool): [optional]  # noqa: E501
            share_for_anonymous_access (bool): [optional]  # noqa: E501
            view_change_orders (bool): [optional]  # noqa: E501
            view_change_requests (bool): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
