# coding: utf-8

"""
    Onshape REST API

    The Onshape REST API consumed by all client. # Authorization The simplest way to authorize and enable the **Try it out** functionality is to sign in to Onshape and use the current session. The **Authorize** button enables other authorization techniques. To ensure the current session isn't used when trying other authentication techniques, make sure to remove the Onshape cookie as per the instructions for your particular browser. Alternatively, a private or incognito window may be used. Here's [how to remove a specific cookie on Chrome](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site). - **Current Session** authorization is enabled by default if the browser is already signed in to [Onshape](/). - **OAuth2** authorization uses an Onshape OAuth2 app created on the [Onshape Developer Portal](https://dev-portal.onshape.com/oauthApps). The redirect URL field should include `https://cad.onshape.com/glassworks/explorer/oauth2-redirect.html`. - **API Key** authorization using basic authentication is also available. The keys can be generated in the [Onshape Developer Portal](https://dev-portal.onshape.com/keys). In the authentication dialog, enter the access key in the `Username` field, and enter the secret key in the `Password` field. Basic authentication should only be used during the development process since sharing API Keys provides the same level of access as a username and password.  # noqa: E501

    The version of the OpenAPI document: 1.148.5096-9e2122142227
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""

import re  # noqa: F401
import sys  # noqa: F401
import typing  # noqa: F401

from frozendict import frozendict  # noqa: F401

import decimal  # noqa: F401
from datetime import date, datetime  # noqa: F401
from frozendict import frozendict  # noqa: F401

from openapi_client.schemas import (  # noqa: F401
    AnyTypeSchema,
    ComposedSchema,
    DictSchema,
    ListSchema,
    StrSchema,
    IntSchema,
    Int32Schema,
    Int64Schema,
    Float32Schema,
    Float64Schema,
    NumberSchema,
    DateSchema,
    DateTimeSchema,
    DecimalSchema,
    BoolSchema,
    BinarySchema,
    NoneSchema,
    none_type,
    InstantiationMetadata,
    Unset,
    unset,
    ComposedBase,
    ListBase,
    DictBase,
    NoneBase,
    StrBase,
    IntBase,
    Int32Base,
    Int64Base,
    Float32Base,
    Float64Base,
    NumberBase,
    DateBase,
    DateTimeBase,
    BoolBase,
    BinaryBase,
    Schema,
    _SchemaValidator,
    _SchemaTypeChecker,
    _SchemaEnumMaker
)


class GlobalPermissionInfo(
    DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    accessReports = BoolSchema
    adminEnterprise = BoolSchema
    allowAppStoreAccess = BoolSchema
    allowPublicDocumentsAccess = BoolSchema
    approveReleases = BoolSchema
    createChangeOrders = BoolSchema
    createChangeRequests = BoolSchema
    createDocumentsInRoot = BoolSchema
    createProject = BoolSchema
    createReleases = BoolSchema
    deletePermanently = BoolSchema
    manageGuestUsers = BoolSchema
    manageNonGeometricItems = BoolSchema
    manageRbac = BoolSchema
    manageUsers = BoolSchema
    manageWorkflows = BoolSchema
    shareForAnonymousAccess = BoolSchema
    transferDocumentsFromEnterprise = BoolSchema
    viewChangeOrders = BoolSchema
    viewChangeRequests = BoolSchema


    def __new__(
        cls,
        *args: typing.Union[dict, frozendict, ],
        accessReports: typing.Union[accessReports, Unset] = unset,
        adminEnterprise: typing.Union[adminEnterprise, Unset] = unset,
        allowAppStoreAccess: typing.Union[allowAppStoreAccess, Unset] = unset,
        allowPublicDocumentsAccess: typing.Union[allowPublicDocumentsAccess, Unset] = unset,
        approveReleases: typing.Union[approveReleases, Unset] = unset,
        createChangeOrders: typing.Union[createChangeOrders, Unset] = unset,
        createChangeRequests: typing.Union[createChangeRequests, Unset] = unset,
        createDocumentsInRoot: typing.Union[createDocumentsInRoot, Unset] = unset,
        createProject: typing.Union[createProject, Unset] = unset,
        createReleases: typing.Union[createReleases, Unset] = unset,
        deletePermanently: typing.Union[deletePermanently, Unset] = unset,
        manageGuestUsers: typing.Union[manageGuestUsers, Unset] = unset,
        manageNonGeometricItems: typing.Union[manageNonGeometricItems, Unset] = unset,
        manageRbac: typing.Union[manageRbac, Unset] = unset,
        manageUsers: typing.Union[manageUsers, Unset] = unset,
        manageWorkflows: typing.Union[manageWorkflows, Unset] = unset,
        shareForAnonymousAccess: typing.Union[shareForAnonymousAccess, Unset] = unset,
        transferDocumentsFromEnterprise: typing.Union[transferDocumentsFromEnterprise, Unset] = unset,
        viewChangeOrders: typing.Union[viewChangeOrders, Unset] = unset,
        viewChangeRequests: typing.Union[viewChangeRequests, Unset] = unset,
        _instantiation_metadata: typing.Optional[InstantiationMetadata] = None,
        **kwargs: typing.Type[Schema],
    ) -> 'GlobalPermissionInfo':
        return super().__new__(
            cls,
            *args,
            accessReports=accessReports,
            adminEnterprise=adminEnterprise,
            allowAppStoreAccess=allowAppStoreAccess,
            allowPublicDocumentsAccess=allowPublicDocumentsAccess,
            approveReleases=approveReleases,
            createChangeOrders=createChangeOrders,
            createChangeRequests=createChangeRequests,
            createDocumentsInRoot=createDocumentsInRoot,
            createProject=createProject,
            createReleases=createReleases,
            deletePermanently=deletePermanently,
            manageGuestUsers=manageGuestUsers,
            manageNonGeometricItems=manageNonGeometricItems,
            manageRbac=manageRbac,
            manageUsers=manageUsers,
            manageWorkflows=manageWorkflows,
            shareForAnonymousAccess=shareForAnonymousAccess,
            transferDocumentsFromEnterprise=transferDocumentsFromEnterprise,
            viewChangeOrders=viewChangeOrders,
            viewChangeRequests=viewChangeRequests,
            _instantiation_metadata=_instantiation_metadata,
            **kwargs,
        )
